# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""
The `Kernel` module gathers all kernels available in the SHOGUN toolkit.
"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Kernel', [dirname(__file__)])
        except ImportError:
            import _Kernel
            return _Kernel
        if fp is not None:
            try:
                _mod = imp.load_module('_Kernel', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Kernel = swig_import_helper()
    del swig_import_helper
else:
    import _Kernel
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class ShogunException(_object):
    """Proxy of C++ shogun::ShogunException class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShogunException, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShogunException, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self, str) -> ShogunException"""
        this = _Kernel.new_ShogunException(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_ShogunException
    __del__ = lambda self : None;
    def get_exception_string(self):
        """get_exception_string(self) -> str"""
        return _Kernel.ShogunException_get_exception_string(self)

ShogunException_swigregister = _Kernel.ShogunException_swigregister
ShogunException_swigregister(ShogunException)

MSG_GCDEBUG = _Kernel.MSG_GCDEBUG
MSG_DEBUG = _Kernel.MSG_DEBUG
MSG_INFO = _Kernel.MSG_INFO
MSG_NOTICE = _Kernel.MSG_NOTICE
MSG_WARN = _Kernel.MSG_WARN
MSG_ERROR = _Kernel.MSG_ERROR
MSG_CRITICAL = _Kernel.MSG_CRITICAL
MSG_ALERT = _Kernel.MSG_ALERT
MSG_EMERGENCY = _Kernel.MSG_EMERGENCY
MSG_MESSAGEONLY = _Kernel.MSG_MESSAGEONLY
class IO(_object):
    """Proxy of C++ shogun::CIO class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IO, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IO, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IO
        __init__(self, orig) -> IO
        """
        this = _Kernel.new_IO(*args)
        try: self.this.append(this)
        except: self.this = this
    def set_loglevel(self, *args):
        """set_loglevel(self, level)"""
        return _Kernel.IO_set_loglevel(self, *args)

    def get_loglevel(self):
        """get_loglevel(self) -> EMessageType"""
        return _Kernel.IO_get_loglevel(self)

    def get_show_progress(self):
        """get_show_progress(self) -> bool"""
        return _Kernel.IO_get_show_progress(self)

    def get_show_file_and_line(self):
        """get_show_file_and_line(self) -> bool"""
        return _Kernel.IO_get_show_file_and_line(self)

    def get_syntax_highlight(self):
        """get_syntax_highlight(self) -> bool"""
        return _Kernel.IO_get_syntax_highlight(self)

    def message(self, *args):
        """message(self, prio, file, line, fmt, *args)"""
        return _Kernel.IO_message(self, *args)

    def progress(self, *args):
        """
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1)
        progress(self, current_val, min_val = 0.0, max_val = 1.0)
        progress(self, current_val, min_val = 0.0)
        progress(self, current_val)
        """
        return _Kernel.IO_progress(self, *args)

    def absolute_progress(self, *args):
        """
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1)
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0)
        absolute_progress(self, current_val, val, min_val = 0.0)
        absolute_progress(self, current_val, val)
        """
        return _Kernel.IO_absolute_progress(self, *args)

    def done(self):
        """done(self)"""
        return _Kernel.IO_done(self)

    def not_implemented(self, *args):
        """not_implemented(self, file, line)"""
        return _Kernel.IO_not_implemented(self, *args)

    def deprecated(self, *args):
        """deprecated(self, file, line)"""
        return _Kernel.IO_deprecated(self, *args)

    def buffered_message(self, *args):
        """buffered_message(self, prio, fmt, *args)"""
        return _Kernel.IO_buffered_message(self, *args)

    def skip_spaces(*args):
        """skip_spaces(str) -> str"""
        return _Kernel.IO_skip_spaces(*args)

    if _newclass:skip_spaces = staticmethod(skip_spaces)
    __swig_getmethods__["skip_spaces"] = lambda x: skip_spaces
    def skip_blanks(*args):
        """skip_blanks(str) -> str"""
        return _Kernel.IO_skip_blanks(*args)

    if _newclass:skip_blanks = staticmethod(skip_blanks)
    __swig_getmethods__["skip_blanks"] = lambda x: skip_blanks
    def get_target(self):
        """get_target(self) -> FILE"""
        return _Kernel.IO_get_target(self)

    def set_target(self, *args):
        """set_target(self, target)"""
        return _Kernel.IO_set_target(self, *args)

    def set_target_to_stderr(self):
        """set_target_to_stderr(self)"""
        return _Kernel.IO_set_target_to_stderr(self)

    def set_target_to_stdout(self):
        """set_target_to_stdout(self)"""
        return _Kernel.IO_set_target_to_stdout(self)

    def enable_progress(self):
        """enable_progress(self)"""
        return _Kernel.IO_enable_progress(self)

    def disable_progress(self):
        """disable_progress(self)"""
        return _Kernel.IO_disable_progress(self)

    def enable_file_and_line(self):
        """enable_file_and_line(self)"""
        return _Kernel.IO_enable_file_and_line(self)

    def disable_file_and_line(self):
        """disable_file_and_line(self)"""
        return _Kernel.IO_disable_file_and_line(self)

    def enable_syntax_highlighting(self):
        """enable_syntax_highlighting(self)"""
        return _Kernel.IO_enable_syntax_highlighting(self)

    def disable_syntax_highlighting(self):
        """disable_syntax_highlighting(self)"""
        return _Kernel.IO_disable_syntax_highlighting(self)

    def set_dirname(*args):
        """set_dirname(dirname)"""
        return _Kernel.IO_set_dirname(*args)

    if _newclass:set_dirname = staticmethod(set_dirname)
    __swig_getmethods__["set_dirname"] = lambda x: set_dirname
    def concat_filename(*args):
        """concat_filename(filename) -> str"""
        return _Kernel.IO_concat_filename(*args)

    if _newclass:concat_filename = staticmethod(concat_filename)
    __swig_getmethods__["concat_filename"] = lambda x: concat_filename
    def filter(*args):
        """filter(d) -> int"""
        return _Kernel.IO_filter(*args)

    if _newclass:filter = staticmethod(filter)
    __swig_getmethods__["filter"] = lambda x: filter
    def ref(self):
        """ref(self) ->  int"""
        return _Kernel.IO_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Kernel.IO_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Kernel.IO_unref(self)

    def get_name(self):
        """get_name(self) -> str"""
        return _Kernel.IO_get_name(self)

    __swig_destroy__ = _Kernel.delete_IO
    __del__ = lambda self : None;
IO_swigregister = _Kernel.IO_swigregister
IO_swigregister(IO)
cvar = _Kernel.cvar

def IO_skip_spaces(*args):
  """IO_skip_spaces(str) -> str"""
  return _Kernel.IO_skip_spaces(*args)

def IO_skip_blanks(*args):
  """IO_skip_blanks(str) -> str"""
  return _Kernel.IO_skip_blanks(*args)

def IO_set_dirname(*args):
  """IO_set_dirname(dirname)"""
  return _Kernel.IO_set_dirname(*args)

def IO_concat_filename(*args):
  """IO_concat_filename(filename) -> str"""
  return _Kernel.IO_concat_filename(*args)

def IO_filter(*args):
  """IO_filter(d) -> int"""
  return _Kernel.IO_filter(*args)

class SGObject(_object):
    """Proxy of C++ shogun::CSGObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SGObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SGObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_SGObject
    __del__ = lambda self : None;
    def ref(self):
        """ref(self) ->  int"""
        return _Kernel.SGObject_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Kernel.SGObject_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Kernel.SGObject_unref(self)

    def get_name(self):
        """get_name(self) -> str"""
        return _Kernel.SGObject_get_name(self)

    def set_io(self, *args):
        """set_io(self, io)"""
        return _Kernel.SGObject_set_io(self, *args)

    def get_io(self):
        """get_io(self) -> IO"""
        return _Kernel.SGObject_get_io(self)

    def set_parallel(self, *args):
        """set_parallel(self, parallel)"""
        return _Kernel.SGObject_set_parallel(self, *args)

    def get_parallel(self):
        """get_parallel(self) -> Parallel"""
        return _Kernel.SGObject_get_parallel(self)

    def set_version(self, *args):
        """set_version(self, version)"""
        return _Kernel.SGObject_set_version(self, *args)

    def get_version(self):
        """get_version(self) -> Version"""
        return _Kernel.SGObject_get_version(self)

    __swig_setmethods__["io"] = _Kernel.SGObject_io_set
    __swig_getmethods__["io"] = _Kernel.SGObject_io_get
    if _newclass:io = _swig_property(_Kernel.SGObject_io_get, _Kernel.SGObject_io_set)
    __swig_setmethods__["parallel"] = _Kernel.SGObject_parallel_set
    __swig_getmethods__["parallel"] = _Kernel.SGObject_parallel_get
    if _newclass:parallel = _swig_property(_Kernel.SGObject_parallel_get, _Kernel.SGObject_parallel_set)
    __swig_setmethods__["version"] = _Kernel.SGObject_version_set
    __swig_getmethods__["version"] = _Kernel.SGObject_version_get
    if _newclass:version = _swig_property(_Kernel.SGObject_version_get, _Kernel.SGObject_version_set)
SGObject_swigregister = _Kernel.SGObject_swigregister
SGObject_swigregister(SGObject)

class Version(_object):
    """Proxy of C++ shogun::CVersion class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Version, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Version, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> Version"""
        this = _Kernel.new_Version()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_Version
    __del__ = lambda self : None;
    def print_version():
        """print_version()"""
        return _Kernel.Version_print_version()

    if _newclass:print_version = staticmethod(print_version)
    __swig_getmethods__["print_version"] = lambda x: print_version
    def get_version_extra():
        """get_version_extra() -> str"""
        return _Kernel.Version_get_version_extra()

    if _newclass:get_version_extra = staticmethod(get_version_extra)
    __swig_getmethods__["get_version_extra"] = lambda x: get_version_extra
    def get_version_release():
        """get_version_release() -> str"""
        return _Kernel.Version_get_version_release()

    if _newclass:get_version_release = staticmethod(get_version_release)
    __swig_getmethods__["get_version_release"] = lambda x: get_version_release
    def get_version_revision():
        """get_version_revision() ->  int"""
        return _Kernel.Version_get_version_revision()

    if _newclass:get_version_revision = staticmethod(get_version_revision)
    __swig_getmethods__["get_version_revision"] = lambda x: get_version_revision
    def get_version_year():
        """get_version_year() ->  int"""
        return _Kernel.Version_get_version_year()

    if _newclass:get_version_year = staticmethod(get_version_year)
    __swig_getmethods__["get_version_year"] = lambda x: get_version_year
    def get_version_month():
        """get_version_month() ->  int"""
        return _Kernel.Version_get_version_month()

    if _newclass:get_version_month = staticmethod(get_version_month)
    __swig_getmethods__["get_version_month"] = lambda x: get_version_month
    def get_version_day():
        """get_version_day() ->  int"""
        return _Kernel.Version_get_version_day()

    if _newclass:get_version_day = staticmethod(get_version_day)
    __swig_getmethods__["get_version_day"] = lambda x: get_version_day
    def get_version_hour():
        """get_version_hour() ->  int"""
        return _Kernel.Version_get_version_hour()

    if _newclass:get_version_hour = staticmethod(get_version_hour)
    __swig_getmethods__["get_version_hour"] = lambda x: get_version_hour
    def get_version_minute():
        """get_version_minute() ->  int"""
        return _Kernel.Version_get_version_minute()

    if _newclass:get_version_minute = staticmethod(get_version_minute)
    __swig_getmethods__["get_version_minute"] = lambda x: get_version_minute
    def get_version_in_minutes():
        """get_version_in_minutes() -> int"""
        return _Kernel.Version_get_version_in_minutes()

    if _newclass:get_version_in_minutes = staticmethod(get_version_in_minutes)
    __swig_getmethods__["get_version_in_minutes"] = lambda x: get_version_in_minutes
    def ref(self):
        """ref(self) ->  int"""
        return _Kernel.Version_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Kernel.Version_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Kernel.Version_unref(self)

Version_swigregister = _Kernel.Version_swigregister
Version_swigregister(Version)

def Version_print_version():
  """Version_print_version()"""
  return _Kernel.Version_print_version()

def Version_get_version_extra():
  """Version_get_version_extra() -> str"""
  return _Kernel.Version_get_version_extra()

def Version_get_version_release():
  """Version_get_version_release() -> str"""
  return _Kernel.Version_get_version_release()

def Version_get_version_revision():
  """Version_get_version_revision() ->  int"""
  return _Kernel.Version_get_version_revision()

def Version_get_version_year():
  """Version_get_version_year() ->  int"""
  return _Kernel.Version_get_version_year()

def Version_get_version_month():
  """Version_get_version_month() ->  int"""
  return _Kernel.Version_get_version_month()

def Version_get_version_day():
  """Version_get_version_day() ->  int"""
  return _Kernel.Version_get_version_day()

def Version_get_version_hour():
  """Version_get_version_hour() ->  int"""
  return _Kernel.Version_get_version_hour()

def Version_get_version_minute():
  """Version_get_version_minute() ->  int"""
  return _Kernel.Version_get_version_minute()

def Version_get_version_in_minutes():
  """Version_get_version_in_minutes() -> int"""
  return _Kernel.Version_get_version_in_minutes()

class Parallel(_object):
    """Proxy of C++ shogun::CParallel class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parallel, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Parallel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Parallel
        __init__(self, orig) -> Parallel
        """
        this = _Kernel.new_Parallel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_Parallel
    __del__ = lambda self : None;
    def get_num_cpus(self):
        """get_num_cpus(self) ->  int"""
        return _Kernel.Parallel_get_num_cpus(self)

    def set_num_threads(self, *args):
        """set_num_threads(self, n)"""
        return _Kernel.Parallel_set_num_threads(self, *args)

    def get_num_threads(self):
        """get_num_threads(self) ->  int"""
        return _Kernel.Parallel_get_num_threads(self)

    def ref(self):
        """ref(self) ->  int"""
        return _Kernel.Parallel_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Kernel.Parallel_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Kernel.Parallel_unref(self)

Parallel_swigregister = _Kernel.Parallel_swigregister
Parallel_swigregister(Parallel)

class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self):
        """value(self) -> PyObject"""
        return _Kernel.SwigPyIterator_value(self)

    def incr(self, n = 1):
        """
        incr(self, n = 1) -> SwigPyIterator
        incr(self) -> SwigPyIterator
        """
        return _Kernel.SwigPyIterator_incr(self, n)

    def decr(self, n = 1):
        """
        decr(self, n = 1) -> SwigPyIterator
        decr(self) -> SwigPyIterator
        """
        return _Kernel.SwigPyIterator_decr(self, n)

    def distance(self, *args):
        """distance(self, x) -> ptrdiff_t"""
        return _Kernel.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(self, x) -> bool"""
        return _Kernel.SwigPyIterator_equal(self, *args)

    def copy(self):
        """copy(self) -> SwigPyIterator"""
        return _Kernel.SwigPyIterator_copy(self)

    def next(self):
        """next(self) -> PyObject"""
        return _Kernel.SwigPyIterator_next(self)

    def __next__(self):
        """__next__(self) -> PyObject"""
        return _Kernel.SwigPyIterator___next__(self)

    def previous(self):
        """previous(self) -> PyObject"""
        return _Kernel.SwigPyIterator_previous(self)

    def advance(self, *args):
        """advance(self, n) -> SwigPyIterator"""
        return _Kernel.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(self, x) -> bool"""
        return _Kernel.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(self, x) -> bool"""
        return _Kernel.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(self, n) -> SwigPyIterator"""
        return _Kernel.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(self, n) -> SwigPyIterator"""
        return _Kernel.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(self, n) -> SwigPyIterator"""
        return _Kernel.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(self, n) -> SwigPyIterator
        __sub__(self, x) -> ptrdiff_t
        """
        return _Kernel.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = _Kernel.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

class IntVector(_object):
    """Proxy of C++ std::vector<(int32_t)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Kernel.IntVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Kernel.IntVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Kernel.IntVector___bool__(self)

    def __len__(self):
        """__len__(self) -> std::vector<(int)>::size_type"""
        return _Kernel.IntVector___len__(self)

    def pop(self):
        """pop(self) -> std::vector<(int)>::value_type"""
        return _Kernel.IntVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> IntVector"""
        return _Kernel.IntVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Kernel.IntVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Kernel.IntVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Kernel.IntVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> IntVector
        __getitem__(self, i) -> std::vector<(int)>::value_type
        """
        return _Kernel.IntVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Kernel.IntVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Kernel.IntVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Kernel.IntVector_empty(self)

    def size(self):
        """size(self) -> std::vector<(int)>::size_type"""
        return _Kernel.IntVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Kernel.IntVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Kernel.IntVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> std::vector<(int)>::allocator_type"""
        return _Kernel.IntVector_get_allocator(self)

    def begin(self):
        """begin(self) -> std::vector<(int)>::const_iterator"""
        return _Kernel.IntVector_begin(self)

    def end(self):
        """end(self) -> std::vector<(int)>::const_iterator"""
        return _Kernel.IntVector_end(self)

    def rbegin(self):
        """rbegin(self) -> std::vector<(int)>::const_reverse_iterator"""
        return _Kernel.IntVector_rbegin(self)

    def rend(self):
        """rend(self) -> std::vector<(int)>::const_reverse_iterator"""
        return _Kernel.IntVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Kernel.IntVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> std::vector<(int)>::iterator
        erase(self, first, last) -> std::vector<(int)>::iterator
        """
        return _Kernel.IntVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> IntVector
        __init__(self, arg0) -> IntVector
        __init__(self, size) -> IntVector
        __init__(self, size, value) -> IntVector
        """
        this = _Kernel.new_IntVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Kernel.IntVector_push_back(self, *args)

    def front(self):
        """front(self) -> std::vector<(int)>::value_type"""
        return _Kernel.IntVector_front(self)

    def back(self):
        """back(self) -> std::vector<(int)>::value_type"""
        return _Kernel.IntVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Kernel.IntVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Kernel.IntVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> std::vector<(int)>::iterator
        insert(self, pos, n, x)
        """
        return _Kernel.IntVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Kernel.IntVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> std::vector<(int)>::size_type"""
        return _Kernel.IntVector_capacity(self)

    __swig_destroy__ = _Kernel.delete_IntVector
    __del__ = lambda self : None;
IntVector_swigregister = _Kernel.IntVector_swigregister
IntVector_swigregister(IntVector)

class DoubleVector(_object):
    """Proxy of C++ std::vector<(float64_t)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DoubleVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DoubleVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Kernel.DoubleVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Kernel.DoubleVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Kernel.DoubleVector___bool__(self)

    def __len__(self):
        """__len__(self) -> std::vector<(double)>::size_type"""
        return _Kernel.DoubleVector___len__(self)

    def pop(self):
        """pop(self) -> std::vector<(double)>::value_type"""
        return _Kernel.DoubleVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> DoubleVector"""
        return _Kernel.DoubleVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Kernel.DoubleVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Kernel.DoubleVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Kernel.DoubleVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> DoubleVector
        __getitem__(self, i) -> std::vector<(double)>::value_type
        """
        return _Kernel.DoubleVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Kernel.DoubleVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Kernel.DoubleVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Kernel.DoubleVector_empty(self)

    def size(self):
        """size(self) -> std::vector<(double)>::size_type"""
        return _Kernel.DoubleVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Kernel.DoubleVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Kernel.DoubleVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> std::vector<(double)>::allocator_type"""
        return _Kernel.DoubleVector_get_allocator(self)

    def begin(self):
        """begin(self) -> std::vector<(double)>::const_iterator"""
        return _Kernel.DoubleVector_begin(self)

    def end(self):
        """end(self) -> std::vector<(double)>::const_iterator"""
        return _Kernel.DoubleVector_end(self)

    def rbegin(self):
        """rbegin(self) -> std::vector<(double)>::const_reverse_iterator"""
        return _Kernel.DoubleVector_rbegin(self)

    def rend(self):
        """rend(self) -> std::vector<(double)>::const_reverse_iterator"""
        return _Kernel.DoubleVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Kernel.DoubleVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> std::vector<(double)>::iterator
        erase(self, first, last) -> std::vector<(double)>::iterator
        """
        return _Kernel.DoubleVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> DoubleVector
        __init__(self, arg0) -> DoubleVector
        __init__(self, size) -> DoubleVector
        __init__(self, size, value) -> DoubleVector
        """
        this = _Kernel.new_DoubleVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Kernel.DoubleVector_push_back(self, *args)

    def front(self):
        """front(self) -> std::vector<(double)>::value_type"""
        return _Kernel.DoubleVector_front(self)

    def back(self):
        """back(self) -> std::vector<(double)>::value_type"""
        return _Kernel.DoubleVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Kernel.DoubleVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Kernel.DoubleVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> std::vector<(double)>::iterator
        insert(self, pos, n, x)
        """
        return _Kernel.DoubleVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Kernel.DoubleVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> std::vector<(double)>::size_type"""
        return _Kernel.DoubleVector_capacity(self)

    __swig_destroy__ = _Kernel.delete_DoubleVector
    __del__ = lambda self : None;
DoubleVector_swigregister = _Kernel.DoubleVector_swigregister
DoubleVector_swigregister(DoubleVector)

class StringVector(_object):
    """Proxy of C++ std::vector<(std::string)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, StringVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Kernel.StringVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Kernel.StringVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Kernel.StringVector___bool__(self)

    def __len__(self):
        """__len__(self) -> size_type"""
        return _Kernel.StringVector___len__(self)

    def pop(self):
        """pop(self) -> value_type"""
        return _Kernel.StringVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> StringVector"""
        return _Kernel.StringVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Kernel.StringVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Kernel.StringVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Kernel.StringVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> StringVector
        __getitem__(self, i) -> value_type
        """
        return _Kernel.StringVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Kernel.StringVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Kernel.StringVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Kernel.StringVector_empty(self)

    def size(self):
        """size(self) -> size_type"""
        return _Kernel.StringVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Kernel.StringVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Kernel.StringVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> allocator_type"""
        return _Kernel.StringVector_get_allocator(self)

    def begin(self):
        """begin(self) -> const_iterator"""
        return _Kernel.StringVector_begin(self)

    def end(self):
        """end(self) -> const_iterator"""
        return _Kernel.StringVector_end(self)

    def rbegin(self):
        """rbegin(self) -> const_reverse_iterator"""
        return _Kernel.StringVector_rbegin(self)

    def rend(self):
        """rend(self) -> const_reverse_iterator"""
        return _Kernel.StringVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Kernel.StringVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> iterator
        erase(self, first, last) -> iterator
        """
        return _Kernel.StringVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> StringVector
        __init__(self, arg0) -> StringVector
        __init__(self, size) -> StringVector
        __init__(self, size, value) -> StringVector
        """
        this = _Kernel.new_StringVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Kernel.StringVector_push_back(self, *args)

    def front(self):
        """front(self) -> value_type"""
        return _Kernel.StringVector_front(self)

    def back(self):
        """back(self) -> value_type"""
        return _Kernel.StringVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Kernel.StringVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Kernel.StringVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> iterator
        insert(self, pos, n, x)
        """
        return _Kernel.StringVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Kernel.StringVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> size_type"""
        return _Kernel.StringVector_capacity(self)

    __swig_destroy__ = _Kernel.delete_StringVector
    __del__ = lambda self : None;
StringVector_swigregister = _Kernel.StringVector_swigregister
StringVector_swigregister(StringVector)

FASTBUTMEMHUNGRY = _Kernel.FASTBUTMEMHUNGRY
SLOWBUTMEMEFFICIENT = _Kernel.SLOWBUTMEMEFFICIENT
K_UNKNOWN = _Kernel.K_UNKNOWN
K_LINEAR = _Kernel.K_LINEAR
K_SPARSELINEAR = _Kernel.K_SPARSELINEAR
K_POLY = _Kernel.K_POLY
K_GAUSSIAN = _Kernel.K_GAUSSIAN
K_SPARSEGAUSSIAN = _Kernel.K_SPARSEGAUSSIAN
K_GAUSSIANSHIFT = _Kernel.K_GAUSSIANSHIFT
K_GAUSSIANMATCH = _Kernel.K_GAUSSIANMATCH
K_HISTOGRAM = _Kernel.K_HISTOGRAM
K_SALZBERG = _Kernel.K_SALZBERG
K_LOCALITYIMPROVED = _Kernel.K_LOCALITYIMPROVED
K_SIMPLELOCALITYIMPROVED = _Kernel.K_SIMPLELOCALITYIMPROVED
K_FIXEDDEGREE = _Kernel.K_FIXEDDEGREE
K_WEIGHTEDDEGREE = _Kernel.K_WEIGHTEDDEGREE
K_WEIGHTEDDEGREEPOS = _Kernel.K_WEIGHTEDDEGREEPOS
K_WEIGHTEDDEGREERBF = _Kernel.K_WEIGHTEDDEGREERBF
K_WEIGHTEDCOMMWORDSTRING = _Kernel.K_WEIGHTEDCOMMWORDSTRING
K_POLYMATCH = _Kernel.K_POLYMATCH
K_ALIGNMENT = _Kernel.K_ALIGNMENT
K_COMMWORDSTRING = _Kernel.K_COMMWORDSTRING
K_COMMULONGSTRING = _Kernel.K_COMMULONGSTRING
K_SPECTRUMMISMATCHRBF = _Kernel.K_SPECTRUMMISMATCHRBF
K_COMBINED = _Kernel.K_COMBINED
K_AUC = _Kernel.K_AUC
K_CUSTOM = _Kernel.K_CUSTOM
K_SIGMOID = _Kernel.K_SIGMOID
K_CHI2 = _Kernel.K_CHI2
K_DIAG = _Kernel.K_DIAG
K_CONST = _Kernel.K_CONST
K_DISTANCE = _Kernel.K_DISTANCE
K_LOCALALIGNMENT = _Kernel.K_LOCALALIGNMENT
K_PYRAMIDCHI2 = _Kernel.K_PYRAMIDCHI2
K_OLIGO = _Kernel.K_OLIGO
K_MATCHWORD = _Kernel.K_MATCHWORD
K_TPPK = _Kernel.K_TPPK
K_REGULATORYMODULES = _Kernel.K_REGULATORYMODULES
KP_NONE = _Kernel.KP_NONE
KP_LINADD = _Kernel.KP_LINADD
KP_KERNCOMBINATION = _Kernel.KP_KERNCOMBINATION
KP_BATCHEVALUATION = _Kernel.KP_BATCHEVALUATION
class Kernel(SGObject):
    """
    The Kernel base class.

    Non-mathematically spoken, a kernel is a function that given two input
    objects ${\\bf x}$ and ${\\bf x'}$ returns a score describing the
    similarity of the vectors. The score should be larger when the objects
    are more similar.

    It can be defined as

    \\[ k({\\bf x},{\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi$ maps the objects into some potentially high
    dimensional feature space.

    Apart from the input features, the base kernel takes only one argument
    (the size of the kernel cache) that is used to efficiently train
    kernel-machines like e.g. SVMs.

    In case you would like to define your own kernel, you only have to
    define a new compute() function (and the kernel name via get_name()
    and the kernel type get_kernel_type()). A good example to look at is
    the GaussianKernel.

    C++ includes: Kernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Kernel, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Kernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_Kernel
    __del__ = lambda self : None;
    def kernel(self, *args):
        """
        kernel(self, idx_a, idx_b) -> float

        get kernel function for lhs feature vector a and rhs feature vector b

        Parameters:
        -----------

        idx_a:  index of feature vector a

        idx_b:  index of feature vector b

        computed kernel function 
        """
        return _Kernel.Kernel_kernel(self, *args)

    def get_kernel_matrix(self):
        """
        get_kernel_matrix(self) -> numpy 2dim array of float

        get kernel matrix real

        Parameters:
        -----------

        m:  dimension m of matrix

        n:  dimension n of matrix

        target:  the kernel matrix

        the kernel matrix 
        """
        return _Kernel.Kernel_get_kernel_matrix(self)

    def init(self, *args):
        """
        init(self, lhs, rhs) -> bool

        initialize kernel e.g. setup lhs/rhs of kernel, precompute
        normalization constants etc. make sure to check that your kernel can
        deal with the supplied features (!)

        Parameters:
        -----------

        lhs:  features for left-hand side

        rhs:  features for right-hand side

        if init was successful 
        """
        return _Kernel.Kernel_init(self, *args)

    def set_normalizer(self, *args):
        """
        set_normalizer(self, normalizer) -> bool

        set the current kernel normalizer

        if successful 
        """
        return _Kernel.Kernel_set_normalizer(self, *args)

    def get_normalizer(self):
        """
        get_normalizer(self) -> KernelNormalizer

        obtain the current kernel normalizer

        the kernel normalizer 
        """
        return _Kernel.Kernel_get_normalizer(self)

    def init_normalizer(self):
        """
        init_normalizer(self) -> bool

        initialize the current kernel normalizer if init was successful 
        """
        return _Kernel.Kernel_init_normalizer(self)

    def cleanup(self):
        """
        cleanup(self)

        clean up your kernel

        base method only removes lhs and rhs overload to add further cleanup
        but make sure CKernel::cleanup() is called 
        """
        return _Kernel.Kernel_cleanup(self)

    def load(self, *args):
        """
        load(self, loader)

        load the kernel matrix

        Parameters:
        -----------

        loader:  File object via which to load data 
        """
        return _Kernel.Kernel_load(self, *args)

    def save(self, *args):
        """
        save(self, writer)

        save kernel matrix

        Parameters:
        -----------

        writer:  File object via which to save data 
        """
        return _Kernel.Kernel_save(self, *args)

    def get_lhs(self):
        """
        get_lhs(self) -> Features

        get left-hand side of features used in kernel

        features of left-hand side 
        """
        return _Kernel.Kernel_get_lhs(self)

    def get_rhs(self):
        """
        get_rhs(self) -> Features

        get right-hand side of features used in kernel

        features of right-hand side 
        """
        return _Kernel.Kernel_get_rhs(self)

    def get_num_vec_lhs(self):
        """
        get_num_vec_lhs(self) ->  int

        get number of vectors of lhs features

        number of vectors of left-hand side 
        """
        return _Kernel.Kernel_get_num_vec_lhs(self)

    def get_num_vec_rhs(self):
        """
        get_num_vec_rhs(self) ->  int

        get number of vectors of rhs features

        number of vectors of right-hand side 
        """
        return _Kernel.Kernel_get_num_vec_rhs(self)

    def has_features(self):
        """
        has_features(self) -> bool

        test whether features have been assigned to lhs and rhs

        true if features are assigned 
        """
        return _Kernel.Kernel_has_features(self)

    def lhs_equals_rhs(self):
        """
        lhs_equals_rhs(self) -> bool

        test whether features on lhs and rhs are the same

        true if features are the same 
        """
        return _Kernel.Kernel_lhs_equals_rhs(self)

    def remove_lhs_and_rhs(self):
        """
        remove_lhs_and_rhs(self)

        remove lhs and rhs from kernel 
        """
        return _Kernel.Kernel_remove_lhs_and_rhs(self)

    def remove_lhs(self):
        """
        remove_lhs(self)

        remove lhs from kernel 
        """
        return _Kernel.Kernel_remove_lhs(self)

    def remove_rhs(self):
        """
        remove_rhs(self)

        remove rhs from kernel 
        """
        return _Kernel.Kernel_remove_rhs(self)

    def get_kernel_type(self):
        """
        get_kernel_type(self) -> EKernelType

        return what type of kernel we are, e.g. Linear,Polynomial,
        Gaussian,...

        abstract base method

        kernel type 
        """
        return _Kernel.Kernel_get_kernel_type(self)

    def get_feature_type(self):
        """
        get_feature_type(self) -> EFeatureType

        return feature type the kernel can deal with

        abstract base method

        feature type 
        """
        return _Kernel.Kernel_get_feature_type(self)

    def get_feature_class(self):
        """
        get_feature_class(self) -> EFeatureClass

        return feature class the kernel can deal with

        abstract base method

        feature class 
        """
        return _Kernel.Kernel_get_feature_class(self)

    def set_cache_size(self, *args):
        """
        set_cache_size(self, size)

        set the size of the kernel cache

        Parameters:
        -----------

        size:  of kernel cache 
        """
        return _Kernel.Kernel_set_cache_size(self, *args)

    def get_cache_size(self):
        """
        get_cache_size(self) ->  int

        return the size of the kernel cache

        size of kernel cache 
        """
        return _Kernel.Kernel_get_cache_size(self)

    def list_kernel(self):
        """
        list_kernel(self)

        list kernel 
        """
        return _Kernel.Kernel_list_kernel(self)

    def has_property(self, *args):
        """
        has_property(self, p) -> bool

        check if kernel has given property

        Parameters:
        -----------

        p:  kernel property

        if kernel has given property 
        """
        return _Kernel.Kernel_has_property(self, *args)

    def clear_normal(self):
        """
        clear_normal(self)

        for optimizable kernels, i.e. kernels where the weight vector can be
        computed explicitly (if it fits into memory) 
        """
        return _Kernel.Kernel_clear_normal(self)

    def add_to_normal(self, *args):
        """
        add_to_normal(self, vector_idx, weight)

        add vector*factor to 'virtual' normal vector

        Parameters:
        -----------

        vector_idx:  index

        weight:  weight 
        """
        return _Kernel.Kernel_add_to_normal(self, *args)

    def get_optimization_type(self):
        """
        get_optimization_type(self) -> EOptimizationType

        get optimization type

        optimization type 
        """
        return _Kernel.Kernel_get_optimization_type(self)

    def set_optimization_type(self, *args):
        """
        set_optimization_type(self, t)

        set optimization type

        Parameters:
        -----------

        t:  optimization type to set 
        """
        return _Kernel.Kernel_set_optimization_type(self, *args)

    def get_is_initialized(self):
        """
        get_is_initialized(self) -> bool

        check if optimization is initialized

        if optimization is initialized 
        """
        return _Kernel.Kernel_get_is_initialized(self)

    def init_optimization(self, *args):
        """
        init_optimization(self, count, IDX, weights) -> bool

        initialize optimization

        Parameters:
        -----------

        count:  count

        IDX:  index

        weights:  weights

        if initializing was successful 
        """
        return _Kernel.Kernel_init_optimization(self, *args)

    def delete_optimization(self):
        """
        delete_optimization(self) -> bool

        delete optimization

        if deleting was successful 
        """
        return _Kernel.Kernel_delete_optimization(self)

    def init_optimization_svm(self, *args):
        """
        init_optimization_svm(self, svm) -> bool

        initialize optimization

        Parameters:
        -----------

        svm:  svm model

        if initializing was successful 
        """
        return _Kernel.Kernel_init_optimization_svm(self, *args)

    def compute_optimized(self, *args):
        """
        compute_optimized(self, vector_idx) -> float

        compute optimized

        Parameters:
        -----------

        vector_idx:  index to compute

        optimized value at given index 
        """
        return _Kernel.Kernel_compute_optimized(self, *args)

    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        computes output for a batch of examples in an optimized fashion
        (favorable if kernel supports it, i.e. has KP_BATCHEVALUATION. to the
        outputvector target (of length num_vec elements) the output for the
        examples enumerated in vec_idx are added. therefore make sure that it
        is initialized with ZERO. the following num_suppvec, IDX, alphas
        arguments are the number of support vectors, their indices and weights

        """
        return _Kernel.Kernel_compute_batch(self, *args)

    def get_combined_kernel_weight(self):
        """
        get_combined_kernel_weight(self) -> float

        get combined kernel weight

        combined kernel weight 
        """
        return _Kernel.Kernel_get_combined_kernel_weight(self)

    def set_combined_kernel_weight(self, *args):
        """
        set_combined_kernel_weight(self, nw)

        set combined kernel weight

        Parameters:
        -----------

        nw:  new combined kernel weight 
        """
        return _Kernel.Kernel_set_combined_kernel_weight(self, *args)

    def get_num_subkernels(self):
        """
        get_num_subkernels(self) ->  int

        get number of subkernels

        number of subkernels 
        """
        return _Kernel.Kernel_get_num_subkernels(self)

    def compute_by_subkernel(self, *args):
        """
        compute_by_subkernel(self, vector_idx, subkernel_contrib)

        compute by subkernel

        Parameters:
        -----------

        vector_idx:  index

        subkernel_contrib:  subkernel contribution 
        """
        return _Kernel.Kernel_compute_by_subkernel(self, *args)

    def get_subkernel_weights(self, *args):
        """
        get_subkernel_weights(self, num_weights) -> float

        get subkernel weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        subkernel weights 
        """
        return _Kernel.Kernel_get_subkernel_weights(self, *args)

    def set_subkernel_weights(self, *args):
        """
        set_subkernel_weights(self, weights)

        set subkernel weights

        Parameters:
        -----------

        weights:  subkernel weights

        num_weights:  number of weights 
        """
        return _Kernel.Kernel_set_subkernel_weights(self, *args)

Kernel_swigregister = _Kernel.Kernel_swigregister
Kernel_swigregister(Kernel)

class RealKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_RealKernel
    __del__ = lambda self : None;
RealKernel_swigregister = _Kernel.RealKernel_swigregister
RealKernel_swigregister(RealKernel)

class ShortRealKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_ShortRealKernel
    __del__ = lambda self : None;
ShortRealKernel_swigregister = _Kernel.ShortRealKernel_swigregister
ShortRealKernel_swigregister(ShortRealKernel)

class WordKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_WordKernel
    __del__ = lambda self : None;
WordKernel_swigregister = _Kernel.WordKernel_swigregister
WordKernel_swigregister(WordKernel)

class CharKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_CharKernel
    __del__ = lambda self : None;
CharKernel_swigregister = _Kernel.CharKernel_swigregister
CharKernel_swigregister(CharKernel)

class ByteKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ByteKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_ByteKernel
    __del__ = lambda self : None;
ByteKernel_swigregister = _Kernel.ByteKernel_swigregister
ByteKernel_swigregister(ByteKernel)

class IntKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_IntKernel
    __del__ = lambda self : None;
IntKernel_swigregister = _Kernel.IntKernel_swigregister
IntKernel_swigregister(IntKernel)

class ShortKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_ShortKernel
    __del__ = lambda self : None;
ShortKernel_swigregister = _Kernel.ShortKernel_swigregister
ShortKernel_swigregister(ShortKernel)

class UlongKernel(Kernel):
    """
    Template class SimpleKernel is the base class for kernels working on
    Simple features.

    CSimpleFeatures are dense Matrix like Features and Kernels operating
    on them all derive from this class (cf., e.g., CGaussianKernel)

    C++ includes: SimpleKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UlongKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UlongKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_UlongKernel
    __del__ = lambda self : None;
UlongKernel_swigregister = _Kernel.UlongKernel_swigregister
UlongKernel_swigregister(UlongKernel)

class SparseRealKernel(Kernel):
    """
    Template class SparseKernel, is the base class of kernels working on
    sparse features.

    See e.g. the CSparseGaussianKernel for an example.

    C++ includes: SparseKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseRealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_SparseRealKernel
    __del__ = lambda self : None;
SparseRealKernel_swigregister = _Kernel.SparseRealKernel_swigregister
SparseRealKernel_swigregister(SparseRealKernel)

class SparseWordKernel(Kernel):
    """
    Template class SparseKernel, is the base class of kernels working on
    sparse features.

    See e.g. the CSparseGaussianKernel for an example.

    C++ includes: SparseKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseWordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseWordKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_SparseWordKernel
    __del__ = lambda self : None;
SparseWordKernel_swigregister = _Kernel.SparseWordKernel_swigregister
SparseWordKernel_swigregister(SparseWordKernel)

class StringRealKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringRealKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringRealKernel
    __del__ = lambda self : None;
StringRealKernel_swigregister = _Kernel.StringRealKernel_swigregister
StringRealKernel_swigregister(StringRealKernel)

class StringWordKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringWordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringWordKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringWordKernel
    __del__ = lambda self : None;
StringWordKernel_swigregister = _Kernel.StringWordKernel_swigregister
StringWordKernel_swigregister(StringWordKernel)

class StringCharKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringCharKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringCharKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringCharKernel
    __del__ = lambda self : None;
StringCharKernel_swigregister = _Kernel.StringCharKernel_swigregister
StringCharKernel_swigregister(StringCharKernel)

class StringIntKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringIntKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringIntKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringIntKernel
    __del__ = lambda self : None;
StringIntKernel_swigregister = _Kernel.StringIntKernel_swigregister
StringIntKernel_swigregister(StringIntKernel)

class StringUlongKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringUlongKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringUlongKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringUlongKernel
    __del__ = lambda self : None;
StringUlongKernel_swigregister = _Kernel.StringUlongKernel_swigregister
StringUlongKernel_swigregister(StringUlongKernel)

class StringShortKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringShortKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringShortKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringShortKernel
    __del__ = lambda self : None;
StringShortKernel_swigregister = _Kernel.StringShortKernel_swigregister
StringShortKernel_swigregister(StringShortKernel)

class StringByteKernel(Kernel):
    """
    Template class StringKernel, is the base class of all String Kernels.

    For a (very complex) example see e.g. CWeightedDegreeStringKernel

    C++ includes: StringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringByteKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringByteKernel, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_StringByteKernel
    __del__ = lambda self : None;
StringByteKernel_swigregister = _Kernel.StringByteKernel_swigregister
StringByteKernel_swigregister(StringByteKernel)


def KernelNormalizerToMultitaskKernelNormalizer(*args):
  """KernelNormalizerToMultitaskKernelNormalizer(n) -> MultitaskKernelNormalizer"""
  return _Kernel.KernelNormalizerToMultitaskKernelNormalizer(*args)

def KernelNormalizerToMultitaskKernelTreeNormalizer(*args):
  """KernelNormalizerToMultitaskKernelTreeNormalizer(n) -> MultitaskKernelTreeNormalizer"""
  return _Kernel.KernelNormalizerToMultitaskKernelTreeNormalizer(*args)

def KernelNormalizerToMultitaskKernelMaskNormalizer(*args):
  """KernelNormalizerToMultitaskKernelMaskNormalizer(n) -> MultitaskKernelMaskNormalizer"""
  return _Kernel.KernelNormalizerToMultitaskKernelMaskNormalizer(*args)

def KernelNormalizerToMultitaskKernelMaskPairNormalizer(*args):
  """KernelNormalizerToMultitaskKernelMaskPairNormalizer(n) -> MultitaskKernelMaskPairNormalizer"""
  return _Kernel.KernelNormalizerToMultitaskKernelMaskPairNormalizer(*args)

def KernelNormalizerToMultitaskKernelPlifNormalizer(*args):
  """KernelNormalizerToMultitaskKernelPlifNormalizer(n) -> MultitaskKernelPlifNormalizer"""
  return _Kernel.KernelNormalizerToMultitaskKernelPlifNormalizer(*args)

def KernelToCombinedKernel(*args):
  """KernelToCombinedKernel(n) -> CombinedKernel"""
  return _Kernel.KernelToCombinedKernel(*args)
N_REGULAR = _Kernel.N_REGULAR
N_MULTITASK = _Kernel.N_MULTITASK
class KernelNormalizer(SGObject):
    """
    The class Kernel Normalizer defines a function to post-process kernel
    values.

    Formally it defines f(.,.,.)

    \\[ k'({\\bf x},{\\bf x'}) = f(k({\\bf x},{\\bf x'}),{\\bf
    x},{\\bf x'}) \\]

    examples for f(.,.,.) would be scaling with a constant

    \\[ f(k({\\bf x},{\\bf x'}), ., .)= \\frac{1}{c}\\cdot
    k({\\bf x},{\\bf x'}) \\]

    as can be found in class CAvgDiagKernelNormalizer, the identity (cf.
    CIdentityKernelNormalizer), dividing by the Square Root of the product
    of the diagonal elements which effectively normalizes the vectors in
    feature space to norm 1 (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{\\sqrt{k({\\bf x},{\\bf x})k({\\bf x'},{\\bf x'})}}
    \\]

    C++ includes: KernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, KernelNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_KernelNormalizer
    __del__ = lambda self : None;
    def init(self, *args):
        """
        init(self, k) -> bool

        initialization of the normalizer (if needed)

        Parameters:
        -----------

        k:  kernel 
        """
        return _Kernel.KernelNormalizer_init(self, *args)

    def normalize(self, *args):
        """
        normalize(self, value, idx_lhs, idx_rhs) -> float

        normalize the kernel value

        Parameters:
        -----------

        value:  kernel value

        idx_lhs:  index of left hand side vector

        idx_rhs:  index of right hand side vector 
        """
        return _Kernel.KernelNormalizer_normalize(self, *args)

    def normalize_lhs(self, *args):
        """
        normalize_lhs(self, value, idx_lhs) -> float

        normalize only the left hand side vector

        Parameters:
        -----------

        value:  value of a component of the left hand side feature vector

        idx_lhs:  index of left hand side vector 
        """
        return _Kernel.KernelNormalizer_normalize_lhs(self, *args)

    def normalize_rhs(self, *args):
        """
        normalize_rhs(self, value, idx_rhs) -> float

        normalize only the right hand side vector

        Parameters:
        -----------

        value:  value of a component of the right hand side feature vector

        idx_rhs:  index of right hand side vector 
        """
        return _Kernel.KernelNormalizer_normalize_rhs(self, *args)

    def get_normalizer_type(self):
        """
        get_normalizer_type(self) -> ENormalizerType

        getter for normalizer type 
        """
        return _Kernel.KernelNormalizer_get_normalizer_type(self)

    def set_normalizer_type(self, *args):
        """
        set_normalizer_type(self, type)

        setter for normalizer type

        Parameters:
        -----------

        type:  type of normalizer 
        """
        return _Kernel.KernelNormalizer_set_normalizer_type(self, *args)

KernelNormalizer_swigregister = _Kernel.KernelNormalizer_swigregister
KernelNormalizer_swigregister(KernelNormalizer)

class PyramidChi2(RealKernel):
    """
    Pyramid Kernel over Chi2 matched histograms.

    C++ includes: PyramidChi2.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PyramidChi2, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PyramidChi2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2) -> PyramidChi2
        __init__(self, l, r, size, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2) -> PyramidChi2

        constructor

        Parameters:
        -----------

        l:  features lhs convention: concatenated features along all cells,
        i.e. [feature for cell1, feature for cell2, ... feature for last cell]
        , the dimensionality of the base feature is equal to dividing the
        total feature length by the number ofcells

        r:  features rhs the same convention as for param l applies here

        size:  cache size

        num_cells2:  - the number of pyramid cells

        weights_foreach_cell2:  the vector of weights for each cell with which
        the Chi2 distance gets weighted

        width_computation_type2:  - 0 use the following parameter as fixed
        width, 1- use mean of inner distances in case 1 the value of parameter
        width is important!!!

        width2:  - in case of width_computation_type ==0 it is the width, in
        case of width_computation_type > 0 its value determines the how many
        random features are used for determining the width in case of
        width_computation_type > 0 set width2 <=1 to use all LEFT HAND SIDE
        features for width estimation 
        """
        this = _Kernel.new_PyramidChi2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_PyramidChi2
    __del__ = lambda self : None;
    def setparams_pychi2(self, *args):
        """
        setparams_pychi2(self, num_cells2, weights_foreach_cell2, width_computation_type2, 
            width2)

        sets parameters, see also constructor

        Parameters:
        -----------

        num_cells2:  - the number of pyramid cells

        weights_foreach_cell2:  the vector of weights for each cell with which
        the Chi2 distance gets weighted

        width_computation_type2:  - 0 use the following parameter as fixed
        width, 1- use mean of inner distances in cases 1 and 2 the value of
        parameter width is still important, see parameter width2

        width2:  - in case of width_computation_type ==0 it is the width, in
        case of width_computation_type > 0 its value determines the how many
        random features are used for determining the width in case of
        width_computation_type > 0 set width2 <=1 to use all LEFT HAND SIDE
        features for width estimation 
        """
        return _Kernel.PyramidChi2_setparams_pychi2(self, *args)

PyramidChi2_swigregister = _Kernel.PyramidChi2_swigregister
PyramidChi2_swigregister(PyramidChi2)

class AUCKernel(WordKernel):
    """
    The AUC kernel can be used to maximize the area under the receiver
    operator stracteristic curve (AUC) instead of margin in SVM training.

    It takes as argument a sub-kernel and Labels based on which number of
    positive labels times number of negative labels many ``virtual''
    examples are created that ensure that all positive examples get a
    higher score than all negative examples in training.

    C++ includes: AUCKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [WordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AUCKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [WordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AUCKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, subkernel) -> AUCKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        subkernel:  the subkernel 
        """
        this = _Kernel.new_AUCKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_AUCKernel
    __del__ = lambda self : None;
    def setup_auc_maximization(self, *args):
        """
        setup_auc_maximization(self, labels) -> CLabels

        initialize kernel based on current labeling and subkernel

        Parameters:
        -----------

        labels:  - current labeling

        new label object to be used together with this kernel in SVM training
        for AUC maximization 
        """
        return _Kernel.AUCKernel_setup_auc_maximization(self, *args)

AUCKernel_swigregister = _Kernel.AUCKernel_swigregister
AUCKernel_swigregister(AUCKernel)

class AvgDiagKernelNormalizer(KernelNormalizer):
    """
    Normalize the kernel by either a constant or the average value of the
    diagonal elements (depending on argument c of the constructor).

    In case c <= 0 compute scale as \\[ \\mbox{scale} =
    \\frac{1}{N}\\sum_{i=1}^N k(x_i,x_i) \\]

    otherwise use scale=c and normalize the kernel via

    \\[ k'(x,x')= \\frac{k(x,x')}{scale} \\]

    C++ includes: AvgDiagKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AvgDiagKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AvgDiagKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, c = 0.0): 
        """
        __init__(self, c = 0.0) -> AvgDiagKernelNormalizer
        __init__(self) -> AvgDiagKernelNormalizer

        constructor

        Parameters:
        -----------

        c:  scale parameter, if <= 0 scaling will be computed from the avg of
        the kernel diagonal elements 
        """
        this = _Kernel.new_AvgDiagKernelNormalizer(c)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_AvgDiagKernelNormalizer
    __del__ = lambda self : None;
AvgDiagKernelNormalizer_swigregister = _Kernel.AvgDiagKernelNormalizer_swigregister
AvgDiagKernelNormalizer_swigregister(AvgDiagKernelNormalizer)

class RidgeKernelNormalizer(KernelNormalizer):
    """
    Normalize the kernel by adding a constant term to its diagonal. This
    aids kernels to become positive definite (even though they are not -
    often caused by numerical problems).

    Formally,

    \\[ k'(x,x')= \\frac{k(x,x')}+ R\\cdot {\\bf E} \\]

    where E is a matrix with ones on the diagonal and R is the scalar
    ridge term. The ridge term R is computed as $R=r\\dot c$.

    Typically,

    r=1e-10 and c=0.0 will add mean(diag(K))*1e-10 to the diagonal

    r=0.1 and c=1 will add 0.1 to the diagonal

    In case c <= 0, c is compute as the mean of the kernel diagonal \\[
    \\mbox{c} = \\frac{1}{N}\\sum_{i=1}^N k(x_i,x_i) \\]

    C++ includes: RidgeKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RidgeKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RidgeKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, r = 1e-10, c = 0.0): 
        """
        __init__(self, r = 1e-10, c = 0.0) -> RidgeKernelNormalizer
        __init__(self, r = 1e-10) -> RidgeKernelNormalizer
        __init__(self) -> RidgeKernelNormalizer

        constructor

        Parameters:
        -----------

        r:  ridge parameter

        c:  scale parameter, if <= 0 scaling will be computed from the avg of
        the kernel diagonal elements

        the scalar r*c will be added to the kernel diagonal, typical use
        cases: r=1e-10 and c=0.0 will add mean(diag(K))*1e-10 to the diagonal

        r=0.1 and c=1 will add 0.1 to the diagonal 
        """
        this = _Kernel.new_RidgeKernelNormalizer(r, c)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_RidgeKernelNormalizer
    __del__ = lambda self : None;
RidgeKernelNormalizer_swigregister = _Kernel.RidgeKernelNormalizer_swigregister
RidgeKernelNormalizer_swigregister(RidgeKernelNormalizer)

class Chi2Kernel(RealKernel):
    """
    The Chi2 kernel operating on realvalued vectors computes the chi-
    squared distance between sets of histograms.

    It is a very useful distance in image recognition (used to detect
    objects).

    It is defined as \\[ k({\\bf x},({\\bf x'})=
    e^{-\\frac{1}{width}
    \\sum_{i=0}^{l}\\frac{(x_i-x'_i)^2}{(x_i+x'_i)}} \\]

    C++ includes: Chi2Kernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Chi2Kernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Chi2Kernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width) -> Chi2Kernel
        __init__(self, l, r, width, size) -> Chi2Kernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _Kernel.new_Chi2Kernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_Chi2Kernel
    __del__ = lambda self : None;
Chi2Kernel_swigregister = _Kernel.Chi2Kernel_swigregister
Chi2Kernel_swigregister(Chi2Kernel)

class CombinedKernel(Kernel):
    """
    The Combined kernel is used to combine a number of kernels into a
    single CombinedKernel object by linear combination.

    It keeps pointers to the added sub-kernels $k_m({\\bf x}, {\\bf
    x'})$ and for each sub-kernel - a kernel specific weight $\\beta_m$.

    It is especially useful to combine kernels working on different
    domains and to combine kernels looking at independent features and
    requires CCombinedFeatures to be used.

    It is defined as:

    \\[ k_{combined}({\\bf x}, {\\bf x'}) = \\sum_{m=1}^M
    \\beta_m k_m({\\bf x}, {\\bf x'}) \\]

    C++ includes: CombinedKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CombinedKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CombinedKernel, name)
    __repr__ = _swig_repr
    def __init__(self, size = 10, append_subkernel_weights = False): 
        """
        __init__(self, size = 10, append_subkernel_weights = False) -> CombinedKernel
        __init__(self, size = 10) -> CombinedKernel
        __init__(self) -> CombinedKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        append_subkernel_weights:  if subkernel weights shall be appended 
        """
        this = _Kernel.new_CombinedKernel(size, append_subkernel_weights)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_CombinedKernel
    __del__ = lambda self : None;
    def list_kernels(self):
        """
        list_kernels(self)

        list kernels 
        """
        return _Kernel.CombinedKernel_list_kernels(self)

    def get_first_kernel(self, *args):
        """
        get_first_kernel(self) -> Kernel
        get_first_kernel(self, current) -> Kernel

        get first kernel

        Parameters:
        -----------

        current:

        first kernel 
        """
        return _Kernel.CombinedKernel_get_first_kernel(self, *args)

    def get_kernel(self, *args):
        """
        get_kernel(self, idx) -> Kernel

        get kernel

        Parameters:
        -----------

        idx:  index of kernel

        kernel at index idx 
        """
        return _Kernel.CombinedKernel_get_kernel(self, *args)

    def get_last_kernel(self):
        """
        get_last_kernel(self) -> Kernel

        get last kernel

        last kernel 
        """
        return _Kernel.CombinedKernel_get_last_kernel(self)

    def get_next_kernel(self, *args):
        """
        get_next_kernel(self) -> Kernel
        get_next_kernel(self, current) -> Kernel

        get next kernel multi-thread safe

        Parameters:
        -----------

        current:

        next kernel 
        """
        return _Kernel.CombinedKernel_get_next_kernel(self, *args)

    def insert_kernel(self, *args):
        """
        insert_kernel(self, k) -> bool

        insert kernel

        Parameters:
        -----------

        k:  kernel

        if inserting was successful 
        """
        return _Kernel.CombinedKernel_insert_kernel(self, *args)

    def append_kernel(self, *args):
        """
        append_kernel(self, k) -> bool

        append kernel

        Parameters:
        -----------

        k:  kernel

        if appending was successful 
        """
        return _Kernel.CombinedKernel_append_kernel(self, *args)

    def delete_kernel(self):
        """
        delete_kernel(self) -> bool

        delete kernel

        if deleting was successful 
        """
        return _Kernel.CombinedKernel_delete_kernel(self)

    def get_append_subkernel_weights(self):
        """
        get_append_subkernel_weights(self) -> bool

        check if subkernel weights are appended

        if subkernel weigths are appended 
        """
        return _Kernel.CombinedKernel_get_append_subkernel_weights(self)

    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        computes output for a batch of examples in an optimized fashion
        (favorable if kernel supports it, i.e. has KP_BATCHEVALUATION. to the
        outputvector target (of length num_vec elements) the output for the
        examples enumerated in vec_idx are added. therefore make sure that it
        is initialized with ZERO. the following num_suppvec, IDX, alphas
        arguments are the number of support vectors, their indices and weights

        """
        return _Kernel.CombinedKernel_compute_batch(self, *args)

    def compute_optimized_kernel_helper(*args):
        """compute_optimized_kernel_helper(p) -> void"""
        return _Kernel.CombinedKernel_compute_optimized_kernel_helper(*args)

    if _newclass:compute_optimized_kernel_helper = staticmethod(compute_optimized_kernel_helper)
    __swig_getmethods__["compute_optimized_kernel_helper"] = lambda x: compute_optimized_kernel_helper
    def compute_kernel_helper(*args):
        """compute_kernel_helper(p) -> void"""
        return _Kernel.CombinedKernel_compute_kernel_helper(*args)

    if _newclass:compute_kernel_helper = staticmethod(compute_kernel_helper)
    __swig_getmethods__["compute_kernel_helper"] = lambda x: compute_kernel_helper
    def emulate_compute_batch(self, *args):
        """
        emulate_compute_batch(self, k, num_vec, vec_idx, target, num_suppvec, IDX, weights)

        emulates batch computation, via linadd optimization w^t x or even down
        to sum_i alpha_i K(x_i,x)

        Parameters:
        -----------

        k:  kernel

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        weights:  weights 
        """
        return _Kernel.CombinedKernel_emulate_compute_batch(self, *args)

    def get_subkernel_weights(self, *args):
        """
        get_subkernel_weights(self, num_weights) -> float
        get_subkernel_weights(self)

        get subkernel weights (swig compatible)

        Parameters:
        -----------

        weights:  subkernel weights

        num_weights:  number of weights 
        """
        return _Kernel.CombinedKernel_get_subkernel_weights(self, *args)

    def precompute_subkernels(self):
        """
        precompute_subkernels(self) -> bool

        precompute all sub-kernels 
        """
        return _Kernel.CombinedKernel_precompute_subkernels(self)

CombinedKernel_swigregister = _Kernel.CombinedKernel_swigregister
CombinedKernel_swigregister(CombinedKernel)

def CombinedKernel_compute_optimized_kernel_helper(*args):
  """CombinedKernel_compute_optimized_kernel_helper(p) -> void"""
  return _Kernel.CombinedKernel_compute_optimized_kernel_helper(*args)

def CombinedKernel_compute_kernel_helper(*args):
  """CombinedKernel_compute_kernel_helper(p) -> void"""
  return _Kernel.CombinedKernel_compute_kernel_helper(*args)

class CommUlongStringKernel(StringUlongKernel):
    """
    The CommUlongString kernel may be used to compute the spectrum kernel
    from strings that have been mapped into unsigned 64bit integers.

    These 64bit integers correspond to k-mers. To be applicable in this
    kernel they need to be sorted (e.g. via the SortUlongString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation enables spectrum kernels of order 8 for
    8bit alphabets (like binaries) and order 32 for 2-bit alphabets like
    DNA.

    For this kernel the linadd speedups are implemented (though there is
    room for improvement here when a whole set of sequences is ADDed)
    using sorted lists.

    C++ includes: CommUlongStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringUlongKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CommUlongStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringUlongKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CommUlongStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size = 10, use_sign = False) -> CommUlongStringKernel
        __init__(self, size = 10) -> CommUlongStringKernel
        __init__(self) -> CommUlongStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> CommUlongStringKernel
        __init__(self, l, r, use_sign = False) -> CommUlongStringKernel
        __init__(self, l, r) -> CommUlongStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _Kernel.new_CommUlongStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_CommUlongStringKernel
    __del__ = lambda self : None;
    def merge_dictionaries(self, *args):
        """
        merge_dictionaries(self, t, j, k, vec, dic, dic_weights, weight, vec_idx)

        merge dictionaries

        Parameters:
        -----------

        t:  t

        j:  j

        k:  k

        vec:  vector

        dic:  dictionary

        dic_weights:  dictionary weights

        weight:  weight

        vec_idx:  vector index 
        """
        return _Kernel.CommUlongStringKernel_merge_dictionaries(self, *args)

    def get_dictionary(self, *args):
        """
        get_dictionary(self, dsize, dict, dweights)

        get dictionary

        Parameters:
        -----------

        dsize:  dictionary size will be stored in here

        dict:  dictionary will be stored in here

        dweights:  dictionary weights will be stored in here 
        """
        return _Kernel.CommUlongStringKernel_get_dictionary(self, *args)

CommUlongStringKernel_swigregister = _Kernel.CommUlongStringKernel_swigregister
CommUlongStringKernel_swigregister(CommUlongStringKernel)

class CommWordStringKernel(StringWordKernel):
    """
    The CommWordString kernel may be used to compute the spectrum kernel
    from strings that have been mapped into unsigned 16bit integers.

    These 16bit integers correspond to k-mers. To applicable in this
    kernel they need to be sorted (e.g. via the SortWordString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation is especially tuned to small alphabets
    (like the 2-bit alphabet DNA), for which it enables spectrum kernels
    of order up to 8.

    For this kernel the linadd speedups are quite efficiently implemented
    using direct maps.

    C++ includes: CommWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CommWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CommWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, use_sign) -> CommWordStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> CommWordStringKernel
        __init__(self, l, r, use_sign = False) -> CommWordStringKernel
        __init__(self, l, r) -> CommWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _Kernel.new_CommWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_CommWordStringKernel
    __del__ = lambda self : None;
    def init_dictionary(self, *args):
        """
        init_dictionary(self, size) -> bool

        initialize dictionary

        Parameters:
        -----------

        size:  size 
        """
        return _Kernel.CommWordStringKernel_init_dictionary(self, *args)

    def get_dictionary(self, *args):
        """
        get_dictionary(self, dsize, dweights)

        get dictionary

        Parameters:
        -----------

        dsize:  dictionary size will be stored in here

        dweights:  dictionary weights will be stored in here 
        """
        return _Kernel.CommWordStringKernel_get_dictionary(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas, do_init = True) -> float
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas) -> float

        compute scoring

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        do_init:  if initialization shall be performed

        computed scores 
        """
        return _Kernel.CommWordStringKernel_compute_scoring(self, *args)

    def compute_consensus(self, *args):
        """
        compute_consensus(self, num_feat, num_suppvec, IDX, alphas) -> str

        compute consensus

        Parameters:
        -----------

        num_feat:  number of features

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        computed consensus 
        """
        return _Kernel.CommWordStringKernel_compute_consensus(self, *args)

    def set_use_dict_diagonal_optimization(self, *args):
        """
        set_use_dict_diagonal_optimization(self, flag)

        set_use_dict_diagonal_optimization

        Parameters:
        -----------

        flag:  enable diagonal optimization 
        """
        return _Kernel.CommWordStringKernel_set_use_dict_diagonal_optimization(self, *args)

    def get_use_dict_diagonal_optimization(self):
        """
        get_use_dict_diagonal_optimization(self) -> bool

        get.use.dict.diagonal.optimization

        true if diagonal optimization is on 
        """
        return _Kernel.CommWordStringKernel_get_use_dict_diagonal_optimization(self)

CommWordStringKernel_swigregister = _Kernel.CommWordStringKernel_swigregister
CommWordStringKernel_swigregister(CommWordStringKernel)

class ConstKernel(Kernel):
    """
    The Constant Kernel returns a constant for all elements.

    A ``kernel'' that simply returns a single constant, i.e. $k({\\bf
    x}, {\\bf x'})= c$

    C++ includes: ConstKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, c) -> ConstKernel
        __init__(self, l, r, c) -> ConstKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        c:  constant c 
        """
        this = _Kernel.new_ConstKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_ConstKernel
    __del__ = lambda self : None;
ConstKernel_swigregister = _Kernel.ConstKernel_swigregister
ConstKernel_swigregister(ConstKernel)

class CustomKernel(Kernel):
    """
    The Custom Kernel allows for custom user provided kernel matrices.

    For squared training matrices it allows to store only the upper
    triangle of the kernel to save memory: Full symmetric kernel matrices
    can be stored as is or can be internally converted into (or directly
    given in) upper triangle representation. Also note that values are
    stored as 32bit floats.

    C++ includes: CustomKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CustomKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CustomKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CustomKernel
        __init__(self, k) -> CustomKernel
        __init__(self, km) -> CustomKernel
        __init__(self, km) -> CustomKernel

        constructor

        sets full kernel matrix from full kernel matrix (from single precision
        floats)

        Parameters:
        -----------

        km:  kernel matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        this = _Kernel.new_CustomKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_CustomKernel
    __del__ = lambda self : None;
    def dummy_init(self, *args):
        """
        dummy_init(self, rows, cols) -> bool

        initialize kernel with dummy features

        Kernels always need feature objects assigned. As the custom kernel
        does not really require this it creates some magic dummy features that
        only know about the number of vectors

        Parameters:
        -----------

        rows:  features of left-hand side

        cols:  features of right-hand side

        if initializing was successful 
        """
        return _Kernel.CustomKernel_dummy_init(self, *args)

    def set_triangle_kernel_matrix_from_triangle(self, *args):
        """
        set_triangle_kernel_matrix_from_triangle(self, km) -> bool
        set_triangle_kernel_matrix_from_triangle(self, km) -> bool

        set kernel matrix (only elements from upper triangle) from elements of
        upper triangle (concat'd), including the main diagonal

        small variant for floats32's, triangle needs to have less than 2**32
        elements

        Parameters:
        -----------

        km:  kernel matrix

        len:  denotes the size of the array and should match
        len=cols*(cols+1)/2

        if setting was successful 
        """
        return _Kernel.CustomKernel_set_triangle_kernel_matrix_from_triangle(self, *args)

    def set_triangle_kernel_matrix_from_full(self, *args):
        """
        set_triangle_kernel_matrix_from_full(self, km) -> bool
        set_triangle_kernel_matrix_from_full(self, km) -> bool

        set kernel matrix (only elements from upper triangle) from squared
        matrix

        for float32's

        Parameters:
        -----------

        km:  kernel matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        return _Kernel.CustomKernel_set_triangle_kernel_matrix_from_full(self, *args)

    def set_full_kernel_matrix_from_full(self, *args):
        """
        set_full_kernel_matrix_from_full(self, km) -> bool
        set_full_kernel_matrix_from_full(self, km) -> bool

        set full kernel matrix from full kernel matrix

        for float32's

        Parameters:
        -----------

        km:  kernel matrix

        rows:  number of rows in matrix

        cols:  number of cols in matrix

        if setting was successful 
        """
        return _Kernel.CustomKernel_set_full_kernel_matrix_from_full(self, *args)

CustomKernel_swigregister = _Kernel.CustomKernel_swigregister
CustomKernel_swigregister(CustomKernel)

class DiagKernel(Kernel):
    """
    The Diagonal Kernel returns a constant for the diagonal and zero
    otherwise.

    A kernel that returns zero for all non-diagonal elements and a single
    constant otherwise, i.e. $k({\\bf x_i}, {\\bf x_j})=
    \\delta_{ij} c$

    C++ includes: DiagKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DiagKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DiagKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, diag = 1.0) -> DiagKernel
        __init__(self, size) -> DiagKernel
        __init__(self, l, r, diag = 1.0) -> DiagKernel
        __init__(self, l, r) -> DiagKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        diag:  diagonal 
        """
        this = _Kernel.new_DiagKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_DiagKernel
    __del__ = lambda self : None;
DiagKernel_swigregister = _Kernel.DiagKernel_swigregister
DiagKernel_swigregister(DiagKernel)

class DiceKernelNormalizer(KernelNormalizer):
    """
    DiceKernelNormalizer performs kernel normalization inspired by the
    Dice coefficient (seehttp://en.wikipedia.org/wiki/Dice's_coefficient).

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{2k({\\bf x},{\\bf
    x'})}{k({\\bf x},{\\bf x})+k({\\bf x'},{\\bf x'}} \\]

    C++ includes: DiceKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DiceKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DiceKernelNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_DiceKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _Kernel.DiceKernelNormalizer_alloc_and_compute_diag(self, *args)

DiceKernelNormalizer_swigregister = _Kernel.DiceKernelNormalizer_swigregister
DiceKernelNormalizer_swigregister(DiceKernelNormalizer)

class DistanceKernel(Kernel):
    """
    The Distance kernel takes a distance as input.

    It turns a distance into something kernel like by computing

    \\[ k({\\bf x}, {\\bf x'}) = e^{-\\frac{dist({\\bf x},
    {\\bf x'})}{width}} \\]

    C++ includes: DistanceKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [Kernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistanceKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [Kernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistanceKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, cache, width, dist) -> DistanceKernel
        __init__(self, l, r, width, dist) -> DistanceKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        dist:  distance 
        """
        this = _Kernel.new_DistanceKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_DistanceKernel
    __del__ = lambda self : None;
DistanceKernel_swigregister = _Kernel.DistanceKernel_swigregister
DistanceKernel_swigregister(DistanceKernel)

class FixedDegreeStringKernel(StringCharKernel):
    """
    The FixedDegree String kernel takes as input two strings of same size
    and counts the number of matches of length d.

    \\[ k({\\bf x}, {\\bf x'}) = \\sum_{i=0}^{l-d} I({\\bf
    x}_{i,i+1,\\dots,i+d-1} = {\\bf x'}_{i,i+1,\\dots,i+d-1}) \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: FixedDegreeStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FixedDegreeStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FixedDegreeStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, degree) -> FixedDegreeStringKernel
        __init__(self, l, r, degree) -> FixedDegreeStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  the degree 
        """
        this = _Kernel.new_FixedDegreeStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_FixedDegreeStringKernel
    __del__ = lambda self : None;
FixedDegreeStringKernel_swigregister = _Kernel.FixedDegreeStringKernel_swigregister
FixedDegreeStringKernel_swigregister(FixedDegreeStringKernel)

class GaussianKernel(RealKernel):
    """
    The well known Gaussian kernel (swiss army knife for SVMs) on dense
    real valued features.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: GaussianKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> GaussianKernel
        __init__(self, size, width) -> GaussianKernel
        __init__(self, l, r, width, size = 10) -> GaussianKernel
        __init__(self, l, r, width) -> GaussianKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _Kernel.new_GaussianKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_GaussianKernel
    __del__ = lambda self : None;
GaussianKernel_swigregister = _Kernel.GaussianKernel_swigregister
GaussianKernel_swigregister(GaussianKernel)

class GaussianShiftKernel(GaussianKernel):
    """
    An experimental kernel inspired by the
    WeightedDegreePositionStringKernel and the Gaussian kernel.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= \\exp(-\\frac{||{\\bf
    x}-{\\bf x'}||^2}{\\tau}) +
    \\sum_{s=1}^{S_{\\mathrm{max}}/S_{\\mathrm{step}}}
    \\frac{1}{2s} \\exp(-\\frac{||{\\bf x}_{[1:|{\\bf
    x}|-sS_{\\mathrm{step}}]}-{\\bf
    x'}_{[sS_{\\mathrm{step}}:|{\\bf x}|]}||^2}{\\tau}) +
    \\sum_{s=1}^{S_{max}/S_{step}} \\frac{1}{2s}
    \\exp(-\\frac{||{\\bf x}_{[sS_{\\mathrm{step}}:|{\\bf
    x}|]}-{\\bf x'}_{[1:|{\\bf
    x}|-sS_{\\mathrm{step}}]}||^2}{\\tau}) + \\]

    where $\\tau$ is the kernel width. The idea is to shift the
    dimensions of the input vectors against eachother.
    $S_{\\mathrm{step}}$ is the step size (parameter shift_step) of the
    shifts and $S_{\\mathrm{max}}$ (parameter max_shift) is the maximal
    shift.

    C++ includes: GaussianShiftKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [GaussianKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianShiftKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [GaussianKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianShiftKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width, max_shift, shift_step) -> GaussianShiftKernel
        __init__(self, l, r, width, max_shift, shift_step, size = 10) -> GaussianShiftKernel
        __init__(self, l, r, width, max_shift, shift_step) -> GaussianShiftKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        max_shift:  maximum shift

        shift_step:  shift step

        size:  cache size 
        """
        this = _Kernel.new_GaussianShiftKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_GaussianShiftKernel
    __del__ = lambda self : None;
GaussianShiftKernel_swigregister = _Kernel.GaussianShiftKernel_swigregister
GaussianShiftKernel_swigregister(GaussianShiftKernel)

class GaussianShortRealKernel(ShortRealKernel):
    """
    The well known Gaussian kernel (swiss army knife for SVMs) on dense
    short-real valued features.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: GaussianShortRealKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [ShortRealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianShortRealKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [ShortRealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianShortRealKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width) -> GaussianShortRealKernel
        __init__(self, l, r, width, size = 10) -> GaussianShortRealKernel
        __init__(self, l, r, width) -> GaussianShortRealKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        size:  cache size 
        """
        this = _Kernel.new_GaussianShortRealKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_GaussianShortRealKernel
    __del__ = lambda self : None;
GaussianShortRealKernel_swigregister = _Kernel.GaussianShortRealKernel_swigregister
GaussianShortRealKernel_swigregister(GaussianShortRealKernel)

class HistogramWordStringKernel(StringWordKernel):
    """
    The HistogramWordString computes the TOP kernel on inhomogeneous
    Markov Chains.

    C++ includes: HistogramWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HistogramWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HistogramWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, pie) -> HistogramWordStringKernel
        __init__(self, l, r, pie) -> HistogramWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        pie:  plugin estimate 
        """
        this = _Kernel.new_HistogramWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_HistogramWordStringKernel
    __del__ = lambda self : None;
HistogramWordStringKernel_swigregister = _Kernel.HistogramWordStringKernel_swigregister
HistogramWordStringKernel_swigregister(HistogramWordStringKernel)

class IdentityKernelNormalizer(KernelNormalizer):
    """
    Identity Kernel Normalization, i.e. no normalization is applied.

    C++ includes: IdentityKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IdentityKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IdentityKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> IdentityKernelNormalizer

        default constructor 
        """
        this = _Kernel.new_IdentityKernelNormalizer()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_IdentityKernelNormalizer
    __del__ = lambda self : None;
IdentityKernelNormalizer_swigregister = _Kernel.IdentityKernelNormalizer_swigregister
IdentityKernelNormalizer_swigregister(IdentityKernelNormalizer)

class LinearByteKernel(ByteKernel):
    """
    Computes the standard linear kernel on dense byte valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= {\\bf x}\\cdot {\\bf x'} \\]

    C++ includes: LinearByteKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [ByteKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearByteKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [ByteKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearByteKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearByteKernel
        __init__(self, l, r) -> LinearByteKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_LinearByteKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LinearByteKernel
    __del__ = lambda self : None;
LinearByteKernel_swigregister = _Kernel.LinearByteKernel_swigregister
LinearByteKernel_swigregister(LinearByteKernel)

class LinearKernel(RealKernel):
    """
    Computes the standard linear kernel on dense real valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= {\\bf x}\\cdot {\\bf x'} \\]

    C++ includes: LinearKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearKernel
        __init__(self, l, r) -> LinearKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_LinearKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LinearKernel
    __del__ = lambda self : None;
    def get_normal(self, *args):
        """
        get_normal(self, len) -> float

        get normal

        Parameters:
        -----------

        len:  where length of normal vector will be stored

        normal vector 
        """
        return _Kernel.LinearKernel_get_normal(self, *args)

    def get_w(self):
        """
        get_w(self)

        get normal vector (swig compatible)

        Parameters:
        -----------

        dst_w:  store w in this argument

        dst_dims:  dimension of w 
        """
        return _Kernel.LinearKernel_get_w(self)

    def set_w(self, *args):
        """
        set_w(self, src_w)

        set normal vector (swig compatible)

        Parameters:
        -----------

        src_w:  new w

        src_w_dim:  dimension of new w - must fit dim of lhs 
        """
        return _Kernel.LinearKernel_set_w(self, *args)

LinearKernel_swigregister = _Kernel.LinearKernel_swigregister
LinearKernel_swigregister(LinearKernel)

class LinearStringKernel(StringCharKernel):
    """
    Computes the standard linear kernel on dense str valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= \\frac{1}{scale}{\\bf x}\\cdot
    {\\bf x'} \\]

    Note: Basically the same as LinearByteKernel but on signed strs.

    C++ includes: LinearStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearStringKernel
        __init__(self, l, r) -> LinearStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_LinearStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LinearStringKernel
    __del__ = lambda self : None;
LinearStringKernel_swigregister = _Kernel.LinearStringKernel_swigregister
LinearStringKernel_swigregister(LinearStringKernel)

class LinearWordKernel(WordKernel):
    """
    Computes the standard linear kernel on dense word (2-byte) valued
    features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= \\frac{1}{scale}{\\bf x}\\cdot
    {\\bf x'} \\]

    C++ includes: LinearWordKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [WordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearWordKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [WordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearWordKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearWordKernel
        __init__(self, l, r) -> LinearWordKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_LinearWordKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LinearWordKernel
    __del__ = lambda self : None;
LinearWordKernel_swigregister = _Kernel.LinearWordKernel_swigregister
LinearWordKernel_swigregister(LinearWordKernel)

LOGSUM_TBL = _Kernel.LOGSUM_TBL
class LocalAlignmentStringKernel(StringCharKernel):
    """
    The LocalAlignmentString kernel compares two sequences through all
    possible local alignments between the two sequences.

    The implementation is taken fromhttp://www.mloss.org/software/view/40/
    and only adjusted to work with shogun.

    C++ includes: LocalAlignmentStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalAlignmentStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalAlignmentStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size) -> LocalAlignmentStringKernel
        __init__(self, l, r) -> LocalAlignmentStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_LocalAlignmentStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LocalAlignmentStringKernel
    __del__ = lambda self : None;
LocalAlignmentStringKernel_swigregister = _Kernel.LocalAlignmentStringKernel_swigregister
LocalAlignmentStringKernel_swigregister(LocalAlignmentStringKernel)

class LocalityImprovedStringKernel(StringCharKernel):
    """
    The LocalityImprovedString kernel is inspired by the polynomial
    kernel. Comparing neighboring stracters it puts emphasize on local
    features.

    It can be defined as \\[ K({\\bf x},{\\bf
    x'})=\\left(\\sum_{i=0}^{T-1}\\left(\\sum_{j=-l}^{+l}w_jI_{i+j}({\\bf
    x},{\\bf x'})\\right)^{d_1}\\right)^{d_2}, \\] where $
    I_i({\\bf x},{\\bf x'})=1$ if $x_i=x'_i$ and 0 otherwise.

    C++ includes: LocalityImprovedStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalityImprovedStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalityImprovedStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, length, inner_degree, outer_degree) -> LocalityImprovedStringKernel
        __init__(self, l, r, length, inner_degree, outer_degree) -> LocalityImprovedStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        length:  length

        inner_degree:  inner degree

        outer_degree:  outer degree 
        """
        this = _Kernel.new_LocalityImprovedStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_LocalityImprovedStringKernel
    __del__ = lambda self : None;
LocalityImprovedStringKernel_swigregister = _Kernel.LocalityImprovedStringKernel_swigregister
LocalityImprovedStringKernel_swigregister(LocalityImprovedStringKernel)

class MatchWordStringKernel(StringWordKernel):
    """
    The class MatchWordStringKernel computes a variant of the polynomial
    kernel on strings of same length converted to a word alphabet.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= \\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: MatchWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MatchWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MatchWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, d) -> MatchWordStringKernel
        __init__(self, l, r, degree) -> MatchWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _Kernel.new_MatchWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_MatchWordStringKernel
    __del__ = lambda self : None;
MatchWordStringKernel_swigregister = _Kernel.MatchWordStringKernel_swigregister
MatchWordStringKernel_swigregister(MatchWordStringKernel)

class MultitaskKernelNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    This effectively normalizes the vectors in feature space to norm 1
    (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\gamma(task({\\bf
    x}),task({\\bf x'})) k({\\bf x},{\\bf x'}) \\]

    C++ includes: MultitaskKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelNormalizer
        __init__(self, task_lhs, task_rhs) -> MultitaskKernelNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side 
        """
        this = _Kernel.new_MultitaskKernelNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_MultitaskKernelNormalizer
    __del__ = lambda self : None;
    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> IntVector

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _Kernel.MultitaskKernelNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> IntVector

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _Kernel.MultitaskKernelNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelNormalizer_set_task_vector(self, *args)

    def get_task_similarity(self, *args):
        """
        get_task_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _Kernel.MultitaskKernelNormalizer_get_task_similarity(self, *args)

    def set_task_similarity(self, *args):
        """
        set_task_similarity(self, task_lhs, task_rhs, similarity)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity:  similarity between tasks 
        """
        return _Kernel.MultitaskKernelNormalizer_set_task_similarity(self, *args)

MultitaskKernelNormalizer_swigregister = _Kernel.MultitaskKernelNormalizer_swigregister
MultitaskKernelNormalizer_swigregister(MultitaskKernelNormalizer)

class MultitaskKernelMklNormalizer(KernelNormalizer):
    """
    Base-class for parameterized Kernel Normalizers.

    C++ includes: MultitaskKernelMklNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMklNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMklNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def get_beta(self, *args):
        """
        get_beta(self, idx) -> float

        Parameters:

        idx:  index of MKL weight to get 
        """
        return _Kernel.MultitaskKernelMklNormalizer_get_beta(self, *args)

    def set_beta(self, *args):
        """
        set_beta(self, idx, weight)

        Parameters:

        idx:  index of MKL weight to set

        weight:  MKL weight to set 
        """
        return _Kernel.MultitaskKernelMklNormalizer_set_beta(self, *args)

    def get_num_betas(self):
        """
        get_num_betas(self) ->  int

        number of sub-kernel weights for MKL 
        """
        return _Kernel.MultitaskKernelMklNormalizer_get_num_betas(self)

    __swig_destroy__ = _Kernel.delete_MultitaskKernelMklNormalizer
    __del__ = lambda self : None;
MultitaskKernelMklNormalizer_swigregister = _Kernel.MultitaskKernelMklNormalizer_swigregister
MultitaskKernelMklNormalizer_swigregister(MultitaskKernelMklNormalizer)

class CNode(SGObject):
    """
    A CNode is an element of a CTaxonomy, which is used to describe
    hierarchical structure between tasks.

    C++ includes: MultitaskKernelTreeNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CNode, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CNode, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> CNode

        default constructor 
        """
        this = _Kernel.new_CNode()
        try: self.this.append(this)
        except: self.this = this
    def get_path_root(self):
        """
        get_path_root(self) -> std::set<(p.shogun::CNode)>

        get a list of all ancestors of this node set of CNodes 
        """
        return _Kernel.CNode_get_path_root(self)

    def get_task_ids_below(self):
        """
        get_task_ids_below(self) -> IntVector

        get a list of task ids at the leaves below the current node list of
        task ids 
        """
        return _Kernel.CNode_get_task_ids_below(self)

    def add_child(self, *args):
        """
        add_child(self, node)

        add child to current node

        Parameters:
        -----------

        node:  child node 
        """
        return _Kernel.CNode_add_child(self, *args)

    def is_leaf(self):
        """
        is_leaf(self) -> bool

        boolean indicating, whether this node is a leaf 
        """
        return _Kernel.CNode_is_leaf(self)

    def getNode_id(self):
        """
        getNode_id(self) ->  int

        node id of current node 
        """
        return _Kernel.CNode_getNode_id(self)

    def setNode_id(self, *args):
        """
        setNode_id(self, node_idx)

        Parameters:

        node_idx:  node id for current node 
        """
        return _Kernel.CNode_setNode_id(self, *args)

    __swig_setmethods__["beta"] = _Kernel.CNode_beta_set
    __swig_getmethods__["beta"] = _Kernel.CNode_beta_get
    if _newclass:beta = _swig_property(_Kernel.CNode_beta_get, _Kernel.CNode_beta_set)
    __swig_destroy__ = _Kernel.delete_CNode
    __del__ = lambda self : None;
CNode_swigregister = _Kernel.CNode_swigregister
CNode_swigregister(CNode)

class CTaxonomy(SGObject):
    """
    CTaxonomy is used to describe hierarchical structure between tasks.

    C++ includes: MultitaskKernelTreeNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CTaxonomy, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CTaxonomy, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> CTaxonomy

        default constructor 
        """
        this = _Kernel.new_CTaxonomy()
        try: self.this.append(this)
        except: self.this = this
    def get_node(self, *args):
        """
        get_node(self, task_id) -> CNode

        Parameters:

        task_id:  task identifier

        node with id task_id 
        """
        return _Kernel.CTaxonomy_get_node(self, *args)

    def set_root_beta(self, *args):
        """
        set_root_beta(self, beta)

        set root weight

        Parameters:
        -----------

        beta:  weight 
        """
        return _Kernel.CTaxonomy_set_root_beta(self, *args)

    def add_node(self, *args):
        """
        add_node(self, parent_name, child_name, beta) -> CNode

        inserts additional node into taxonomy

        Parameters:
        -----------

        parent_name:  name of parent

        child_name:  name of child

        beta:  weight of child 
        """
        return _Kernel.CTaxonomy_add_node(self, *args)

    def get_id(self, *args):
        """
        get_id(self, name) ->  int

        translates name to id

        Parameters:
        -----------

        name:  name of task

        id 
        """
        return _Kernel.CTaxonomy_get_id(self, *args)

    def intersect_root_path(self, *args):
        """
        intersect_root_path(self, node_lhs, node_rhs) -> std::set<(p.shogun::CNode)>

        given two nodes, compute the intersection of their ancestors

        Parameters:
        -----------

        node_lhs:  node of left hand side

        node_rhs:  node of right hand side

        intersection of the two sets of ancestors 
        """
        return _Kernel.CTaxonomy_intersect_root_path(self, *args)

    def compute_node_similarity(self, *args):
        """
        compute_node_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _Kernel.CTaxonomy_compute_node_similarity(self, *args)

    def update_task_histogram(self, *args):
        """
        update_task_histogram(self, task_vector_lhs)

        keep track of how many elements each task has

        Parameters:
        -----------

        task_vector_lhs:  vector of task ids for examples 
        """
        return _Kernel.CTaxonomy_update_task_histogram(self, *args)

    def get_num_nodes(self):
        """
        get_num_nodes(self) ->  int

        number of nodes 
        """
        return _Kernel.CTaxonomy_get_num_nodes(self)

    def get_num_leaves(self):
        """
        get_num_leaves(self) ->  int

        number of leaves 
        """
        return _Kernel.CTaxonomy_get_num_leaves(self)

    def get_node_weight(self, *args):
        """
        get_node_weight(self, idx) -> float

        weight of node with identifier idx 
        """
        return _Kernel.CTaxonomy_get_node_weight(self, *args)

    def set_node_weight(self, *args):
        """
        set_node_weight(self, idx, weight)

        Parameters:

        idx:  node id

        weight:  weight to set 
        """
        return _Kernel.CTaxonomy_set_node_weight(self, *args)

    def get_name2id(self):
        """
        get_name2id(self) -> std::map<(std::string,int32_t,std::less<(std::string)>,std::allocator<(std::pair<(q(const).std::string,int32_t)>)>)>

        mapping from name to id 
        """
        return _Kernel.CTaxonomy_get_name2id(self)

    def get_id_by_name(self, *args):
        """
        get_id_by_name(self, name) ->  int

        translate name to id

        Parameters:
        -----------

        name:  node name

        id 
        """
        return _Kernel.CTaxonomy_get_id_by_name(self, *args)

    __swig_destroy__ = _Kernel.delete_CTaxonomy
    __del__ = lambda self : None;
CTaxonomy_swigregister = _Kernel.CTaxonomy_swigregister
CTaxonomy_swigregister(CTaxonomy)

class MultitaskKernelTreeNormalizer(MultitaskKernelMklNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function based on taxonomy.

    C++ includes: MultitaskKernelTreeNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelTreeNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelTreeNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelTreeNormalizer
        __init__(self, task_lhs, task_rhs, tax) -> MultitaskKernelTreeNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side

        tax:  taxonomy 
        """
        this = _Kernel.new_MultitaskKernelTreeNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_MultitaskKernelTreeNormalizer
    __del__ = lambda self : None;
    def update_cache(self):
        """
        update_cache(self)

        update cache 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_update_cache(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_set_task_vector_lhs(self, *args)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_set_task_vector(self, *args)

    def get_node_similarity(self, *args):
        """
        get_node_similarity(self, node_lhs, node_rhs) -> float

        Parameters:

        node_lhs:  node_id on left hand side

        node_rhs:  node_id on right hand side

        similarity between nodes 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_get_node_similarity(self, *args)

    def set_node_similarity(self, *args):
        """
        set_node_similarity(self, node_lhs, node_rhs, similarity)

        Parameters:

        node_lhs:  node_id on left hand side

        node_rhs:  node_id on right hand side

        similarity:  similarity between nodes 
        """
        return _Kernel.MultitaskKernelTreeNormalizer_set_node_similarity(self, *args)

MultitaskKernelTreeNormalizer_swigregister = _Kernel.MultitaskKernelTreeNormalizer_swigregister
MultitaskKernelTreeNormalizer_swigregister(MultitaskKernelTreeNormalizer)

class MultitaskKernelMaskNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    The user defines a set of active tasks. Subsequently, only
    similarities between active tasks are taken into account. Kernel
    entries between tasks of which at least one is not an active tasks are
    set to zero.

    \\[ K_S(x,y)=\\left\\{\\begin{array}{cl} K_B(x,y), &
    \\mbox{if } t(x) \\in S \\wedge t(y) \\in S\\\\ 0, &
    \\mbox{else} \\end{array}\\right. \\]

    C++ includes: MultitaskKernelMaskNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMaskNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMaskNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelMaskNormalizer
        __init__(self, task_lhs, task_rhs, active_tasks_vec) -> MultitaskKernelMaskNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side 
        """
        this = _Kernel.new_MultitaskKernelMaskNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_MultitaskKernelMaskNormalizer
    __del__ = lambda self : None;
    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> IntVector

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> IntVector

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_set_task_vector(self, *args)

    def get_similarity(self, *args):
        """
        get_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_get_similarity(self, *args)

    def get_active_tasks(self):
        """
        get_active_tasks(self) -> IntVector

        list of active task ids 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_get_active_tasks(self)

    def get_normalization_constant(self):
        """
        get_normalization_constant(self) -> float

        normalization constant 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_get_normalization_constant(self)

    def set_normalization_constant(self, *args):
        """
        set_normalization_constant(self, constant) -> float

        Parameters:

        constant:  normalization constant 
        """
        return _Kernel.MultitaskKernelMaskNormalizer_set_normalization_constant(self, *args)

MultitaskKernelMaskNormalizer_swigregister = _Kernel.MultitaskKernelMaskNormalizer_swigregister
MultitaskKernelMaskNormalizer_swigregister(MultitaskKernelMaskNormalizer)

class MultitaskKernelMaskPairNormalizer(KernelNormalizer):
    """
    The MultitaskKernel allows Multitask Learning via a modified kernel
    function.

    Normalization is based on a mask that is defined by a number of pair
    of tasks.

    C++ includes: MultitaskKernelMaskPairNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelMaskPairNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelMaskPairNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> MultitaskKernelMaskPairNormalizer
        __init__(self, task_vector_, active_pairs_) -> MultitaskKernelMaskPairNormalizer

        default constructor

        Parameters:
        -----------

        task_lhs:  task vector with containing task_id for each example for
        left hand side

        task_rhs:  task vector with containing task_id for each example for
        right hand side 
        """
        this = _Kernel.new_MultitaskKernelMaskPairNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_MultitaskKernelMaskPairNormalizer
    __del__ = lambda self : None;
    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> IntVector

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> IntVector

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_set_task_vector(self, *args)

    def get_similarity(self, *args):
        """
        get_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_get_similarity(self, *args)

    def get_active_pairs(self):
        """
        get_active_pairs(self) -> PairiiVec

        vector of active pairs 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_get_active_pairs(self)

    def get_normalization_constant(self):
        """
        get_normalization_constant(self) -> float

        normalization constant 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_get_normalization_constant(self)

    def set_normalization_constant(self, *args):
        """
        set_normalization_constant(self, constant) -> float

        Parameters:

        constant:  normalization constant 
        """
        return _Kernel.MultitaskKernelMaskPairNormalizer_set_normalization_constant(self, *args)

MultitaskKernelMaskPairNormalizer_swigregister = _Kernel.MultitaskKernelMaskPairNormalizer_swigregister
MultitaskKernelMaskPairNormalizer_swigregister(MultitaskKernelMaskPairNormalizer)

class MultitaskKernelPlifNormalizer(MultitaskKernelMklNormalizer):
    """
    The MultitaskKernel allows learning a piece-wise linear function
    (PLIF) via MKL.

    C++ includes: MultitaskKernelPlifNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultitaskKernelPlifNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [MultitaskKernelMklNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultitaskKernelPlifNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, support_, task_vector) -> MultitaskKernelPlifNormalizer

        constructor 
        """
        this = _Kernel.new_MultitaskKernelPlifNormalizer(*args)
        try: self.this.append(this)
        except: self.this = this
    def get_num_unique_tasks(self, *args):
        """
        get_num_unique_tasks(self, vec) ->  int

        helper routine

        Parameters:
        -----------

        vec:  vector with containing task_id for each example

        number of unique task ids 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_get_num_unique_tasks(self, *args)

    __swig_destroy__ = _Kernel.delete_MultitaskKernelPlifNormalizer
    __del__ = lambda self : None;
    def update_cache(self):
        """
        update_cache(self)

        update cache 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_update_cache(self)

    def compute_task_similarity(self, *args):
        """
        compute_task_similarity(self, task_a, task_b) -> float

        derive similarity from distance with plif 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_compute_task_similarity(self, *args)

    def get_task_vector_lhs(self):
        """
        get_task_vector_lhs(self) -> IntVector

        vec task vector with containing task_id for each example on left hand
        side 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_get_task_vector_lhs(self)

    def set_task_vector_lhs(self, *args):
        """
        set_task_vector_lhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_set_task_vector_lhs(self, *args)

    def get_task_vector_rhs(self):
        """
        get_task_vector_rhs(self) -> IntVector

        vec task vector with containing task_id for each example on right hand
        side 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_get_task_vector_rhs(self)

    def set_task_vector_rhs(self, *args):
        """
        set_task_vector_rhs(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_set_task_vector_rhs(self, *args)

    def set_task_vector(self, *args):
        """
        set_task_vector(self, vec)

        Parameters:

        vec:  task vector with containing task_id for each example 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_set_task_vector(self, *args)

    def get_task_distance(self, *args):
        """
        get_task_distance(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        distance between tasks 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_get_task_distance(self, *args)

    def set_task_distance(self, *args):
        """
        set_task_distance(self, task_lhs, task_rhs, distance)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        distance:  distance between tasks 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_set_task_distance(self, *args)

    def get_task_similarity(self, *args):
        """
        get_task_similarity(self, task_lhs, task_rhs) -> float

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity between tasks 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_get_task_similarity(self, *args)

    def set_task_similarity(self, *args):
        """
        set_task_similarity(self, task_lhs, task_rhs, similarity)

        Parameters:

        task_lhs:  task_id on left hand side

        task_rhs:  task_id on right hand side

        similarity:  similarity between tasks 
        """
        return _Kernel.MultitaskKernelPlifNormalizer_set_task_similarity(self, *args)

MultitaskKernelPlifNormalizer_swigregister = _Kernel.MultitaskKernelPlifNormalizer_swigregister
MultitaskKernelPlifNormalizer_swigregister(MultitaskKernelPlifNormalizer)

class OligoStringKernel(StringCharKernel):
    """
    This class offers access to the Oligo Kernel introduced by Meinicke et
    al. in 2004.

    The class has functions to preprocess the data such that the kernel
    computation can be pursued faster. The kernel function is then
    kernelOligoFast or kernelOligo.

    Requires significant speedup, should be working but as is might be
    applicable only to academic small scale problems:

    the kernel should only ever see encoded sequences, which however
    requires another OligoFeatures object (using CSimpleFeatures of pairs)

    Uses CSqrtDiagKernelNormalizer, as the vanilla kernel seems to be very
    diagonally dominant.

    C++ includes: OligoStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OligoStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OligoStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, cache_size, k, width) -> OligoStringKernel

        Constructor

        Parameters:
        -----------

        cache_size:  cache size for kernel

        k:  k-mer length

        width:  - equivalent to 2*sigma^2 
        """
        this = _Kernel.new_OligoStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_OligoStringKernel
    __del__ = lambda self : None;
    def compute(self, *args):
        """
        compute(self, x, y) -> float

        compute kernel function for features a and b idx_{a,b} denote the
        index of the feature vectors in the corresponding feature object

        abstract base method

        Parameters:
        -----------

        x:  index a

        y:  index b

        computed kernel function at indices a,b 
        """
        return _Kernel.OligoStringKernel_compute(self, *args)

OligoStringKernel_swigregister = _Kernel.OligoStringKernel_swigregister
OligoStringKernel_swigregister(OligoStringKernel)

class PolyKernel(RealKernel):
    """
    Computes the standard polynomial kernel on dense real valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= ({\\bf x}\\cdot {\\bf x'}+c)^d
    \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, l, r, d, inhom, size = 10) -> PolyKernel
        __init__(self, l, r, d, inhom) -> PolyKernel
        __init__(self, size, degree, inhomogene = True) -> PolyKernel
        __init__(self, size, degree) -> PolyKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _Kernel.new_PolyKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_PolyKernel
    __del__ = lambda self : None;
PolyKernel_swigregister = _Kernel.PolyKernel_swigregister
PolyKernel_swigregister(PolyKernel)

class PolyMatchStringKernel(StringCharKernel):
    """
    The class PolyMatchStringKernel computes a variant of the polynomial
    kernel on strings of same length.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyMatchStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyMatchStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyMatchStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, degree, inhomogene) -> PolyMatchStringKernel
        __init__(self, l, r, degree, inhomogene) -> PolyMatchStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _Kernel.new_PolyMatchStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_PolyMatchStringKernel
    __del__ = lambda self : None;
    def set_rescaling_enabled(self, *args):
        """
        set_rescaling_enabled(self, n)

        enable rescaling by length of feature vector

        Parameters:
        -----------

        n:  true to enable 
        """
        return _Kernel.PolyMatchStringKernel_set_rescaling_enabled(self, *args)

    def get_rescaling_enabled(self):
        """get_rescaling_enabled(self) -> bool"""
        return _Kernel.PolyMatchStringKernel_get_rescaling_enabled(self)

PolyMatchStringKernel_swigregister = _Kernel.PolyMatchStringKernel_swigregister
PolyMatchStringKernel_swigregister(PolyMatchStringKernel)

class GaussianMatchStringKernel(StringCharKernel):
    """
    The class GaussianMatchStringKernel computes a variant of the Gaussian
    kernel on strings of same length.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})=
    e^{-\\frac{\\left(x-x'\\right)^2}{w}} \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: GaussianMatchStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GaussianMatchStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GaussianMatchStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width) -> GaussianMatchStringKernel
        __init__(self, l, r, width) -> GaussianMatchStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width 
        """
        this = _Kernel.new_GaussianMatchStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_GaussianMatchStringKernel
    __del__ = lambda self : None;
GaussianMatchStringKernel_swigregister = _Kernel.GaussianMatchStringKernel_swigregister
GaussianMatchStringKernel_swigregister(GaussianMatchStringKernel)

class SNPStringKernel(StringCharKernel):
    """
    The class SNPStringKernel computes a variant of the polynomial kernel
    on strings of same length.

    It is computed as FIXME

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^{L-1} I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: SNPStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SNPStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SNPStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, degree, win_len, inhomogene) -> SNPStringKernel
        __init__(self, l, r, degree, win_len, inhomogene) -> SNPStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        win_len:  length of local window

        inhomogene:  whether inhomogeneous poly 
        """
        this = _Kernel.new_SNPStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SNPStringKernel
    __del__ = lambda self : None;
    def set_minor_base_string(self, *args):
        """set_minor_base_string(self, str)"""
        return _Kernel.SNPStringKernel_set_minor_base_string(self, *args)

    def set_major_base_string(self, *args):
        """set_major_base_string(self, str)"""
        return _Kernel.SNPStringKernel_set_major_base_string(self, *args)

    def get_minor_base_string(self):
        """get_minor_base_string(self) -> str"""
        return _Kernel.SNPStringKernel_get_minor_base_string(self)

    def get_major_base_string(self):
        """get_major_base_string(self) -> str"""
        return _Kernel.SNPStringKernel_get_major_base_string(self)

    def obtain_base_strings(self):
        """obtain_base_strings(self)"""
        return _Kernel.SNPStringKernel_obtain_base_strings(self)

SNPStringKernel_swigregister = _Kernel.SNPStringKernel_swigregister
SNPStringKernel_swigregister(SNPStringKernel)

class RegulatoryModulesStringKernel(StringCharKernel):
    """
    The Regulaty Modules kernel, based on the WD kernel, as published in
    Schultheiss et al., Bioinformatics (2009) on regulatory sequences.

    C++ includes: RegulatoryModulesStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RegulatoryModulesStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RegulatoryModulesStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width, degree, shift, window) -> RegulatoryModulesStringKernel
        __init__(self, lstr, rstr, lpos, rpos, width, degree, shift, window, 
            size = 10) -> RegulatoryModulesStringKernel
        __init__(self, lstr, rstr, lpos, rpos, width, degree, shift, window) -> RegulatoryModulesStringKernel

        constructor

        Parameters:
        -----------

        lstr:  string features of left-hand side

        rstr:  string features of right-hand side

        lpos:  motif positions on lhs

        rpos:  motif positions on rhs

        width:  width of gaussian kernel

        degree:  degree of wds kernel

        shift:  shift of wds kernel

        window:  size of window around motifs to compute wds kernels on

        size:  cache size 
        """
        this = _Kernel.new_RegulatoryModulesStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_RegulatoryModulesStringKernel
    __del__ = lambda self : None;
    def set_motif_positions(self, *args):
        """
        set_motif_positions(self, positions_lhs, positions_rhs)

        set motif positions

        Parameters:
        -----------

        positions_lhs:  motif positions on lhs

        positions_rhs:  motif positions on rhs 
        """
        return _Kernel.RegulatoryModulesStringKernel_set_motif_positions(self, *args)

RegulatoryModulesStringKernel_swigregister = _Kernel.RegulatoryModulesStringKernel_swigregister
RegulatoryModulesStringKernel_swigregister(RegulatoryModulesStringKernel)

class PolyMatchWordStringKernel(StringWordKernel):
    """
    The class PolyMatchWordStringKernel computes a variant of the
    polynomial kernel on word-features.

    It makes sense for strings of same length mapped to word features and
    is computed as

    \\[ k({\\bf x},{\\bf x'})= (\\sum_{i=0}^L I(x_i=x'_i)+c)^d
    \\]

    where I is the indicator function which evaluates to 1 if its argument
    is true and to 0 otherwise.

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: PolyMatchWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolyMatchWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolyMatchWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, degree, inhomogene) -> PolyMatchWordStringKernel
        __init__(self, l, r, degree, inhomogene) -> PolyMatchWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _Kernel.new_PolyMatchWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_PolyMatchWordStringKernel
    __del__ = lambda self : None;
PolyMatchWordStringKernel_swigregister = _Kernel.PolyMatchWordStringKernel_swigregister
PolyMatchWordStringKernel_swigregister(PolyMatchWordStringKernel)

class SalzbergWordStringKernel(StringWordKernel):
    """
    The SalzbergWordString kernel implements the Salzberg kernel.

    It is described in

    Engineering Support Vector Machine Kernels That Recognize Translation
    Initiation Sites A. Zien, G.Raetsch, S. Mika, B. Schoelkopf, T.
    Lengauer, K.-R. Mueller

    C++ includes: SalzbergWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringWordKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SalzbergWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringWordKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SalzbergWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, pie, labels = None) -> SalzbergWordStringKernel
        __init__(self, size, pie) -> SalzbergWordStringKernel
        __init__(self, l, r, pie, labels = None) -> SalzbergWordStringKernel
        __init__(self, l, r, pie) -> SalzbergWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        pie:  the plugin estimate

        labels:  optional labels to set prior from 
        """
        this = _Kernel.new_SalzbergWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SalzbergWordStringKernel
    __del__ = lambda self : None;
    def set_prior_probs(self, *args):
        """
        set_prior_probs(self, pos_prior_, neg_prior_)

        set prior probs

        Parameters:
        -----------

        pos_prior_:  positive prior

        neg_prior_:  negative prior 
        """
        return _Kernel.SalzbergWordStringKernel_set_prior_probs(self, *args)

    def set_prior_probs_from_labels(self, *args):
        """
        set_prior_probs_from_labels(self, labels)

        set prior probs from labels

        Parameters:
        -----------

        labels:  labels to set prior probabilites from 
        """
        return _Kernel.SalzbergWordStringKernel_set_prior_probs_from_labels(self, *args)

SalzbergWordStringKernel_swigregister = _Kernel.SalzbergWordStringKernel_swigregister
SalzbergWordStringKernel_swigregister(SalzbergWordStringKernel)

class SigmoidKernel(RealKernel):
    """
    The standard Sigmoid kernel computed on dense real valued features.

    Formally, it is computed as

    \\[ k({\\bf x},{\\bf x'})=\\mbox{tanh}(\\gamma {\\bf
    x}\\cdot{\\bf x'}+c) \\]

    C++ includes: SigmoidKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SigmoidKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SigmoidKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, gamma, coef0) -> SigmoidKernel
        __init__(self, l, r, size, gamma, coef0) -> SigmoidKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        size:  cache size

        gamma:  gamma

        coef0:  coefficient 0 
        """
        this = _Kernel.new_SigmoidKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SigmoidKernel
    __del__ = lambda self : None;
SigmoidKernel_swigregister = _Kernel.SigmoidKernel_swigregister
SigmoidKernel_swigregister(SigmoidKernel)

class SimpleLocalityImprovedStringKernel(StringCharKernel):
    """
    SimpleLocalityImprovedString kernel, is a ``simplified'' and better
    performing version of the Locality improved kernel.

    It can be defined as

    \\[ K({\\bf x},{\\bf
    x'})=\\left(\\sum_{i=0}^{T-1}\\left(\\sum_{j=-l}^{+l}w_jI_{i+j}({\\bf
    x},{\\bf x'})\\right)^{d_1}\\right)^{d_2}, \\] where $
    I_i({\\bf x},{\\bf x'})=1$ if $x_i=x'_i$ and 0 otherwise.

    C++ includes: SimpleLocalityImprovedStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SimpleLocalityImprovedStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SimpleLocalityImprovedStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, length, inner_degree, outer_degree) -> SimpleLocalityImprovedStringKernel
        __init__(self, l, r, length, inner_degree, outer_degree) -> SimpleLocalityImprovedStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        length:  length

        inner_degree:  inner degree

        outer_degree:  outer degree 
        """
        this = _Kernel.new_SimpleLocalityImprovedStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SimpleLocalityImprovedStringKernel
    __del__ = lambda self : None;
SimpleLocalityImprovedStringKernel_swigregister = _Kernel.SimpleLocalityImprovedStringKernel_swigregister
SimpleLocalityImprovedStringKernel_swigregister(SimpleLocalityImprovedStringKernel)

class SparseGaussianKernel(SparseRealKernel):
    """
    The well known Gaussian kernel (swiss army knife for SVMs) on sparse
    real valued features.

    It is computed as

    \\[ k({\\bf x},{\\bf x'})= exp(-\\frac{||{\\bf x}-{\\bf
    x'}||^2}{\\tau}) \\]

    where $\\tau$ is the kernel width.

    C++ includes: SparseGaussianKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [SparseRealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseGaussianKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [SparseRealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseGaussianKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, width) -> SparseGaussianKernel
        __init__(self, l, r, width) -> SparseGaussianKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width 
        """
        this = _Kernel.new_SparseGaussianKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SparseGaussianKernel
    __del__ = lambda self : None;
SparseGaussianKernel_swigregister = _Kernel.SparseGaussianKernel_swigregister
SparseGaussianKernel_swigregister(SparseGaussianKernel)

class SparseLinearKernel(SparseRealKernel):
    """
    Computes the standard linear kernel on sparse real valued features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= \\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    C++ includes: SparseLinearKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [SparseRealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparseLinearKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [SparseRealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparseLinearKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> SparseLinearKernel
        __init__(self, l, r) -> SparseLinearKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side 
        """
        this = _Kernel.new_SparseLinearKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SparseLinearKernel
    __del__ = lambda self : None;
    def get_normal(self, *args):
        """
        get_normal(self, len) -> float

        get normal

        Parameters:
        -----------

        len:  length of normal vector will be stored here

        the normal vector 
        """
        return _Kernel.SparseLinearKernel_get_normal(self, *args)

SparseLinearKernel_swigregister = _Kernel.SparseLinearKernel_swigregister
SparseLinearKernel_swigregister(SparseLinearKernel)

class SparsePolyKernel(SparseRealKernel):
    """
    Computes the standard polynomial kernel on sparse real valued
    features.

    Formally, it computes

    \\[ k({\\bf x},{\\bf x'})= ({\\bf x}\\cdot {\\bf x'}+c)^d
    \\]

    Note that additional normalisation is applied, i.e. \\[ k'({\\bf
    x}, {\\bf x'})=\\frac{k({\\bf x}, {\\bf
    x'})}{\\sqrt{k({\\bf x}, {\\bf x})k({\\bf x'}, {\\bf x'})}}
    \\]

    C++ includes: SparsePolyKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [SparseRealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SparsePolyKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [SparseRealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SparsePolyKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, l, r, size, d, inhom) -> SparsePolyKernel
        __init__(self, size, degree, inhomogene = True) -> SparsePolyKernel
        __init__(self, size, degree) -> SparsePolyKernel

        constructor

        Parameters:
        -----------

        size:  cache size

        degree:  degree

        inhomogene:  is inhomogeneous 
        """
        this = _Kernel.new_SparsePolyKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SparsePolyKernel
    __del__ = lambda self : None;
SparsePolyKernel_swigregister = _Kernel.SparsePolyKernel_swigregister
SparsePolyKernel_swigregister(SparsePolyKernel)

class SqrtDiagKernelNormalizer(KernelNormalizer):
    """
    SqrtDiagKernelNormalizer divides by the Square Root of the product of
    the diagonal elements.

    This effectively normalizes the vectors in feature space to norm 1
    (see CSqrtDiagKernelNormalizer)

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{\\sqrt{k({\\bf x},{\\bf x})k({\\bf x'},{\\bf x'})}}
    \\]

    C++ includes: SqrtDiagKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SqrtDiagKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SqrtDiagKernelNormalizer, name)
    __repr__ = _swig_repr
    def __init__(self, use_opt_diag = False): 
        """
        __init__(self, use_opt_diag = False) -> SqrtDiagKernelNormalizer
        __init__(self) -> SqrtDiagKernelNormalizer

        default constructor

        Parameters:
        -----------

        use_opt_diag:  - some kernels support faster diagonal compuation via
        compute_diag(idx), this flag enables this 
        """
        this = _Kernel.new_SqrtDiagKernelNormalizer(use_opt_diag)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_SqrtDiagKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _Kernel.SqrtDiagKernelNormalizer_alloc_and_compute_diag(self, *args)

SqrtDiagKernelNormalizer_swigregister = _Kernel.SqrtDiagKernelNormalizer_swigregister
SqrtDiagKernelNormalizer_swigregister(SqrtDiagKernelNormalizer)

class TanimotoKernelNormalizer(KernelNormalizer):
    """
    TanimotoKernelNormalizer performs kernel normalization inspired by the
    Tanimoto coefficient (seehttp://en.wikipedia.org/wiki/Jaccard_index ).

    \\[ k'({\\bf x},{\\bf x'}) = \\frac{k({\\bf x},{\\bf
    x'})}{k({\\bf x},{\\bf x})+k({\\bf x'},{\\bf x'})-k({\\bf
    x},{\\bf x'})} \\]

    C++ includes: TanimotoKernelNormalizer.h 
    """
    __swig_setmethods__ = {}
    for _s in [KernelNormalizer]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TanimotoKernelNormalizer, name, value)
    __swig_getmethods__ = {}
    for _s in [KernelNormalizer]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TanimotoKernelNormalizer, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Kernel.delete_TanimotoKernelNormalizer
    __del__ = lambda self : None;
    def alloc_and_compute_diag(self, *args):
        """
        alloc_and_compute_diag(self, k, v, num) -> bool

        alloc and compute the vector containing the square root of the
        diagonal elements of this kernel. 
        """
        return _Kernel.TanimotoKernelNormalizer_alloc_and_compute_diag(self, *args)

TanimotoKernelNormalizer_swigregister = _Kernel.TanimotoKernelNormalizer_swigregister
TanimotoKernelNormalizer_swigregister(TanimotoKernelNormalizer)

class TensorProductPairKernel(IntKernel):
    """
    Computes the Tensor Product Pair Kernel (TPPK).

    Formally, it computes

    \\[ k_{\\mbox{tppk}}(({\\bf a},{\\bf b}), ({\\bf c},{\\bf
    d}))= k({\\bf a}, {\\bf c})\\cdot k({\\bf b}, {\\bf c}) +
    k({\\bf a},{\\bf d})\\cdot k({\\bf b}, {\\bf c}) \\]

    It is defined on pairs of inputs and a subkernel $k$. The subkernel
    has to be given on initialization. The pairs are specified via indizes
    (ab)using 2-dimensional integer features.

    Its feature space $\\Phi_{\\mbox{tppk}}$ is the tensor product of
    the feature spaces of the subkernel $k(.,.)$ on its input.

    It is often used in bioinformatics, e.g., to predict protein-protein
    interactions.

    C++ includes: TensorProductPairKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [IntKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TensorProductPairKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [IntKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TensorProductPairKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, subkernel) -> TensorProductPairKernel
        __init__(self, l, r, subkernel) -> TensorProductPairKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        subkernel:  the subkernel 
        """
        this = _Kernel.new_TensorProductPairKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_TensorProductPairKernel
    __del__ = lambda self : None;
TensorProductPairKernel_swigregister = _Kernel.TensorProductPairKernel_swigregister
TensorProductPairKernel_swigregister(TensorProductPairKernel)

class WeightedCommWordStringKernel(CommWordStringKernel):
    """
    The WeightedCommWordString kernel may be used to compute the weighted
    spectrum kernel (i.e. a spectrum kernel for 1 to K-mers, where each
    k-mer length is weighted by some coefficient $\\beta_k$) from
    strings that have been mapped into unsigned 16bit integers.

    These 16bit integers correspond to k-mers. To applicable in this
    kernel they need to be sorted (e.g. via the SortWordString pre-
    processor).

    It basically uses the algorithm in the unix "comm" command (hence
    the name) to compute:

    \\[ k({\\bf x},({\\bf x'})=
    \\sum_{k=1}^K\\beta_k\\Phi_k({\\bf x})\\cdot
    \\Phi_k({\\bf x'}) \\]

    where $\\Phi_k$ maps a sequence ${\\bf x}$ that consists of
    letters in $\\Sigma$ to a feature vector of size $|\\Sigma|^k$. In
    this feature vector each entry denotes how often the k-mer appears in
    that ${\\bf x}$.

    Note that this representation is especially tuned to small alphabets
    (like the 2-bit alphabet DNA), for which it enables spectrum kernels
    of order 8.

    For this kernel the linadd speedups are quite efficiently implemented
    using direct maps.

    C++ includes: WeightedCommWordStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [CommWordStringKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedCommWordStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [CommWordStringKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedCommWordStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, use_sign) -> WeightedCommWordStringKernel
        __init__(self, l, r, use_sign = False, size = 10) -> WeightedCommWordStringKernel
        __init__(self, l, r, use_sign = False) -> WeightedCommWordStringKernel
        __init__(self, l, r) -> WeightedCommWordStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        use_sign:  if sign shall be used

        size:  cache size 
        """
        this = _Kernel.new_WeightedCommWordStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_WeightedCommWordStringKernel
    __del__ = lambda self : None;
    def merge_normal(self):
        """
        merge_normal(self)

        merge normal 
        """
        return _Kernel.WeightedCommWordStringKernel_merge_normal(self)

    def set_wd_weights(self):
        """
        set_wd_weights(self) -> bool

        set weighted degree weights

        if setting was successful 
        """
        return _Kernel.WeightedCommWordStringKernel_set_wd_weights(self)

    def set_weights(self, *args):
        """
        set_weights(self, w) -> bool

        set custom weights (swig compatible)

        Parameters:
        -----------

        w:  weights

        d:  degree (must match number of weights)

        if setting was successful 
        """
        return _Kernel.WeightedCommWordStringKernel_set_weights(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas, do_init = True) -> float
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, alphas) -> float

        compute scoring

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        do_init:  if initialization shall be performed

        computed score 
        """
        return _Kernel.WeightedCommWordStringKernel_compute_scoring(self, *args)

WeightedCommWordStringKernel_swigregister = _Kernel.WeightedCommWordStringKernel_swigregister
WeightedCommWordStringKernel_swigregister(WeightedCommWordStringKernel)

class WeightedDegreePositionStringKernel(StringCharKernel):
    """
    The Weighted Degree Position String kernel (Weighted Degree kernel
    with shifts).

    The WD-shift kernel of order d compares two sequences ${\\bf x}$ and
    ${\\bf x'}$ of length L by summing all contributions of k-mer
    matches of lengths $k\\in\\{1,\\dots,d\\}$, weighted by
    coefficients $\\beta_k$ allowing for a positional tolerance of up to
    shift s.

    It is formally defined as \\begin{eqnarray*}
    &&\\!\\!\\!\\!\\!\\!\\!k({\\bf x}_i,{\\bf
    x}_j)=\\sum_{k=1}^d\\beta_k\\sum_{l=1}^{\\!\\!\\!\\!L-k+1\\!\\!\\!\\!}\\gamma_l\\sum_{\\begin{array}{c}s=0\\\\
    \\!\\!\\!\\!s+l\\leq
    L\\!\\!\\!\\!\\end{array}}^{S(l)}
    \\delta_s\\;\\mu_{k,l,s,{{\\bf x}_i},{{\\bf x}_j}},\\\\
    &&\\!\\!\\!\\!\\!\\!\\!\\!\\!\\! {\\footnotesize
    \\mu_{k,l,s,{{\\bf x}_i},{{\\bf x}_j}}\\!\\!\\!
    =\\!\\! I({\\bf u}_{k,l+s}({\\bf x}_i)\\! =\\!{\\bf
    u}_{k,l}({\\bf x}_j))\\! +\\!I({\\bf u}_{k,l}({\\bf
    x}_i)\\! =\\!{\\bf u}_{k,l+s}({\\bf x}_j))},\\nonumber
    \\end{eqnarray*} where $\\beta_j$ are the weighting coefficients
    of the j-mers, $\\gamma_l$ is a weighting over the position in the
    sequence, $\\delta_s=1/(2(s+1))$ is the weight assigned to shifts
    (in either direction) of extent s, and S(l) determines the shift range
    at position l.

    C++ includes: WeightedDegreePositionStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreePositionStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreePositionStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, size, degree, max_mismatch = 0, mkl_stepsize = 1) -> WeightedDegreePositionStringKernel
        __init__(self, size, degree, max_mismatch = 0) -> WeightedDegreePositionStringKernel
        __init__(self, size, degree) -> WeightedDegreePositionStringKernel
        __init__(self, size, weights, degree, max_mismatch, shift, shift_len, 
            mkl_stepsize = 1) -> WeightedDegreePositionStringKernel
        __init__(self, size, weights, degree, max_mismatch, shift, shift_len) -> WeightedDegreePositionStringKernel
        __init__(self, l, r, degree) -> WeightedDegreePositionStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _Kernel.new_WeightedDegreePositionStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_WeightedDegreePositionStringKernel
    __del__ = lambda self : None;
    def init_optimization(self, *args):
        """
        init_optimization(self, p_count, IDX, alphas) -> bool
        init_optimization(self, count, IDX, alphas, tree_num, upto_tree = -1) -> bool
        init_optimization(self, count, IDX, alphas, tree_num) -> bool

        initialize optimization do initialization for tree_num up to
        upto_tree, use tree_num=-1 to construct all trees

        Parameters:
        -----------

        count:  count

        IDX:  IDX

        alphas:  alphas

        tree_num:  which tree

        upto_tree:  up to this tree

        if initializing was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_optimization(self, *args)

    def compute_batch_helper(*args):
        """compute_batch_helper(p) -> void"""
        return _Kernel.WeightedDegreePositionStringKernel_compute_batch_helper(*args)

    if _newclass:compute_batch_helper = staticmethod(compute_batch_helper)
    __swig_getmethods__["compute_batch_helper"] = lambda x: compute_batch_helper
    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        compute batch

        Parameters:
        -----------

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        factor:  factor 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_batch(self, *args)

    def compute_abs_weights(self, *args):
        """
        compute_abs_weights(self, len) -> float

        compute abs weights

        Parameters:
        -----------

        len:  len

        computed abs weights 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_abs_weights(self, *args)

    def is_tree_initialized(self):
        """
        is_tree_initialized(self) -> bool

        check if tree is initialized

        if tree is initialized 
        """
        return _Kernel.WeightedDegreePositionStringKernel_is_tree_initialized(self)

    def get_max_mismatch(self):
        """
        get_max_mismatch(self) ->  int

        get maximum mismatch

        maximum mismatch 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_max_mismatch(self)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        the degree 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_degree(self)

    def get_degree_weights(self, *args):
        """
        get_degree_weights(self, d, len) -> float

        get degree weights

        Parameters:
        -----------

        d:  degree weights will be stored here

        len:  number of degree weights will be stored here 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_degree_weights(self, *args)

    def get_weights(self, *args):
        """
        get_weights(self, num_weights) -> float

        get weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        weights 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_weights(self, *args)

    def get_position_weights(self, *args):
        """
        get_position_weights(self, len) -> float

        get position weights

        Parameters:
        -----------

        len:  number of position weights will be stored here

        position weights 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_position_weights(self, *args)

    def set_shifts(self, *args):
        """
        set_shifts(self, shifts) -> bool

        set shifts

        Parameters:
        -----------

        shifts:  new shifts

        len:  number of shifts 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_shifts(self, *args)

    def set_weights(self, *args):
        """
        set_weights(self, weights) -> bool
        set_weights(self, weights, d) -> bool

        set weights

        Parameters:
        -----------

        weights:  new weights

        d:  degree

        len:  number of weights 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_weights(self, *args)

    def set_wd_weights(self):
        """
        set_wd_weights(self) -> bool

        set wd weights

        if setting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_wd_weights(self)

    def set_position_weights(self, *args):
        """
        set_position_weights(self, pws) -> bool

        set position weights

        Parameters:
        -----------

        pws:  new position weights

        len:  number of position weights

        if setting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_position_weights(self, *args)

    def set_position_weights_lhs(self, *args):
        """
        set_position_weights_lhs(self, pws, num) -> bool

        set position weights for left-hand side

        Parameters:
        -----------

        pws:  new position weights

        len:  len

        num:  num

        if setting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_position_weights_lhs(self, *args)

    def set_position_weights_rhs(self, *args):
        """
        set_position_weights_rhs(self, pws, num) -> bool

        set position weights for right-hand side

        Parameters:
        -----------

        pws:  new position weights

        len:  len

        num:  num

        if setting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_set_position_weights_rhs(self, *args)

    def init_block_weights(self):
        """
        init_block_weights(self) -> bool

        initialize block weights

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights(self)

    def init_block_weights_from_wd(self):
        """
        init_block_weights_from_wd(self) -> bool

        initialize block weights from weighted degree

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_from_wd(self)

    def init_block_weights_from_wd_external(self):
        """
        init_block_weights_from_wd_external(self) -> bool

        initialize block weights from external weighted degree

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_from_wd_external(self)

    def init_block_weights_const(self):
        """
        init_block_weights_const(self) -> bool

        initialize block weights constant

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_const(self)

    def init_block_weights_linear(self):
        """
        init_block_weights_linear(self) -> bool

        initialize block weights linear

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_linear(self)

    def init_block_weights_sqpoly(self):
        """
        init_block_weights_sqpoly(self) -> bool

        initialize block weights squared polynomial

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_sqpoly(self)

    def init_block_weights_cubicpoly(self):
        """
        init_block_weights_cubicpoly(self) -> bool

        initialize block weights cubic polynomial

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_cubicpoly(self)

    def init_block_weights_exp(self):
        """
        init_block_weights_exp(self) -> bool

        initialize block weights exponential

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_exp(self)

    def init_block_weights_log(self):
        """
        init_block_weights_log(self) -> bool

        initialize block weights logarithmic

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_log(self)

    def init_block_weights_external(self):
        """
        init_block_weights_external(self) -> bool

        initialize block weights external

        if initialization was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_init_block_weights_external(self)

    def delete_position_weights(self):
        """
        delete_position_weights(self) -> bool

        delete position weights

        if deleting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_delete_position_weights(self)

    def delete_position_weights_lhs(self):
        """
        delete_position_weights_lhs(self) -> bool

        delete position weights left-hand side

        if deleting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_delete_position_weights_lhs(self)

    def delete_position_weights_rhs(self):
        """
        delete_position_weights_rhs(self) -> bool

        delete position weights right-hand side

        if deleting was successful 
        """
        return _Kernel.WeightedDegreePositionStringKernel_delete_position_weights_rhs(self)

    def compute_by_tree(self, *args):
        """
        compute_by_tree(self, idx) -> float
        compute_by_tree(self, idx, LevelContrib)

        compute by tree

        Parameters:
        -----------

        idx:  index

        LevelContrib:  level contribution 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_by_tree(self, *args)

    def compute_scoring(self, *args):
        """
        compute_scoring(self, max_degree, num_feat, num_sym, target, num_suppvec, 
            IDX, weights) -> float

        compute positional scoring function, which assigns a weight per
        position, per symbol in the sequence

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        weights:  weights

        computed scores 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_scoring(self, *args)

    def compute_consensus(self, *args):
        """
        compute_consensus(self, num_feat, num_suppvec, IDX, alphas) -> str

        compute consensus string

        Parameters:
        -----------

        num_feat:  number of features

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        consensus string 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_consensus(self, *args)

    def extract_w(self, *args):
        """
        extract_w(self, max_degree, num_feat, num_sym, w_result, num_suppvec, 
            IDX, alphas) -> float

        extract w

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        w_result:  w

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        w 
        """
        return _Kernel.WeightedDegreePositionStringKernel_extract_w(self, *args)

    def compute_POIM(self, *args):
        """
        compute_POIM(self, max_degree, num_feat, num_sym, poim_result, num_suppvec, 
            IDX, alphas, distrib) -> float

        compute POIM

        Parameters:
        -----------

        max_degree:  maximum degree

        num_feat:  number of features

        num_sym:  number of symbols

        poim_result:  poim

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        distrib:  distribution

        computed POIMs 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_POIM(self, *args)

    def prepare_POIM2(self, *args):
        """
        prepare_POIM2(self, distrib)

        prepare POIM2

        Parameters:
        -----------

        num_feat:  number of features

        num_sym:  number of symbols

        distrib:  distribution 
        """
        return _Kernel.WeightedDegreePositionStringKernel_prepare_POIM2(self, *args)

    def compute_POIM2(self, *args):
        """
        compute_POIM2(self, max_degree, svm)

        compute POIM2

        Parameters:
        -----------

        max_degree:  maximum degree

        svm:  SVM 
        """
        return _Kernel.WeightedDegreePositionStringKernel_compute_POIM2(self, *args)

    def get_POIM2(self):
        """
        get_POIM2(self) -> [] of float

        get POIM2

        Parameters:
        -----------

        poim:  POIMs (returned)

        result_len:  (returned) 
        """
        return _Kernel.WeightedDegreePositionStringKernel_get_POIM2(self)

    def cleanup_POIM2(self):
        """
        cleanup_POIM2(self)

        cleanup POIM2 
        """
        return _Kernel.WeightedDegreePositionStringKernel_cleanup_POIM2(self)

WeightedDegreePositionStringKernel_swigregister = _Kernel.WeightedDegreePositionStringKernel_swigregister
WeightedDegreePositionStringKernel_swigregister(WeightedDegreePositionStringKernel)

def WeightedDegreePositionStringKernel_compute_batch_helper(*args):
  """WeightedDegreePositionStringKernel_compute_batch_helper(p) -> void"""
  return _Kernel.WeightedDegreePositionStringKernel_compute_batch_helper(*args)

E_WD = _Kernel.E_WD
E_EXTERNAL = _Kernel.E_EXTERNAL
E_BLOCK_CONST = _Kernel.E_BLOCK_CONST
E_BLOCK_LINEAR = _Kernel.E_BLOCK_LINEAR
E_BLOCK_SQPOLY = _Kernel.E_BLOCK_SQPOLY
E_BLOCK_CUBICPOLY = _Kernel.E_BLOCK_CUBICPOLY
E_BLOCK_EXP = _Kernel.E_BLOCK_EXP
E_BLOCK_LOG = _Kernel.E_BLOCK_LOG
E_BLOCK_EXTERNAL = _Kernel.E_BLOCK_EXTERNAL
class WeightedDegreeStringKernel(StringCharKernel):
    """
    The Weighted Degree String kernel.

    The WD kernel of order d compares two sequences ${\\bf x}$ and
    ${\\bf x'}$ of length L by summing all contributions of k-mer
    matches of lengths $k\\in\\{1,\\dots,d\\}$, weighted by
    coefficients $\\beta_k$. It is defined as \\[ k({\\bf x},{\\bf
    x'})=\\sum_{k=1}^d\\beta_k\\sum_{l=1}^{L-k+1}I({\\bf
    u}_{k,l}({\\bf x})={\\bf u}_{k,l}({\\bf x'})). \\] Here,
    ${\\bf u}_{k,l}({\\bf x})$ is the string of length k starting at
    position l of the sequence ${\\bf x}$ and $I(\\cdot)$ is the
    indicator function which evaluates to 1 when its argument is true and
    to 0 otherwise.

    C++ includes: WeightedDegreeStringKernel.h 
    """
    __swig_setmethods__ = {}
    for _s in [StringCharKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreeStringKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [StringCharKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreeStringKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, degree, type = E_WD) -> WeightedDegreeStringKernel
        __init__(self, degree) -> WeightedDegreeStringKernel
        __init__(self, weights, degree) -> WeightedDegreeStringKernel
        __init__(self, l, r, degree) -> WeightedDegreeStringKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        degree:  degree 
        """
        this = _Kernel.new_WeightedDegreeStringKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_WeightedDegreeStringKernel
    __del__ = lambda self : None;
    def get_type(self):
        """
        get_type(self) -> EWDKernType

        get WD kernel weighting type

        weighting type

        See:  EWDKernType 
        """
        return _Kernel.WeightedDegreeStringKernel_get_type(self)

    def init_optimization(self, *args):
        """
        init_optimization(self, count, IDX, alphas) -> bool
        init_optimization(self, count, IDX, alphas, tree_num) -> bool

        initialize optimization do initialization for tree_num up to
        upto_tree, use tree_num=-1 to construct all trees

        Parameters:
        -----------

        count:  count

        IDX:  IDX

        alphas:  alphas

        tree_num:  which tree

        if initializing was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_optimization(self, *args)

    def compute_batch_helper(*args):
        """compute_batch_helper(p) -> void"""
        return _Kernel.WeightedDegreeStringKernel_compute_batch_helper(*args)

    if _newclass:compute_batch_helper = staticmethod(compute_batch_helper)
    __swig_getmethods__["compute_batch_helper"] = lambda x: compute_batch_helper
    def compute_batch(self, *args):
        """
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas, 
            factor = 1.0)
        compute_batch(self, num_vec, vec_idx, target, num_suppvec, IDX, alphas)

        compute batch

        Parameters:
        -----------

        num_vec:  number of vectors

        vec_idx:  vector index

        target:  target

        num_suppvec:  number of support vectors

        IDX:  IDX

        alphas:  alphas

        factor:  factor 
        """
        return _Kernel.WeightedDegreeStringKernel_compute_batch(self, *args)

    def compute_abs_weights(self, *args):
        """
        compute_abs_weights(self, len) -> float

        compute abs weights

        Parameters:
        -----------

        len:  len

        computed abs weights 
        """
        return _Kernel.WeightedDegreeStringKernel_compute_abs_weights(self, *args)

    def compute_by_tree(self, *args):
        """
        compute_by_tree(self, idx, LevelContrib)

        compute by tree

        Parameters:
        -----------

        idx:  index

        LevelContrib:  level contribution

        computed value 
        """
        return _Kernel.WeightedDegreeStringKernel_compute_by_tree(self, *args)

    def is_tree_initialized(self):
        """
        is_tree_initialized(self) -> bool

        check if tree is initialized

        if tree is initialized 
        """
        return _Kernel.WeightedDegreeStringKernel_is_tree_initialized(self)

    def get_degree_weights(self, *args):
        """
        get_degree_weights(self, d, len) -> float

        get degree weights

        Parameters:
        -----------

        d:  degree weights will be stored here

        len:  number of degree weights will be stored here 
        """
        return _Kernel.WeightedDegreeStringKernel_get_degree_weights(self, *args)

    def get_weights(self, *args):
        """
        get_weights(self, num_weights) -> float

        get weights

        Parameters:
        -----------

        num_weights:  number of weights will be stored here

        weights 
        """
        return _Kernel.WeightedDegreeStringKernel_get_weights(self, *args)

    def get_position_weights(self, *args):
        """
        get_position_weights(self, len) -> float

        get position weights

        Parameters:
        -----------

        len:  number of position weights will be stored here

        position weights 
        """
        return _Kernel.WeightedDegreeStringKernel_get_position_weights(self, *args)

    def set_wd_weights_by_type(self, *args):
        """
        set_wd_weights_by_type(self, type) -> bool

        set wd weights

        Parameters:
        -----------

        type:  weighted degree kernel type

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_wd_weights_by_type(self, *args)

    def set_wd_weights(self, *args):
        """
        set_wd_weights(self, p_weights)

        set wd weights

        Parameters:
        -----------

        p_weights:  new eights

        d:  degree

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_wd_weights(self, *args)

    def set_weights(self, *args):
        """
        set_weights(self, weights) -> bool

        set weights

        Parameters:
        -----------

        weights:  new weights

        d:  degree

        len:  number of weights 
        """
        return _Kernel.WeightedDegreeStringKernel_set_weights(self, *args)

    def set_position_weights(self, *args):
        """
        set_position_weights(self, position_weights, len = 0) -> bool
        set_position_weights(self, position_weights) -> bool

        set position weights

        Parameters:
        -----------

        position_weights:  new position weights

        len:  number of position weights

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_position_weights(self, *args)

    def init_block_weights(self):
        """
        init_block_weights(self) -> bool

        initialize block weights

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights(self)

    def init_block_weights_from_wd(self):
        """
        init_block_weights_from_wd(self) -> bool

        initialize block weights from weighted degree

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_from_wd(self)

    def init_block_weights_from_wd_external(self):
        """
        init_block_weights_from_wd_external(self) -> bool

        initialize block weights from external weighted degree

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_from_wd_external(self)

    def init_block_weights_const(self):
        """
        init_block_weights_const(self) -> bool

        initialize block weights constant

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_const(self)

    def init_block_weights_linear(self):
        """
        init_block_weights_linear(self) -> bool

        initialize block weights linear

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_linear(self)

    def init_block_weights_sqpoly(self):
        """
        init_block_weights_sqpoly(self) -> bool

        initialize block weights squared polynomial

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_sqpoly(self)

    def init_block_weights_cubicpoly(self):
        """
        init_block_weights_cubicpoly(self) -> bool

        initialize block weights cubic polynomial

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_cubicpoly(self)

    def init_block_weights_exp(self):
        """
        init_block_weights_exp(self) -> bool

        initialize block weights exponential

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_exp(self)

    def init_block_weights_log(self):
        """
        init_block_weights_log(self) -> bool

        initialize block weights logarithmic

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_log(self)

    def init_block_weights_external(self):
        """
        init_block_weights_external(self) -> bool

        initialize block weights external

        if initialization was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_init_block_weights_external(self)

    def delete_position_weights(self):
        """
        delete_position_weights(self) -> bool

        delete position weights

        if deleting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_delete_position_weights(self)

    def set_max_mismatch(self, *args):
        """
        set_max_mismatch(self, max) -> bool

        set maximum mismatch

        Parameters:
        -----------

        max:  new maximum mismatch

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_max_mismatch(self, *args)

    def get_max_mismatch(self, *args):
        """
        get_max_mismatch(self) ->  int
        get_max_mismatch(self) ->  int

        get maximum mismatch

        maximum mismatch 
        """
        return _Kernel.WeightedDegreeStringKernel_get_max_mismatch(self, *args)

    def set_degree(self, *args):
        """
        set_degree(self, deg) -> bool

        set degree

        Parameters:
        -----------

        deg:  new degree

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_degree(self, *args)

    def get_degree(self, *args):
        """
        get_degree(self) ->  int
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _Kernel.WeightedDegreeStringKernel_get_degree(self, *args)

    def set_use_block_computation(self, *args):
        """
        set_use_block_computation(self, block) -> bool

        set if block computation shall be performed

        Parameters:
        -----------

        block:  if block computation shall be performed

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_use_block_computation(self, *args)

    def get_use_block_computation(self):
        """
        get_use_block_computation(self) -> bool

        check if block computation is performed

        if block computation is performed 
        """
        return _Kernel.WeightedDegreeStringKernel_get_use_block_computation(self)

    def set_mkl_stepsize(self, *args):
        """
        set_mkl_stepsize(self, step) -> bool

        set MKL steps ize

        Parameters:
        -----------

        step:  new step size

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_mkl_stepsize(self, *args)

    def get_mkl_stepsize(self):
        """
        get_mkl_stepsize(self) ->  int

        get MKL step size

        MKL step size 
        """
        return _Kernel.WeightedDegreeStringKernel_get_mkl_stepsize(self)

    def set_which_degree(self, *args):
        """
        set_which_degree(self, which) -> bool

        set which degree

        Parameters:
        -----------

        which:  which degree

        if setting was successful 
        """
        return _Kernel.WeightedDegreeStringKernel_set_which_degree(self, *args)

    def get_which_degree(self):
        """
        get_which_degree(self) ->  int

        get which degree

        which degree 
        """
        return _Kernel.WeightedDegreeStringKernel_get_which_degree(self)

WeightedDegreeStringKernel_swigregister = _Kernel.WeightedDegreeStringKernel_swigregister
WeightedDegreeStringKernel_swigregister(WeightedDegreeStringKernel)

def WeightedDegreeStringKernel_compute_batch_helper(*args):
  """WeightedDegreeStringKernel_compute_batch_helper(p) -> void"""
  return _Kernel.WeightedDegreeStringKernel_compute_batch_helper(*args)

class WeightedDegreeRBFKernel(RealKernel):
    """Proxy of C++ shogun::CWeightedDegreeRBFKernel class"""
    __swig_setmethods__ = {}
    for _s in [RealKernel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeightedDegreeRBFKernel, name, value)
    __swig_getmethods__ = {}
    for _s in [RealKernel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeightedDegreeRBFKernel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WeightedDegreeRBFKernel
        __init__(self, size, width, degree, nof_properties) -> WeightedDegreeRBFKernel
        __init__(self, l, r, width, degree, nof_properties, size = 10) -> WeightedDegreeRBFKernel
        __init__(self, l, r, width, degree, nof_properties) -> WeightedDegreeRBFKernel

        constructor

        Parameters:
        -----------

        l:  features of left-hand side

        r:  features of right-hand side

        width:  width

        degree:  degree

        nof_properties:  number of properties per amino acid

        size:  cache size 
        """
        this = _Kernel.new_WeightedDegreeRBFKernel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Kernel.delete_WeightedDegreeRBFKernel
    __del__ = lambda self : None;
    def set_degree(self, *args):
        """
        set_degree(self, deg) -> bool

        set degree

        Parameters:
        -----------

        deg:  new degree

        if setting was successful 
        """
        return _Kernel.WeightedDegreeRBFKernel_set_degree(self, *args)

    def get_degree(self):
        """
        get_degree(self) ->  int

        get degree

        degree 
        """
        return _Kernel.WeightedDegreeRBFKernel_get_degree(self)

WeightedDegreeRBFKernel_swigregister = _Kernel.WeightedDegreeRBFKernel_swigregister
WeightedDegreeRBFKernel_swigregister(WeightedDegreeRBFKernel)

class NodeSet(_object):
    """Proxy of C++ std::vector<(p.shogun::CNode)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NodeSet, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NodeSet, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Kernel.NodeSet_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Kernel.NodeSet___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Kernel.NodeSet___bool__(self)

    def __len__(self):
        """__len__(self) -> size_type"""
        return _Kernel.NodeSet___len__(self)

    def pop(self):
        """pop(self) -> value_type"""
        return _Kernel.NodeSet_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> NodeSet"""
        return _Kernel.NodeSet___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Kernel.NodeSet___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Kernel.NodeSet___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Kernel.NodeSet___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> NodeSet
        __getitem__(self, i) -> value_type
        """
        return _Kernel.NodeSet___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Kernel.NodeSet___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Kernel.NodeSet_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Kernel.NodeSet_empty(self)

    def size(self):
        """size(self) -> size_type"""
        return _Kernel.NodeSet_size(self)

    def clear(self):
        """clear(self)"""
        return _Kernel.NodeSet_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Kernel.NodeSet_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> allocator_type"""
        return _Kernel.NodeSet_get_allocator(self)

    def begin(self):
        """begin(self) -> const_iterator"""
        return _Kernel.NodeSet_begin(self)

    def end(self):
        """end(self) -> const_iterator"""
        return _Kernel.NodeSet_end(self)

    def rbegin(self):
        """rbegin(self) -> const_reverse_iterator"""
        return _Kernel.NodeSet_rbegin(self)

    def rend(self):
        """rend(self) -> const_reverse_iterator"""
        return _Kernel.NodeSet_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Kernel.NodeSet_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> iterator
        erase(self, first, last) -> iterator
        """
        return _Kernel.NodeSet_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> NodeSet
        __init__(self, arg0) -> NodeSet
        __init__(self, size) -> NodeSet
        __init__(self, size, value) -> NodeSet
        """
        this = _Kernel.new_NodeSet(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Kernel.NodeSet_push_back(self, *args)

    def front(self):
        """front(self) -> value_type"""
        return _Kernel.NodeSet_front(self)

    def back(self):
        """back(self) -> value_type"""
        return _Kernel.NodeSet_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Kernel.NodeSet_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Kernel.NodeSet_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> iterator
        insert(self, pos, n, x)
        """
        return _Kernel.NodeSet_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Kernel.NodeSet_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> size_type"""
        return _Kernel.NodeSet_capacity(self)

    __swig_destroy__ = _Kernel.delete_NodeSet
    __del__ = lambda self : None;
NodeSet_swigregister = _Kernel.NodeSet_swigregister
NodeSet_swigregister(NodeSet)

class Pairii(_object):
    """Proxy of C++ std::pair<(int32_t,int32_t)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Pairii, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Pairii, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Pairii
        __init__(self, first, second) -> Pairii
        __init__(self, p) -> Pairii
        """
        this = _Kernel.new_Pairii(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_setmethods__["first"] = _Kernel.Pairii_first_set
    __swig_getmethods__["first"] = _Kernel.Pairii_first_get
    if _newclass:first = _swig_property(_Kernel.Pairii_first_get, _Kernel.Pairii_first_set)
    __swig_setmethods__["second"] = _Kernel.Pairii_second_set
    __swig_getmethods__["second"] = _Kernel.Pairii_second_get
    if _newclass:second = _swig_property(_Kernel.Pairii_second_get, _Kernel.Pairii_second_set)
    def __len__(self): return 2
    def __repr__(self): return str((self.first, self.second))
    def __getitem__(self, index): 
      if not (index % 2): 
        return self.first
      else:
        return self.second
    def __setitem__(self, index, val):
      if not (index % 2): 
        self.first = val
      else:
        self.second = val
    __swig_destroy__ = _Kernel.delete_Pairii
    __del__ = lambda self : None;
Pairii_swigregister = _Kernel.Pairii_swigregister
Pairii_swigregister(Pairii)

class PairiiVec(_object):
    """Proxy of C++ std::vector<(std::pair<(int32_t,int32_t)>)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, PairiiVec, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, PairiiVec, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Kernel.PairiiVec_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Kernel.PairiiVec___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Kernel.PairiiVec___bool__(self)

    def __len__(self):
        """__len__(self) -> std::vector<(std::pair<(int,int)>)>::size_type"""
        return _Kernel.PairiiVec___len__(self)

    def pop(self):
        """pop(self) -> std::vector<(std::pair<(int,int)>)>::value_type"""
        return _Kernel.PairiiVec_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> PairiiVec"""
        return _Kernel.PairiiVec___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Kernel.PairiiVec___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Kernel.PairiiVec___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Kernel.PairiiVec___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> PairiiVec
        __getitem__(self, i) -> std::vector<(std::pair<(int,int)>)>::value_type
        """
        return _Kernel.PairiiVec___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Kernel.PairiiVec___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Kernel.PairiiVec_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Kernel.PairiiVec_empty(self)

    def size(self):
        """size(self) -> std::vector<(std::pair<(int,int)>)>::size_type"""
        return _Kernel.PairiiVec_size(self)

    def clear(self):
        """clear(self)"""
        return _Kernel.PairiiVec_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Kernel.PairiiVec_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> std::vector<(std::pair<(int,int)>)>::allocator_type"""
        return _Kernel.PairiiVec_get_allocator(self)

    def begin(self):
        """begin(self) -> std::vector<(std::pair<(int,int)>)>::const_iterator"""
        return _Kernel.PairiiVec_begin(self)

    def end(self):
        """end(self) -> std::vector<(std::pair<(int,int)>)>::const_iterator"""
        return _Kernel.PairiiVec_end(self)

    def rbegin(self):
        """rbegin(self) -> std::vector<(std::pair<(int,int)>)>::const_reverse_iterator"""
        return _Kernel.PairiiVec_rbegin(self)

    def rend(self):
        """rend(self) -> std::vector<(std::pair<(int,int)>)>::const_reverse_iterator"""
        return _Kernel.PairiiVec_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Kernel.PairiiVec_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> std::vector<(std::pair<(int,int)>)>::iterator
        erase(self, first, last) -> std::vector<(std::pair<(int,int)>)>::iterator
        """
        return _Kernel.PairiiVec_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> PairiiVec
        __init__(self, arg0) -> PairiiVec
        __init__(self, size) -> PairiiVec
        __init__(self, size, value) -> PairiiVec
        """
        this = _Kernel.new_PairiiVec(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Kernel.PairiiVec_push_back(self, *args)

    def front(self):
        """front(self) -> std::vector<(std::pair<(int,int)>)>::value_type"""
        return _Kernel.PairiiVec_front(self)

    def back(self):
        """back(self) -> std::vector<(std::pair<(int,int)>)>::value_type"""
        return _Kernel.PairiiVec_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Kernel.PairiiVec_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Kernel.PairiiVec_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> std::vector<(std::pair<(int,int)>)>::iterator
        insert(self, pos, n, x)
        """
        return _Kernel.PairiiVec_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Kernel.PairiiVec_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> std::vector<(std::pair<(int,int)>)>::size_type"""
        return _Kernel.PairiiVec_capacity(self)

    __swig_destroy__ = _Kernel.delete_PairiiVec
    __del__ = lambda self : None;
PairiiVec_swigregister = _Kernel.PairiiVec_swigregister
PairiiVec_swigregister(PairiiVec)



