# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""
The `Library` module gathers all miscellaneous Objects in the SHOGUN toolkit.
"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Library', [dirname(__file__)])
        except ImportError:
            import _Library
            return _Library
        if fp is not None:
            try:
                _mod = imp.load_module('_Library', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Library = swig_import_helper()
    del swig_import_helper
else:
    import _Library
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class ShogunException(_object):
    """
    Class ShogunException defines an exception which is thrown whenever an
    error inside of shogun occurs.

    C++ includes: ShogunException.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShogunException, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ShogunException, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, str) -> ShogunException

        constructor

        Parameters:
        -----------

        str:  exception string 
        """
        this = _Library.new_ShogunException(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShogunException
    __del__ = lambda self : None;
    def get_exception_string(self):
        """
        get_exception_string(self) -> str

        get exception string

        the exception string 
        """
        return _Library.ShogunException_get_exception_string(self)

ShogunException_swigregister = _Library.ShogunException_swigregister
ShogunException_swigregister(ShogunException)

MSG_GCDEBUG = _Library.MSG_GCDEBUG
MSG_DEBUG = _Library.MSG_DEBUG
MSG_INFO = _Library.MSG_INFO
MSG_NOTICE = _Library.MSG_NOTICE
MSG_WARN = _Library.MSG_WARN
MSG_ERROR = _Library.MSG_ERROR
MSG_CRITICAL = _Library.MSG_CRITICAL
MSG_ALERT = _Library.MSG_ALERT
MSG_EMERGENCY = _Library.MSG_EMERGENCY
MSG_MESSAGEONLY = _Library.MSG_MESSAGEONLY
class IO(_object):
    """
    Class IO, used to do input output operations throughout shogun.

    Any debug or error or progress message is passed through the functions
    of this class to be in the end written to the screen. Note that
    messages don't have to be written to stdout or stderr, but can be
    redirected to a file.

    C++ includes: io.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IO, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IO, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IO
        __init__(self, orig) -> IO

        copy constructor 
        """
        this = _Library.new_IO(*args)
        try: self.this.append(this)
        except: self.this = this
    def set_loglevel(self, *args):
        """
        set_loglevel(self, level)

        set loglevel

        Parameters:
        -----------

        level:  level of log messages 
        """
        return _Library.IO_set_loglevel(self, *args)

    def get_loglevel(self):
        """
        get_loglevel(self) -> EMessageType

        get loglevel

        level of log messages 
        """
        return _Library.IO_get_loglevel(self)

    def get_show_progress(self):
        """
        get_show_progress(self) -> bool

        get show_progress

        if progress bar is shown 
        """
        return _Library.IO_get_show_progress(self)

    def get_show_file_and_line(self):
        """
        get_show_file_and_line(self) -> bool

        get show file and line

        if file and line should prefix messages 
        """
        return _Library.IO_get_show_file_and_line(self)

    def get_syntax_highlight(self):
        """
        get_syntax_highlight(self) -> bool

        get syntax highlight

        if syntax highlighting is enabled 
        """
        return _Library.IO_get_syntax_highlight(self)

    def message(self, *args):
        """
        message(self, prio, file, line, fmt, *args)

        print a message

        optionally prefixed with file name and line number from (use -1 in
        line to disable this)

        Parameters:
        -----------

        prio:  message priority

        file:  file name from where the message is called

        line:  line number from where the message is called

        fmt:  format string 
        """
        return _Library.IO_message(self, *args)

    def progress(self, *args):
        """
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        progress(self, current_val, min_val = 0.0, max_val = 1.0, decimals = 1)
        progress(self, current_val, min_val = 0.0, max_val = 1.0)
        progress(self, current_val, min_val = 0.0)
        progress(self, current_val)

        print progress bar

        Parameters:
        -----------

        current_val:  current value

        min_val:  minimum value

        max_val:  maximum value

        decimals:  decimals

        prefix:  message prefix 
        """
        return _Library.IO_progress(self, *args)

    def absolute_progress(self, *args):
        """
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1, 
            prefix = "PROGRESS:\t")
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0, decimals = 1)
        absolute_progress(self, current_val, val, min_val = 0.0, max_val = 1.0)
        absolute_progress(self, current_val, val, min_val = 0.0)
        absolute_progress(self, current_val, val)

        print absolute progress bar

        Parameters:
        -----------

        current_val:  current value

        val:  value

        min_val:  minimum value

        max_val:  maximum value

        decimals:  decimals

        prefix:  message prefix 
        """
        return _Library.IO_absolute_progress(self, *args)

    def done(self):
        """
        done(self)

        print 'done' with priority INFO, but only if progress bar is enabled

        """
        return _Library.IO_done(self)

    def not_implemented(self, *args):
        """
        not_implemented(self, file, line)

        print error message 'not implemented' 
        """
        return _Library.IO_not_implemented(self, *args)

    def deprecated(self, *args):
        """
        deprecated(self, file, line)

        print warning message 'function deprecated' 
        """
        return _Library.IO_deprecated(self, *args)

    def buffered_message(self, *args):
        """
        buffered_message(self, prio, fmt, *args)

        print a buffered message

        Parameters:
        -----------

        prio:  message priority

        fmt:  format string 
        """
        return _Library.IO_buffered_message(self, *args)

    def skip_spaces(*args):
        """skip_spaces(str) -> str"""
        return _Library.IO_skip_spaces(*args)

    if _newclass:skip_spaces = staticmethod(skip_spaces)
    __swig_getmethods__["skip_spaces"] = lambda x: skip_spaces
    def skip_blanks(*args):
        """skip_blanks(str) -> str"""
        return _Library.IO_skip_blanks(*args)

    if _newclass:skip_blanks = staticmethod(skip_blanks)
    __swig_getmethods__["skip_blanks"] = lambda x: skip_blanks
    def get_target(self):
        """
        get_target(self) -> FILE

        get target

        file descriptor for target 
        """
        return _Library.IO_get_target(self)

    def set_target(self, *args):
        """
        set_target(self, target)

        set target

        Parameters:
        -----------

        target:  file descriptor for target 
        """
        return _Library.IO_set_target(self, *args)

    def set_target_to_stderr(self):
        """
        set_target_to_stderr(self)

        set target to stderr 
        """
        return _Library.IO_set_target_to_stderr(self)

    def set_target_to_stdout(self):
        """
        set_target_to_stdout(self)

        set target to stdout 
        """
        return _Library.IO_set_target_to_stdout(self)

    def enable_progress(self):
        """
        enable_progress(self)

        enable progress bar 
        """
        return _Library.IO_enable_progress(self)

    def disable_progress(self):
        """
        disable_progress(self)

        disable progress bar 
        """
        return _Library.IO_disable_progress(self)

    def enable_file_and_line(self):
        """
        enable_file_and_line(self)

        enable displaying of file and line when printing messages 
        """
        return _Library.IO_enable_file_and_line(self)

    def disable_file_and_line(self):
        """
        disable_file_and_line(self)

        disable displaying of file and line when printing messages 
        """
        return _Library.IO_disable_file_and_line(self)

    def enable_syntax_highlighting(self):
        """
        enable_syntax_highlighting(self)

        enable syntax highlighting 
        """
        return _Library.IO_enable_syntax_highlighting(self)

    def disable_syntax_highlighting(self):
        """
        disable_syntax_highlighting(self)

        disable syntax highlighting 
        """
        return _Library.IO_disable_syntax_highlighting(self)

    def set_dirname(*args):
        """set_dirname(dirname)"""
        return _Library.IO_set_dirname(*args)

    if _newclass:set_dirname = staticmethod(set_dirname)
    __swig_getmethods__["set_dirname"] = lambda x: set_dirname
    def concat_filename(*args):
        """concat_filename(filename) -> str"""
        return _Library.IO_concat_filename(*args)

    if _newclass:concat_filename = staticmethod(concat_filename)
    __swig_getmethods__["concat_filename"] = lambda x: concat_filename
    def filter(*args):
        """filter(d) -> int"""
        return _Library.IO_filter(*args)

    if _newclass:filter = staticmethod(filter)
    __swig_getmethods__["filter"] = lambda x: filter
    def ref(self):
        """
        ref(self) ->  int

        increase reference counter

        reference count 
        """
        return _Library.IO_ref(self)

    def ref_count(self):
        """
        ref_count(self) ->  int

        display reference counter

        reference count 
        """
        return _Library.IO_ref_count(self)

    def unref(self):
        """
        unref(self) ->  int

        decrement reference counter and deallocate object if refcount is zero
        before or after decrementing it

        reference count 
        """
        return _Library.IO_unref(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.IO_get_name(self)

    __swig_destroy__ = _Library.delete_IO
    __del__ = lambda self : None;
IO_swigregister = _Library.IO_swigregister
IO_swigregister(IO)
cvar = _Library.cvar

def IO_skip_spaces(*args):
  """IO_skip_spaces(str) -> str"""
  return _Library.IO_skip_spaces(*args)

def IO_skip_blanks(*args):
  """IO_skip_blanks(str) -> str"""
  return _Library.IO_skip_blanks(*args)

def IO_set_dirname(*args):
  """IO_set_dirname(dirname)"""
  return _Library.IO_set_dirname(*args)

def IO_concat_filename(*args):
  """IO_concat_filename(filename) -> str"""
  return _Library.IO_concat_filename(*args)

def IO_filter(*args):
  """IO_filter(d) -> int"""
  return _Library.IO_filter(*args)

class SGObject(_object):
    """Proxy of C++ shogun::CSGObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SGObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SGObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Library.delete_SGObject
    __del__ = lambda self : None;
    def ref(self):
        """ref(self) ->  int"""
        return _Library.SGObject_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Library.SGObject_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Library.SGObject_unref(self)

    def get_name(self):
        """get_name(self) -> str"""
        return _Library.SGObject_get_name(self)

    def set_io(self, *args):
        """set_io(self, io)"""
        return _Library.SGObject_set_io(self, *args)

    def get_io(self):
        """get_io(self) -> IO"""
        return _Library.SGObject_get_io(self)

    def set_parallel(self, *args):
        """set_parallel(self, parallel)"""
        return _Library.SGObject_set_parallel(self, *args)

    def get_parallel(self):
        """get_parallel(self) -> Parallel"""
        return _Library.SGObject_get_parallel(self)

    def set_version(self, *args):
        """set_version(self, version)"""
        return _Library.SGObject_set_version(self, *args)

    def get_version(self):
        """get_version(self) -> Version"""
        return _Library.SGObject_get_version(self)

    __swig_setmethods__["io"] = _Library.SGObject_io_set
    __swig_getmethods__["io"] = _Library.SGObject_io_get
    if _newclass:io = _swig_property(_Library.SGObject_io_get, _Library.SGObject_io_set)
    __swig_setmethods__["parallel"] = _Library.SGObject_parallel_set
    __swig_getmethods__["parallel"] = _Library.SGObject_parallel_get
    if _newclass:parallel = _swig_property(_Library.SGObject_parallel_get, _Library.SGObject_parallel_set)
    __swig_setmethods__["version"] = _Library.SGObject_version_set
    __swig_getmethods__["version"] = _Library.SGObject_version_get
    if _newclass:version = _swig_property(_Library.SGObject_version_get, _Library.SGObject_version_set)
SGObject_swigregister = _Library.SGObject_swigregister
SGObject_swigregister(SGObject)

class Version(_object):
    """Proxy of C++ shogun::CVersion class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Version, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Version, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> Version"""
        this = _Library.new_Version()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Version
    __del__ = lambda self : None;
    def print_version():
        """print_version()"""
        return _Library.Version_print_version()

    if _newclass:print_version = staticmethod(print_version)
    __swig_getmethods__["print_version"] = lambda x: print_version
    def get_version_extra():
        """get_version_extra() -> str"""
        return _Library.Version_get_version_extra()

    if _newclass:get_version_extra = staticmethod(get_version_extra)
    __swig_getmethods__["get_version_extra"] = lambda x: get_version_extra
    def get_version_release():
        """get_version_release() -> str"""
        return _Library.Version_get_version_release()

    if _newclass:get_version_release = staticmethod(get_version_release)
    __swig_getmethods__["get_version_release"] = lambda x: get_version_release
    def get_version_revision():
        """get_version_revision() ->  int"""
        return _Library.Version_get_version_revision()

    if _newclass:get_version_revision = staticmethod(get_version_revision)
    __swig_getmethods__["get_version_revision"] = lambda x: get_version_revision
    def get_version_year():
        """get_version_year() ->  int"""
        return _Library.Version_get_version_year()

    if _newclass:get_version_year = staticmethod(get_version_year)
    __swig_getmethods__["get_version_year"] = lambda x: get_version_year
    def get_version_month():
        """get_version_month() ->  int"""
        return _Library.Version_get_version_month()

    if _newclass:get_version_month = staticmethod(get_version_month)
    __swig_getmethods__["get_version_month"] = lambda x: get_version_month
    def get_version_day():
        """get_version_day() ->  int"""
        return _Library.Version_get_version_day()

    if _newclass:get_version_day = staticmethod(get_version_day)
    __swig_getmethods__["get_version_day"] = lambda x: get_version_day
    def get_version_hour():
        """get_version_hour() ->  int"""
        return _Library.Version_get_version_hour()

    if _newclass:get_version_hour = staticmethod(get_version_hour)
    __swig_getmethods__["get_version_hour"] = lambda x: get_version_hour
    def get_version_minute():
        """get_version_minute() ->  int"""
        return _Library.Version_get_version_minute()

    if _newclass:get_version_minute = staticmethod(get_version_minute)
    __swig_getmethods__["get_version_minute"] = lambda x: get_version_minute
    def get_version_in_minutes():
        """get_version_in_minutes() -> int"""
        return _Library.Version_get_version_in_minutes()

    if _newclass:get_version_in_minutes = staticmethod(get_version_in_minutes)
    __swig_getmethods__["get_version_in_minutes"] = lambda x: get_version_in_minutes
    def ref(self):
        """ref(self) ->  int"""
        return _Library.Version_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Library.Version_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Library.Version_unref(self)

Version_swigregister = _Library.Version_swigregister
Version_swigregister(Version)

def Version_print_version():
  """Version_print_version()"""
  return _Library.Version_print_version()

def Version_get_version_extra():
  """Version_get_version_extra() -> str"""
  return _Library.Version_get_version_extra()

def Version_get_version_release():
  """Version_get_version_release() -> str"""
  return _Library.Version_get_version_release()

def Version_get_version_revision():
  """Version_get_version_revision() ->  int"""
  return _Library.Version_get_version_revision()

def Version_get_version_year():
  """Version_get_version_year() ->  int"""
  return _Library.Version_get_version_year()

def Version_get_version_month():
  """Version_get_version_month() ->  int"""
  return _Library.Version_get_version_month()

def Version_get_version_day():
  """Version_get_version_day() ->  int"""
  return _Library.Version_get_version_day()

def Version_get_version_hour():
  """Version_get_version_hour() ->  int"""
  return _Library.Version_get_version_hour()

def Version_get_version_minute():
  """Version_get_version_minute() ->  int"""
  return _Library.Version_get_version_minute()

def Version_get_version_in_minutes():
  """Version_get_version_in_minutes() -> int"""
  return _Library.Version_get_version_in_minutes()

class Parallel(_object):
    """Proxy of C++ shogun::CParallel class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parallel, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Parallel, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Parallel
        __init__(self, orig) -> Parallel
        """
        this = _Library.new_Parallel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Parallel
    __del__ = lambda self : None;
    def get_num_cpus(self):
        """get_num_cpus(self) ->  int"""
        return _Library.Parallel_get_num_cpus(self)

    def set_num_threads(self, *args):
        """set_num_threads(self, n)"""
        return _Library.Parallel_set_num_threads(self, *args)

    def get_num_threads(self):
        """get_num_threads(self) ->  int"""
        return _Library.Parallel_get_num_threads(self)

    def ref(self):
        """ref(self) ->  int"""
        return _Library.Parallel_ref(self)

    def ref_count(self):
        """ref_count(self) ->  int"""
        return _Library.Parallel_ref_count(self)

    def unref(self):
        """unref(self) ->  int"""
        return _Library.Parallel_unref(self)

Parallel_swigregister = _Library.Parallel_swigregister
Parallel_swigregister(Parallel)

class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Library.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self):
        """value(self) -> PyObject"""
        return _Library.SwigPyIterator_value(self)

    def incr(self, n = 1):
        """
        incr(self, n = 1) -> SwigPyIterator
        incr(self) -> SwigPyIterator
        """
        return _Library.SwigPyIterator_incr(self, n)

    def decr(self, n = 1):
        """
        decr(self, n = 1) -> SwigPyIterator
        decr(self) -> SwigPyIterator
        """
        return _Library.SwigPyIterator_decr(self, n)

    def distance(self, *args):
        """distance(self, x) -> ptrdiff_t"""
        return _Library.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(self, x) -> bool"""
        return _Library.SwigPyIterator_equal(self, *args)

    def copy(self):
        """copy(self) -> SwigPyIterator"""
        return _Library.SwigPyIterator_copy(self)

    def next(self):
        """next(self) -> PyObject"""
        return _Library.SwigPyIterator_next(self)

    def __next__(self):
        """__next__(self) -> PyObject"""
        return _Library.SwigPyIterator___next__(self)

    def previous(self):
        """previous(self) -> PyObject"""
        return _Library.SwigPyIterator_previous(self)

    def advance(self, *args):
        """advance(self, n) -> SwigPyIterator"""
        return _Library.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(self, x) -> bool"""
        return _Library.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(self, x) -> bool"""
        return _Library.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(self, n) -> SwigPyIterator"""
        return _Library.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(self, n) -> SwigPyIterator"""
        return _Library.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(self, n) -> SwigPyIterator"""
        return _Library.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(self, n) -> SwigPyIterator
        __sub__(self, x) -> ptrdiff_t
        """
        return _Library.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = _Library.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

class IntVector(_object):
    """Proxy of C++ std::vector<(int32_t)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IntVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Library.IntVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Library.IntVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Library.IntVector___bool__(self)

    def __len__(self):
        """__len__(self) -> std::vector<(int)>::size_type"""
        return _Library.IntVector___len__(self)

    def pop(self):
        """pop(self) -> std::vector<(int)>::value_type"""
        return _Library.IntVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> IntVector"""
        return _Library.IntVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Library.IntVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Library.IntVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Library.IntVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> IntVector
        __getitem__(self, i) -> std::vector<(int)>::value_type
        """
        return _Library.IntVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Library.IntVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Library.IntVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Library.IntVector_empty(self)

    def size(self):
        """size(self) -> std::vector<(int)>::size_type"""
        return _Library.IntVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Library.IntVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Library.IntVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> std::vector<(int)>::allocator_type"""
        return _Library.IntVector_get_allocator(self)

    def begin(self):
        """begin(self) -> std::vector<(int)>::const_iterator"""
        return _Library.IntVector_begin(self)

    def end(self):
        """end(self) -> std::vector<(int)>::const_iterator"""
        return _Library.IntVector_end(self)

    def rbegin(self):
        """rbegin(self) -> std::vector<(int)>::const_reverse_iterator"""
        return _Library.IntVector_rbegin(self)

    def rend(self):
        """rend(self) -> std::vector<(int)>::const_reverse_iterator"""
        return _Library.IntVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Library.IntVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> std::vector<(int)>::iterator
        erase(self, first, last) -> std::vector<(int)>::iterator
        """
        return _Library.IntVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> IntVector
        __init__(self, arg0) -> IntVector
        __init__(self, size) -> IntVector
        __init__(self, size, value) -> IntVector
        """
        this = _Library.new_IntVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Library.IntVector_push_back(self, *args)

    def front(self):
        """front(self) -> std::vector<(int)>::value_type"""
        return _Library.IntVector_front(self)

    def back(self):
        """back(self) -> std::vector<(int)>::value_type"""
        return _Library.IntVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Library.IntVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Library.IntVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> std::vector<(int)>::iterator
        insert(self, pos, n, x)
        """
        return _Library.IntVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Library.IntVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> std::vector<(int)>::size_type"""
        return _Library.IntVector_capacity(self)

    __swig_destroy__ = _Library.delete_IntVector
    __del__ = lambda self : None;
IntVector_swigregister = _Library.IntVector_swigregister
IntVector_swigregister(IntVector)

class DoubleVector(_object):
    """Proxy of C++ std::vector<(float64_t)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DoubleVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DoubleVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Library.DoubleVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Library.DoubleVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Library.DoubleVector___bool__(self)

    def __len__(self):
        """__len__(self) -> std::vector<(double)>::size_type"""
        return _Library.DoubleVector___len__(self)

    def pop(self):
        """pop(self) -> std::vector<(double)>::value_type"""
        return _Library.DoubleVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> DoubleVector"""
        return _Library.DoubleVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Library.DoubleVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Library.DoubleVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Library.DoubleVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> DoubleVector
        __getitem__(self, i) -> std::vector<(double)>::value_type
        """
        return _Library.DoubleVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Library.DoubleVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Library.DoubleVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Library.DoubleVector_empty(self)

    def size(self):
        """size(self) -> std::vector<(double)>::size_type"""
        return _Library.DoubleVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Library.DoubleVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Library.DoubleVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> std::vector<(double)>::allocator_type"""
        return _Library.DoubleVector_get_allocator(self)

    def begin(self):
        """begin(self) -> std::vector<(double)>::const_iterator"""
        return _Library.DoubleVector_begin(self)

    def end(self):
        """end(self) -> std::vector<(double)>::const_iterator"""
        return _Library.DoubleVector_end(self)

    def rbegin(self):
        """rbegin(self) -> std::vector<(double)>::const_reverse_iterator"""
        return _Library.DoubleVector_rbegin(self)

    def rend(self):
        """rend(self) -> std::vector<(double)>::const_reverse_iterator"""
        return _Library.DoubleVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Library.DoubleVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> std::vector<(double)>::iterator
        erase(self, first, last) -> std::vector<(double)>::iterator
        """
        return _Library.DoubleVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> DoubleVector
        __init__(self, arg0) -> DoubleVector
        __init__(self, size) -> DoubleVector
        __init__(self, size, value) -> DoubleVector
        """
        this = _Library.new_DoubleVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Library.DoubleVector_push_back(self, *args)

    def front(self):
        """front(self) -> std::vector<(double)>::value_type"""
        return _Library.DoubleVector_front(self)

    def back(self):
        """back(self) -> std::vector<(double)>::value_type"""
        return _Library.DoubleVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Library.DoubleVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Library.DoubleVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> std::vector<(double)>::iterator
        insert(self, pos, n, x)
        """
        return _Library.DoubleVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Library.DoubleVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> std::vector<(double)>::size_type"""
        return _Library.DoubleVector_capacity(self)

    __swig_destroy__ = _Library.delete_DoubleVector
    __del__ = lambda self : None;
DoubleVector_swigregister = _Library.DoubleVector_swigregister
DoubleVector_swigregister(DoubleVector)

class StringVector(_object):
    """Proxy of C++ std::vector<(std::string)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, StringVector, name)
    __repr__ = _swig_repr
    def iterator(self):
        """iterator(self) -> SwigPyIterator"""
        return _Library.StringVector_iterator(self)

    def __iter__(self): return self.iterator()
    def __nonzero__(self):
        """__nonzero__(self) -> bool"""
        return _Library.StringVector___nonzero__(self)

    def __bool__(self):
        """__bool__(self) -> bool"""
        return _Library.StringVector___bool__(self)

    def __len__(self):
        """__len__(self) -> size_type"""
        return _Library.StringVector___len__(self)

    def pop(self):
        """pop(self) -> value_type"""
        return _Library.StringVector_pop(self)

    def __getslice__(self, *args):
        """__getslice__(self, i, j) -> StringVector"""
        return _Library.StringVector___getslice__(self, *args)

    def __setslice__(self, *args):
        """__setslice__(self, i, j, v)"""
        return _Library.StringVector___setslice__(self, *args)

    def __delslice__(self, *args):
        """__delslice__(self, i, j)"""
        return _Library.StringVector___delslice__(self, *args)

    def __delitem__(self, *args):
        """
        __delitem__(self, i)
        __delitem__(self, slice)
        """
        return _Library.StringVector___delitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, slice) -> StringVector
        __getitem__(self, i) -> value_type
        """
        return _Library.StringVector___getitem__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, slice, v)
        __setitem__(self, i, x)
        """
        return _Library.StringVector___setitem__(self, *args)

    def append(self, *args):
        """append(self, x)"""
        return _Library.StringVector_append(self, *args)

    def empty(self):
        """empty(self) -> bool"""
        return _Library.StringVector_empty(self)

    def size(self):
        """size(self) -> size_type"""
        return _Library.StringVector_size(self)

    def clear(self):
        """clear(self)"""
        return _Library.StringVector_clear(self)

    def swap(self, *args):
        """swap(self, v)"""
        return _Library.StringVector_swap(self, *args)

    def get_allocator(self):
        """get_allocator(self) -> allocator_type"""
        return _Library.StringVector_get_allocator(self)

    def begin(self):
        """begin(self) -> const_iterator"""
        return _Library.StringVector_begin(self)

    def end(self):
        """end(self) -> const_iterator"""
        return _Library.StringVector_end(self)

    def rbegin(self):
        """rbegin(self) -> const_reverse_iterator"""
        return _Library.StringVector_rbegin(self)

    def rend(self):
        """rend(self) -> const_reverse_iterator"""
        return _Library.StringVector_rend(self)

    def pop_back(self):
        """pop_back(self)"""
        return _Library.StringVector_pop_back(self)

    def erase(self, *args):
        """
        erase(self, pos) -> iterator
        erase(self, first, last) -> iterator
        """
        return _Library.StringVector_erase(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> StringVector
        __init__(self, arg0) -> StringVector
        __init__(self, size) -> StringVector
        __init__(self, size, value) -> StringVector
        """
        this = _Library.new_StringVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def push_back(self, *args):
        """push_back(self, x)"""
        return _Library.StringVector_push_back(self, *args)

    def front(self):
        """front(self) -> value_type"""
        return _Library.StringVector_front(self)

    def back(self):
        """back(self) -> value_type"""
        return _Library.StringVector_back(self)

    def assign(self, *args):
        """assign(self, n, x)"""
        return _Library.StringVector_assign(self, *args)

    def resize(self, *args):
        """
        resize(self, new_size)
        resize(self, new_size, x)
        """
        return _Library.StringVector_resize(self, *args)

    def insert(self, *args):
        """
        insert(self, pos, x) -> iterator
        insert(self, pos, n, x)
        """
        return _Library.StringVector_insert(self, *args)

    def reserve(self, *args):
        """reserve(self, n)"""
        return _Library.StringVector_reserve(self, *args)

    def capacity(self):
        """capacity(self) -> size_type"""
        return _Library.StringVector_capacity(self)

    __swig_destroy__ = _Library.delete_StringVector
    __del__ = lambda self : None;
StringVector_swigregister = _Library.StringVector_swigregister
StringVector_swigregister(StringVector)

class DynamicCharArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicCharArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicCharArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicCharArray
        __init__(self) -> DynamicCharArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicCharArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicCharArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicCharArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicCharArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicCharArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> str

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicCharArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> str

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicCharArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicCharArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicCharArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicCharArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicCharArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicCharArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicCharArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicCharArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicCharArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicCharArray_clear_array(self)

DynamicCharArray_swigregister = _Library.DynamicCharArray_swigregister
DynamicCharArray_swigregister(DynamicCharArray)

class DynamicByteArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicByteArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicByteArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicByteArray
        __init__(self) -> DynamicByteArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicByteArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicByteArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicByteArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicByteArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicByteArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned str

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicByteArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned str

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicByteArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicByteArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicByteArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicByteArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicByteArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicByteArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicByteArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicByteArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicByteArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicByteArray_clear_array(self)

DynamicByteArray_swigregister = _Library.DynamicByteArray_swigregister
DynamicByteArray_swigregister(DynamicByteArray)

class DynamicShortArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicShortArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicShortArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicShortArray
        __init__(self) -> DynamicShortArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicShortArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicShortArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicShortArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicShortArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicShortArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> short

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicShortArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> short

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicShortArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicShortArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicShortArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicShortArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicShortArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicShortArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicShortArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicShortArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicShortArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicShortArray_clear_array(self)

DynamicShortArray_swigregister = _Library.DynamicShortArray_swigregister
DynamicShortArray_swigregister(DynamicShortArray)

class DynamicWordArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicWordArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicWordArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicWordArray
        __init__(self) -> DynamicWordArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicWordArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicWordArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicWordArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicWordArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicWordArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned short

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicWordArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned short

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicWordArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicWordArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicWordArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicWordArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicWordArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicWordArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicWordArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicWordArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicWordArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicWordArray_clear_array(self)

DynamicWordArray_swigregister = _Library.DynamicWordArray_swigregister
DynamicWordArray_swigregister(DynamicWordArray)

class DynamicIntArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicIntArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicIntArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicIntArray
        __init__(self) -> DynamicIntArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicIntArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicIntArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicIntArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicIntArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicIntArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> int

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicIntArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> int

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicIntArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicIntArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicIntArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicIntArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicIntArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicIntArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicIntArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicIntArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicIntArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicIntArray_clear_array(self)

DynamicIntArray_swigregister = _Library.DynamicIntArray_swigregister
DynamicIntArray_swigregister(DynamicIntArray)

class DynamicUIntArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicUIntArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicUIntArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicUIntArray
        __init__(self) -> DynamicUIntArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicUIntArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicUIntArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicUIntArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicUIntArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicUIntArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned int

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicUIntArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned int

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicUIntArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicUIntArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicUIntArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicUIntArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicUIntArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicUIntArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicUIntArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicUIntArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicUIntArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicUIntArray_clear_array(self)

DynamicUIntArray_swigregister = _Library.DynamicUIntArray_swigregister
DynamicUIntArray_swigregister(DynamicUIntArray)

class DynamicLongArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicLongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicLongArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicLongArray
        __init__(self) -> DynamicLongArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicLongArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicLongArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicLongArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicLongArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicLongArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> long long

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicLongArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> long long

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicLongArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicLongArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicLongArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicLongArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicLongArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicLongArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicLongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicLongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicLongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicLongArray_clear_array(self)

DynamicLongArray_swigregister = _Library.DynamicLongArray_swigregister
DynamicLongArray_swigregister(DynamicLongArray)

class DynamicULongArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicULongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicULongArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicULongArray
        __init__(self) -> DynamicULongArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicULongArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicULongArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicULongArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicULongArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicULongArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned long long

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicULongArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> unsigned long long

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicULongArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicULongArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicULongArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicULongArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicULongArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicULongArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicULongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicULongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicULongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicULongArray_clear_array(self)

DynamicULongArray_swigregister = _Library.DynamicULongArray_swigregister
DynamicULongArray_swigregister(DynamicULongArray)

class DynamicShortRealArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicShortRealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicShortRealArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicShortRealArray
        __init__(self) -> DynamicShortRealArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicShortRealArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicShortRealArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicShortRealArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicShortRealArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicShortRealArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicShortRealArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> float

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicShortRealArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicShortRealArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicShortRealArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicShortRealArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicShortRealArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicShortRealArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicShortRealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicShortRealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicShortRealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicShortRealArray_clear_array(self)

DynamicShortRealArray_swigregister = _Library.DynamicShortRealArray_swigregister
DynamicShortRealArray_swigregister(DynamicShortRealArray)

class DynamicRealArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicRealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicRealArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicRealArray
        __init__(self) -> DynamicRealArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicRealArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicRealArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicRealArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicRealArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicRealArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicRealArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> float

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicRealArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicRealArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicRealArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicRealArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicRealArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicRealArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicRealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicRealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicRealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicRealArray_clear_array(self)

DynamicRealArray_swigregister = _Library.DynamicRealArray_swigregister
DynamicRealArray_swigregister(DynamicRealArray)

class DynamicPlifArray(SGObject):
    """
    Template Dynamic array class that creates an array that can be used
    like a list or an array.

    It grows and shrinks dynamically, while elements can be accessed via
    index. It is performance tuned for simple types like float etc. and
    for hi-level objects only stores pointers, which are not automagically
    SG_REF'd/deleted.

    C++ includes: DynamicArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicPlifArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicPlifArray, name)
    __repr__ = _swig_repr
    def __init__(self, p_resize_granularity = 128): 
        """
        __init__(self, p_resize_granularity = 128) -> DynamicPlifArray
        __init__(self) -> DynamicPlifArray

        constructor

        Parameters:
        -----------

        p_resize_granularity:  resize granularity 
        """
        this = _Library.new_DynamicPlifArray(p_resize_granularity)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DynamicPlifArray
    __del__ = lambda self : None;
    def set_granularity(self, *args):
        """
        set_granularity(self, g) ->  int

        set the resize granularity

        Parameters:
        -----------

        g:  new granularity

        what has been set (minimum is 128) 
        """
        return _Library.DynamicPlifArray_set_granularity(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size (including granularity buffer) 
        """
        return _Library.DynamicPlifArray_get_array_size(self)

    def get_num_elements(self):
        """
        get_num_elements(self) ->  int

        get number of elements

        number of elements 
        """
        return _Library.DynamicPlifArray_get_num_elements(self)

    def get_element(self, *args):
        """
        get_element(self, index) -> shogun::CPlifBase

        get array element at index

        (does NOT do bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicPlifArray_get_element(self, *args)

    def get_element_safe(self, *args):
        """
        get_element_safe(self, index) -> shogun::CPlifBase

        get array element at index

        (does bounds checking)

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.DynamicPlifArray_get_element_safe(self, *args)

    def set_element(self, *args):
        """
        set_element(self, element, index) -> bool

        set array element at index

        Parameters:
        -----------

        element:  element to set

        index:  index

        if setting was successful 
        """
        return _Library.DynamicPlifArray_set_element(self, *args)

    def insert_element(self, *args):
        """
        insert_element(self, element, index) -> bool

        insert array element at index

        Parameters:
        -----------

        element:  element to insert

        index:  index

        if setting was successful 
        """
        return _Library.DynamicPlifArray_insert_element(self, *args)

    def append_element(self, *args):
        """
        append_element(self, element) -> bool

        append array element to the end of array

        Parameters:
        -----------

        element:  element to append

        if setting was successful 
        """
        return _Library.DynamicPlifArray_append_element(self, *args)

    def find_element(self, *args):
        """
        find_element(self, element) ->  int

        find first occurence of array element and return its index or -1 if
        not available

        Parameters:
        -----------

        element:  element to search for

        index of element or -1 
        """
        return _Library.DynamicPlifArray_find_element(self, *args)

    def delete_element(self, *args):
        """
        delete_element(self, idx) -> bool

        delete array element at idx (does not call delete[] or the like)

        Parameters:
        -----------

        idx:  index

        if deleting was successful 
        """
        return _Library.DynamicPlifArray_delete_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize the array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.DynamicPlifArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> shogun::CPlifBase

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.DynamicPlifArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_num_elements, array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  new array

        p_num_elements:  last element index + 1

        array_size:  number of elements in array 
        """
        return _Library.DynamicPlifArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.DynamicPlifArray_clear_array(self)

DynamicPlifArray_swigregister = _Library.DynamicPlifArray_swigregister
DynamicPlifArray_swigregister(DynamicPlifArray)

class PlifGCArray(SGObject):
    """
    Template class GCArray implements a garbage collecting static array.

    This array is meant to be used for Shogun Objects ( CSGObject) only,
    as it deals with garbage collection, i.e. on read and array assignment
    the reference count is increased (and decreased on delete and
    overwriting elements).

    C++ includes: GCArray.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PlifGCArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PlifGCArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, sz) -> PlifGCArray

        Constructor

        Parameters:
        -----------

        sz:  length of array 
        """
        this = _Library.new_PlifGCArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_PlifGCArray
    __del__ = lambda self : None;
    def set(self, *args):
        """
        set(self, element, index)

        write access operator

        Parameters:
        -----------

        element:  - element to write

        index:  - index to write to 
        """
        return _Library.PlifGCArray_set(self, *args)

    def get(self, *args):
        """
        get(self, index) -> shogun::CPlifBase

        read only access operator

        Parameters:
        -----------

        index:  index to write to

        element element 
        """
        return _Library.PlifGCArray_get(self, *args)

PlifGCArray_swigregister = _Library.PlifGCArray_swigregister
PlifGCArray_swigregister(PlifGCArray)

class Hash(SGObject):
    """
    Collection of Hashing Functions.

    This class implements a number of hashing functions like crc32, md5
    and murmur.

    C++ includes: Hash.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Hash, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Hash, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Hash

        default constructor 
        """
        this = _Library.new_Hash()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Hash
    __del__ = lambda self : None;
    def crc32(*args):
        """crc32(data) -> int"""
        return _Library.Hash_crc32(*args)

    if _newclass:crc32 = staticmethod(crc32)
    __swig_getmethods__["crc32"] = lambda x: crc32
    def MD5(*args):
        """MD5(x, l, buf)"""
        return _Library.Hash_MD5(*args)

    if _newclass:MD5 = staticmethod(MD5)
    __swig_getmethods__["MD5"] = lambda x: MD5
    def MurmurHash2(*args):
        """MurmurHash2(data, seed) -> int"""
        return _Library.Hash_MurmurHash2(*args)

    if _newclass:MurmurHash2 = staticmethod(MurmurHash2)
    __swig_getmethods__["MurmurHash2"] = lambda x: MurmurHash2
    def IncrementalMurmurHash2(*args):
        """IncrementalMurmurHash2(data, h) -> int"""
        return _Library.Hash_IncrementalMurmurHash2(*args)

    if _newclass:IncrementalMurmurHash2 = staticmethod(IncrementalMurmurHash2)
    __swig_getmethods__["IncrementalMurmurHash2"] = lambda x: IncrementalMurmurHash2
Hash_swigregister = _Library.Hash_swigregister
Hash_swigregister(Hash)

def Hash_crc32(*args):
  """Hash_crc32(data) -> int"""
  return _Library.Hash_crc32(*args)

def Hash_MD5(*args):
  """Hash_MD5(x, l, buf)"""
  return _Library.Hash_MD5(*args)

def Hash_MurmurHash2(*args):
  """Hash_MurmurHash2(data, seed) -> int"""
  return _Library.Hash_MurmurHash2(*args)

def Hash_IncrementalMurmurHash2(*args):
  """Hash_IncrementalMurmurHash2(data, h) -> int"""
  return _Library.Hash_IncrementalMurmurHash2(*args)

class CharArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> CharArray
        __init__(self) -> CharArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> CharArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> CharArray
        __init__(self, p_array, p_array_size) -> CharArray
        __init__(self, p_array, p_array_size) -> CharArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_CharArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_CharArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.CharArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.CharArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.CharArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.CharArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.CharArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> str

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.CharArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.CharArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> str
        element(self, index) -> str
        element(self, p_array, index) -> str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.CharArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.CharArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> str

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.CharArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.CharArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.CharArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.CharArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.CharArray_display_array(self)

CharArray_swigregister = _Library.CharArray_swigregister
CharArray_swigregister(CharArray)

class ByteArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ByteArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> ByteArray
        __init__(self) -> ByteArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> ByteArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> ByteArray
        __init__(self, p_array, p_array_size) -> ByteArray
        __init__(self, p_array, p_array_size) -> ByteArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_ByteArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ByteArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ByteArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ByteArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ByteArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ByteArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ByteArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned str

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.ByteArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.ByteArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> unsigned str
        element(self, index) -> unsigned str
        element(self, p_array, index) -> unsigned str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.ByteArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.ByteArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned str

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.ByteArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.ByteArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.ByteArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ByteArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ByteArray_display_array(self)

ByteArray_swigregister = _Library.ByteArray_swigregister
ByteArray_swigregister(ByteArray)

class ShortArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> ShortArray
        __init__(self) -> ShortArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> ShortArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> ShortArray
        __init__(self, p_array, p_array_size) -> ShortArray
        __init__(self, p_array, p_array_size) -> ShortArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_ShortArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ShortArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ShortArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> short

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.ShortArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.ShortArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> short
        element(self, index) -> short
        element(self, p_array, index) -> short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.ShortArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.ShortArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> short

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.ShortArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.ShortArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.ShortArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortArray_display_array(self)

ShortArray_swigregister = _Library.ShortArray_swigregister
ShortArray_swigregister(ShortArray)

class WordArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> WordArray
        __init__(self) -> WordArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> WordArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> WordArray
        __init__(self, p_array, p_array_size) -> WordArray
        __init__(self, p_array, p_array_size) -> WordArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_WordArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_WordArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.WordArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.WordArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.WordArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.WordArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.WordArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned short

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.WordArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.WordArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> unsigned short
        element(self, index) -> unsigned short
        element(self, p_array, index) -> unsigned short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.WordArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.WordArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned short

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.WordArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.WordArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.WordArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.WordArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.WordArray_display_array(self)

WordArray_swigregister = _Library.WordArray_swigregister
WordArray_swigregister(WordArray)

class IntArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> IntArray
        __init__(self) -> IntArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> IntArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> IntArray
        __init__(self, p_array, p_array_size) -> IntArray
        __init__(self, p_array, p_array_size) -> IntArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_IntArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_IntArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.IntArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.IntArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.IntArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.IntArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.IntArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> int

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.IntArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.IntArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> int
        element(self, index) -> int
        element(self, p_array, index) -> int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.IntArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.IntArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> int

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.IntArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.IntArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.IntArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.IntArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.IntArray_display_array(self)

IntArray_swigregister = _Library.IntArray_swigregister
IntArray_swigregister(IntArray)

class UIntArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UIntArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UIntArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> UIntArray
        __init__(self) -> UIntArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> UIntArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> UIntArray
        __init__(self, p_array, p_array_size) -> UIntArray
        __init__(self, p_array, p_array_size) -> UIntArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_UIntArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_UIntArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.UIntArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.UIntArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.UIntArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.UIntArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.UIntArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned int

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.UIntArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.UIntArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> unsigned int
        element(self, index) -> unsigned int
        element(self, p_array, index) -> unsigned int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.UIntArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.UIntArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned int

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.UIntArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.UIntArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.UIntArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.UIntArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.UIntArray_display_array(self)

UIntArray_swigregister = _Library.UIntArray_swigregister
UIntArray_swigregister(UIntArray)

class LongArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LongArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> LongArray
        __init__(self) -> LongArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> LongArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> LongArray
        __init__(self, p_array, p_array_size) -> LongArray
        __init__(self, p_array, p_array_size) -> LongArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_LongArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_LongArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.LongArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.LongArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.LongArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.LongArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.LongArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> long long

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.LongArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.LongArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> long long
        element(self, index) -> long long
        element(self, p_array, index) -> long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.LongArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.LongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> long long

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.LongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.LongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.LongArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.LongArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.LongArray_display_array(self)

LongArray_swigregister = _Library.LongArray_swigregister
LongArray_swigregister(LongArray)

class ULongArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ULongArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> ULongArray
        __init__(self) -> ULongArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> ULongArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> ULongArray
        __init__(self, p_array, p_array_size) -> ULongArray
        __init__(self, p_array, p_array_size) -> ULongArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_ULongArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ULongArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ULongArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ULongArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ULongArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ULongArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ULongArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> unsigned long long

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.ULongArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.ULongArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> unsigned long long
        element(self, index) -> unsigned long long
        element(self, p_array, index) -> unsigned long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.ULongArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.ULongArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned long long

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.ULongArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.ULongArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.ULongArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ULongArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ULongArray_display_array(self)

ULongArray_swigregister = _Library.ULongArray_swigregister
ULongArray_swigregister(ULongArray)

class ShortRealArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> ShortRealArray
        __init__(self) -> ShortRealArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> ShortRealArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> ShortRealArray
        __init__(self, p_array, p_array_size) -> ShortRealArray
        __init__(self, p_array, p_array_size) -> ShortRealArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_ShortRealArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortRealArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortRealArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ShortRealArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.ShortRealArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortRealArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortRealArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.ShortRealArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.ShortRealArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> float
        element(self, index) -> float
        element(self, p_array, index) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.ShortRealArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.ShortRealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.ShortRealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.ShortRealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.ShortRealArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortRealArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortRealArray_display_array(self)

ShortRealArray_swigregister = _Library.ShortRealArray_swigregister
ShortRealArray_swigregister(ShortRealArray)

class RealArray(SGObject):
    """
    Template class Array implements a dense one dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance array implementation without
    error checking.

    C++ includes: Array.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealArray, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealArray, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, initial_size = 1) -> RealArray
        __init__(self) -> RealArray
        __init__(self, p_array, p_array_size, p_free_array = True, p_copy_array = False) -> RealArray
        __init__(self, p_array, p_array_size, p_free_array = True) -> RealArray
        __init__(self, p_array, p_array_size) -> RealArray
        __init__(self, p_array, p_array_size) -> RealArray

        constructor

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        this = _Library.new_RealArray(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_RealArray
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.RealArray_set_name(self, *args)

    def get_array_size(self):
        """
        get_array_size(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.RealArray_get_array_size(self)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get array size (including granularity buffer)

        total array size 
        """
        return _Library.RealArray_get_dim1(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.RealArray_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.RealArray_set_const(self, *args)

    def get_element(self, *args):
        """
        get_element(self, index) -> float

        get array element at index

        Parameters:
        -----------

        index:  index

        array element at index 
        """
        return _Library.RealArray_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, index) -> bool

        set array element at index 'index' return false in case of trouble

        Parameters:
        -----------

        p_element:  array element to set

        index:  index

        if setting was successful 
        """
        return _Library.RealArray_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1) -> float
        element(self, index) -> float
        element(self, p_array, index) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        index:  index

        element of given array at given index 
        """
        return _Library.RealArray_element(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, n) -> bool

        resize array

        Parameters:
        -----------

        n:  new size

        if resizing was successful 
        """
        return _Library.RealArray_resize_array(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        call get_array just before messing with it DO NOT call any
        [],resize/delete functions after get_array(), the pointer may become
        invalid!

        the array 
        """
        return _Library.RealArray_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, p_array_size, p_free_array = True, copy_array = False)
        set_array(self, p_array, p_array_size, p_free_array = True)
        set_array(self, p_array, p_array_size)
        set_array(self, p_array, p_array_size)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        p_array_size:  size of another array 
        """
        return _Library.RealArray_set_array(self, *args)

    def clear_array(self):
        """
        clear_array(self)

        clear the array (with zeros) 
        """
        return _Library.RealArray_clear_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.RealArray_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.RealArray_display_array(self)

RealArray_swigregister = _Library.RealArray_swigregister
RealArray_swigregister(RealArray)

class CharArray2(CharArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [CharArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [CharArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> CharArray2
        __init__(self, dim1 = 1) -> CharArray2
        __init__(self) -> CharArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> CharArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> CharArray2
        __init__(self, p_array, dim1, dim2) -> CharArray2
        __init__(self, p_array, dim1, dim2) -> CharArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_CharArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_CharArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.CharArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.CharArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.CharArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.CharArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.CharArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.CharArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.CharArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.CharArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.CharArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> str

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.CharArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.CharArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> str
        element(self, idx1, idx2) -> str
        element(self, p_array, idx1, idx2) -> str
        element(self, p_array, idx1, idx2, p_dim1_size) -> str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.CharArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.CharArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.CharArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.CharArray2_get_name(self)

CharArray2_swigregister = _Library.CharArray2_swigregister
CharArray2_swigregister(CharArray2)

class ByteArray2(ByteArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [ByteArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [ByteArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ByteArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> ByteArray2
        __init__(self, dim1 = 1) -> ByteArray2
        __init__(self) -> ByteArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> ByteArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> ByteArray2
        __init__(self, p_array, dim1, dim2) -> ByteArray2
        __init__(self, p_array, dim1, dim2) -> ByteArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_ByteArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ByteArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.ByteArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ByteArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ByteArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ByteArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ByteArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ByteArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ByteArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ByteArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.ByteArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> unsigned str

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.ByteArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.ByteArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> unsigned str
        element(self, idx1, idx2) -> unsigned str
        element(self, p_array, idx1, idx2) -> unsigned str
        element(self, p_array, idx1, idx2, p_dim1_size) -> unsigned str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.ByteArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ByteArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ByteArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ByteArray2_get_name(self)

ByteArray2_swigregister = _Library.ByteArray2_swigregister
ByteArray2_swigregister(ByteArray2)

class ShortArray2(ShortArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [ShortArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [ShortArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> ShortArray2
        __init__(self, dim1 = 1) -> ShortArray2
        __init__(self) -> ShortArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> ShortArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> ShortArray2
        __init__(self, p_array, dim1, dim2) -> ShortArray2
        __init__(self, p_array, dim1, dim2) -> ShortArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_ShortArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.ShortArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ShortArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ShortArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ShortArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ShortArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.ShortArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> short

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.ShortArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.ShortArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> short
        element(self, idx1, idx2) -> short
        element(self, p_array, idx1, idx2) -> short
        element(self, p_array, idx1, idx2, p_dim1_size) -> short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.ShortArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ShortArray2_get_name(self)

ShortArray2_swigregister = _Library.ShortArray2_swigregister
ShortArray2_swigregister(ShortArray2)

class WordArray2(WordArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [WordArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [WordArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> WordArray2
        __init__(self, dim1 = 1) -> WordArray2
        __init__(self) -> WordArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> WordArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> WordArray2
        __init__(self, p_array, dim1, dim2) -> WordArray2
        __init__(self, p_array, dim1, dim2) -> WordArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_WordArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_WordArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.WordArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.WordArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.WordArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.WordArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.WordArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.WordArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.WordArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.WordArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.WordArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> unsigned short

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.WordArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.WordArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> unsigned short
        element(self, idx1, idx2) -> unsigned short
        element(self, p_array, idx1, idx2) -> unsigned short
        element(self, p_array, idx1, idx2, p_dim1_size) -> unsigned short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.WordArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.WordArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.WordArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.WordArray2_get_name(self)

WordArray2_swigregister = _Library.WordArray2_swigregister
WordArray2_swigregister(WordArray2)

class IntArray2(IntArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [IntArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [IntArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> IntArray2
        __init__(self, dim1 = 1) -> IntArray2
        __init__(self) -> IntArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> IntArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> IntArray2
        __init__(self, p_array, dim1, dim2) -> IntArray2
        __init__(self, p_array, dim1, dim2) -> IntArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_IntArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_IntArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.IntArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.IntArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.IntArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.IntArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.IntArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.IntArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.IntArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.IntArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.IntArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> int

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.IntArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.IntArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> int
        element(self, idx1, idx2) -> int
        element(self, p_array, idx1, idx2) -> int
        element(self, p_array, idx1, idx2, p_dim1_size) -> int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.IntArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.IntArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.IntArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.IntArray2_get_name(self)

IntArray2_swigregister = _Library.IntArray2_swigregister
IntArray2_swigregister(IntArray2)

class UIntArray2(UIntArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [UIntArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UIntArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [UIntArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UIntArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> UIntArray2
        __init__(self, dim1 = 1) -> UIntArray2
        __init__(self) -> UIntArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> UIntArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> UIntArray2
        __init__(self, p_array, dim1, dim2) -> UIntArray2
        __init__(self, p_array, dim1, dim2) -> UIntArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_UIntArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_UIntArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.UIntArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.UIntArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.UIntArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.UIntArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.UIntArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.UIntArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.UIntArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.UIntArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.UIntArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> unsigned int

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.UIntArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.UIntArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> unsigned int
        element(self, idx1, idx2) -> unsigned int
        element(self, p_array, idx1, idx2) -> unsigned int
        element(self, p_array, idx1, idx2, p_dim1_size) -> unsigned int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.UIntArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.UIntArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.UIntArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.UIntArray2_get_name(self)

UIntArray2_swigregister = _Library.UIntArray2_swigregister
UIntArray2_swigregister(UIntArray2)

class LongArray2(LongArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [LongArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [LongArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LongArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> LongArray2
        __init__(self, dim1 = 1) -> LongArray2
        __init__(self) -> LongArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> LongArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> LongArray2
        __init__(self, p_array, dim1, dim2) -> LongArray2
        __init__(self, p_array, dim1, dim2) -> LongArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_LongArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_LongArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.LongArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.LongArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.LongArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.LongArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.LongArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.LongArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.LongArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.LongArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.LongArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> long long

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.LongArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.LongArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> long long
        element(self, idx1, idx2) -> long long
        element(self, p_array, idx1, idx2) -> long long
        element(self, p_array, idx1, idx2, p_dim1_size) -> long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.LongArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.LongArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.LongArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.LongArray2_get_name(self)

LongArray2_swigregister = _Library.LongArray2_swigregister
LongArray2_swigregister(LongArray2)

class ULongArray2(ULongArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [ULongArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [ULongArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ULongArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> ULongArray2
        __init__(self, dim1 = 1) -> ULongArray2
        __init__(self) -> ULongArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> ULongArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> ULongArray2
        __init__(self, p_array, dim1, dim2) -> ULongArray2
        __init__(self, p_array, dim1, dim2) -> ULongArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_ULongArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ULongArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.ULongArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ULongArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ULongArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ULongArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ULongArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ULongArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ULongArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ULongArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.ULongArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> unsigned long long

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.ULongArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.ULongArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> unsigned long long
        element(self, idx1, idx2) -> unsigned long long
        element(self, p_array, idx1, idx2) -> unsigned long long
        element(self, p_array, idx1, idx2, p_dim1_size) -> unsigned long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.ULongArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ULongArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ULongArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ULongArray2_get_name(self)

ULongArray2_swigregister = _Library.ULongArray2_swigregister
ULongArray2_swigregister(ULongArray2)

class ShortRealArray2(ShortRealArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [ShortRealArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [ShortRealArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> ShortRealArray2
        __init__(self, dim1 = 1) -> ShortRealArray2
        __init__(self) -> ShortRealArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> ShortRealArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> ShortRealArray2
        __init__(self, p_array, dim1, dim2) -> ShortRealArray2
        __init__(self, p_array, dim1, dim2) -> ShortRealArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_ShortRealArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortRealArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.ShortRealArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ShortRealArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ShortRealArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortRealArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortRealArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ShortRealArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortRealArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ShortRealArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.ShortRealArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> float

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.ShortRealArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.ShortRealArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> float
        element(self, idx1, idx2) -> float
        element(self, p_array, idx1, idx2) -> float
        element(self, p_array, idx1, idx2, p_dim1_size) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.ShortRealArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortRealArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortRealArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ShortRealArray2_get_name(self)

ShortRealArray2_swigregister = _Library.ShortRealArray2_swigregister
ShortRealArray2_swigregister(ShortRealArray2)

class RealArray2(RealArray):
    """
    Template class Array2 implements a dense two dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 2d-array implementation without
    error checking.

    C++ includes: Array2.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealArray2, name, value)
    __swig_getmethods__ = {}
    for _s in [RealArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealArray2, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, dim1 = 1, dim2 = 1) -> RealArray2
        __init__(self, dim1 = 1) -> RealArray2
        __init__(self) -> RealArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True, p_copy_array = False) -> RealArray2
        __init__(self, p_array, dim1, dim2, p_free_array = True) -> RealArray2
        __init__(self, p_array, dim1, dim2) -> RealArray2
        __init__(self, p_array, dim1, dim2) -> RealArray2

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2 
        """
        this = _Library.new_RealArray2(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_RealArray2
    __del__ = lambda self : None;
    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here 
        """
        return _Library.RealArray2_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.RealArray2_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.RealArray2_get_dim2(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.RealArray2_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.RealArray2_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.RealArray2_get_array(self)

    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.RealArray2_set_name(self, *args)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, p_free_array = True, copy_array = False)
        set_array(self, p_array, dim1, dim2, p_free_array = True)
        set_array(self, p_array, dim1, dim2)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.RealArray2_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        if resizing was successful 
        """
        return _Library.RealArray2_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2) -> float

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        array element at index 
        """
        return _Library.RealArray2_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        if setting was successful 
        """
        return _Library.RealArray2_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2) -> float
        element(self, idx1, idx2) -> float
        element(self, p_array, idx1, idx2) -> float
        element(self, p_array, idx1, idx2, p_dim1_size) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        p_dim1_size:  size of dimension 1

        element of given array at given index 
        """
        return _Library.RealArray2_element(self, *args)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.RealArray2_display_array(self)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.RealArray2_display_size(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.RealArray2_get_name(self)

RealArray2_swigregister = _Library.RealArray2_swigregister
RealArray2_swigregister(RealArray2)

class CharArray3(CharArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [CharArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CharArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [CharArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CharArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CharArray3
        __init__(self, dim1, dim2, dim3) -> CharArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> CharArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> CharArray3
        __init__(self, p_array, dim1, dim2, dim3) -> CharArray3
        __init__(self, p_array, dim1, dim2, dim3) -> CharArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_CharArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_CharArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.CharArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.CharArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.CharArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.CharArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.CharArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.CharArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.CharArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.CharArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.CharArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.CharArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> str

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.CharArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.CharArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> str
        element(self, idx1, idx2, idx3) -> str
        element(self, p_array, idx1, idx2, idx3) -> str
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.CharArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.CharArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.CharArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.CharArray3_get_name(self)

CharArray3_swigregister = _Library.CharArray3_swigregister
CharArray3_swigregister(CharArray3)

class ByteArray3(ByteArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [ByteArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ByteArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [ByteArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ByteArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ByteArray3
        __init__(self, dim1, dim2, dim3) -> ByteArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> ByteArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> ByteArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ByteArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ByteArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_ByteArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ByteArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ByteArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.ByteArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ByteArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ByteArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.ByteArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ByteArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ByteArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned str

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ByteArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ByteArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.ByteArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> unsigned str

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.ByteArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.ByteArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> unsigned str
        element(self, idx1, idx2, idx3) -> unsigned str
        element(self, p_array, idx1, idx2, idx3) -> unsigned str
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> unsigned str

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.ByteArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ByteArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ByteArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ByteArray3_get_name(self)

ByteArray3_swigregister = _Library.ByteArray3_swigregister
ByteArray3_swigregister(ByteArray3)

class ShortArray3(ShortArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [ShortArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [ShortArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortArray3
        __init__(self, dim1, dim2, dim3) -> ShortArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> ShortArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> ShortArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ShortArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ShortArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_ShortArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.ShortArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ShortArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ShortArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.ShortArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ShortArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ShortArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.ShortArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> short

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.ShortArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.ShortArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> short
        element(self, idx1, idx2, idx3) -> short
        element(self, p_array, idx1, idx2, idx3) -> short
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.ShortArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ShortArray3_get_name(self)

ShortArray3_swigregister = _Library.ShortArray3_swigregister
ShortArray3_swigregister(ShortArray3)

class WordArray3(WordArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [WordArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WordArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [WordArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WordArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> WordArray3
        __init__(self, dim1, dim2, dim3) -> WordArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> WordArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> WordArray3
        __init__(self, p_array, dim1, dim2, dim3) -> WordArray3
        __init__(self, p_array, dim1, dim2, dim3) -> WordArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_WordArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_WordArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.WordArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.WordArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.WordArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.WordArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.WordArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.WordArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.WordArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned short

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.WordArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.WordArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.WordArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> unsigned short

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.WordArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.WordArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> unsigned short
        element(self, idx1, idx2, idx3) -> unsigned short
        element(self, p_array, idx1, idx2, idx3) -> unsigned short
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> unsigned short

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.WordArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.WordArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.WordArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.WordArray3_get_name(self)

WordArray3_swigregister = _Library.WordArray3_swigregister
WordArray3_swigregister(WordArray3)

class IntArray3(IntArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [IntArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IntArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [IntArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IntArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> IntArray3
        __init__(self, dim1, dim2, dim3) -> IntArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> IntArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> IntArray3
        __init__(self, p_array, dim1, dim2, dim3) -> IntArray3
        __init__(self, p_array, dim1, dim2, dim3) -> IntArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_IntArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_IntArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.IntArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.IntArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.IntArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.IntArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.IntArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.IntArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.IntArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.IntArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.IntArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.IntArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> int

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.IntArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.IntArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> int
        element(self, idx1, idx2, idx3) -> int
        element(self, p_array, idx1, idx2, idx3) -> int
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.IntArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.IntArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.IntArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.IntArray3_get_name(self)

IntArray3_swigregister = _Library.IntArray3_swigregister
IntArray3_swigregister(IntArray3)

class UIntArray3(UIntArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [UIntArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UIntArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [UIntArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UIntArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> UIntArray3
        __init__(self, dim1, dim2, dim3) -> UIntArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> UIntArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> UIntArray3
        __init__(self, p_array, dim1, dim2, dim3) -> UIntArray3
        __init__(self, p_array, dim1, dim2, dim3) -> UIntArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_UIntArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_UIntArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.UIntArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.UIntArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.UIntArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.UIntArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.UIntArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.UIntArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.UIntArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned int

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.UIntArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.UIntArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.UIntArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> unsigned int

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.UIntArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.UIntArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> unsigned int
        element(self, idx1, idx2, idx3) -> unsigned int
        element(self, p_array, idx1, idx2, idx3) -> unsigned int
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> unsigned int

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.UIntArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.UIntArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.UIntArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.UIntArray3_get_name(self)

UIntArray3_swigregister = _Library.UIntArray3_swigregister
UIntArray3_swigregister(UIntArray3)

class LongArray3(LongArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [LongArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LongArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [LongArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LongArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LongArray3
        __init__(self, dim1, dim2, dim3) -> LongArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> LongArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> LongArray3
        __init__(self, p_array, dim1, dim2, dim3) -> LongArray3
        __init__(self, p_array, dim1, dim2, dim3) -> LongArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_LongArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_LongArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.LongArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.LongArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.LongArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.LongArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.LongArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.LongArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.LongArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.LongArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.LongArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.LongArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> long long

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.LongArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.LongArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> long long
        element(self, idx1, idx2, idx3) -> long long
        element(self, p_array, idx1, idx2, idx3) -> long long
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.LongArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.LongArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.LongArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.LongArray3_get_name(self)

LongArray3_swigregister = _Library.LongArray3_swigregister
LongArray3_swigregister(LongArray3)

class ULongArray3(ULongArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [ULongArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ULongArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [ULongArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ULongArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ULongArray3
        __init__(self, dim1, dim2, dim3) -> ULongArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> ULongArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> ULongArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ULongArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ULongArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_ULongArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ULongArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ULongArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.ULongArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ULongArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ULongArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.ULongArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ULongArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ULongArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> unsigned long long

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ULongArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ULongArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.ULongArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> unsigned long long

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.ULongArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.ULongArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> unsigned long long
        element(self, idx1, idx2, idx3) -> unsigned long long
        element(self, p_array, idx1, idx2, idx3) -> unsigned long long
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> unsigned long long

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.ULongArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ULongArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ULongArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ULongArray3_get_name(self)

ULongArray3_swigregister = _Library.ULongArray3_swigregister
ULongArray3_swigregister(ULongArray3)

class ShortRealArray3(ShortRealArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [ShortRealArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ShortRealArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [ShortRealArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ShortRealArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> ShortRealArray3
        __init__(self, dim1, dim2, dim3) -> ShortRealArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> ShortRealArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> ShortRealArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ShortRealArray3
        __init__(self, p_array, dim1, dim2, dim3) -> ShortRealArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_ShortRealArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ShortRealArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.ShortRealArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.ShortRealArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.ShortRealArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.ShortRealArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.ShortRealArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.ShortRealArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.ShortRealArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.ShortRealArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.ShortRealArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.ShortRealArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> float

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.ShortRealArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.ShortRealArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> float
        element(self, idx1, idx2, idx3) -> float
        element(self, p_array, idx1, idx2, idx3) -> float
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.ShortRealArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.ShortRealArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.ShortRealArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.ShortRealArray3_get_name(self)

ShortRealArray3_swigregister = _Library.ShortRealArray3_swigregister
ShortRealArray3_swigregister(ShortRealArray3)

class RealArray3(RealArray):
    """
    Template class Array3 implements a dense three dimensional array.

    Note that depending on compile options everything will be inlined,
    such that this is as high performance 3d-array implementation without
    error checking.

    C++ includes: Array3.h 
    """
    __swig_setmethods__ = {}
    for _s in [RealArray]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RealArray3, name, value)
    __swig_getmethods__ = {}
    for _s in [RealArray]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RealArray3, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> RealArray3
        __init__(self, dim1, dim2, dim3) -> RealArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True, p_copy_array = False) -> RealArray3
        __init__(self, p_array, dim1, dim2, dim3, p_free_array = True) -> RealArray3
        __init__(self, p_array, dim1, dim2, dim3) -> RealArray3
        __init__(self, p_array, dim1, dim2, dim3) -> RealArray3

        constructor

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimension 2

        dim3:  dimension 3 
        """
        this = _Library.new_RealArray3(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_RealArray3
    __del__ = lambda self : None;
    def set_name(self, *args):
        """
        set_name(self, p_name)

        set array's name

        Parameters:
        -----------

        p_name:  new name 
        """
        return _Library.RealArray3_set_name(self, *args)

    def get_array_size(self, *args):
        """
        get_array_size(self, dim1, dim2, dim3)

        return total array size (including granularity buffer)

        Parameters:
        -----------

        dim1:  dimension 1 will be stored here

        dim2:  dimension 2 will be stored here

        dim3:  dimension 3 will be stored here 
        """
        return _Library.RealArray3_get_array_size(self, *args)

    def get_dim1(self):
        """
        get_dim1(self) ->  int

        get dimension 1

        dimension 1 
        """
        return _Library.RealArray3_get_dim1(self)

    def get_dim2(self):
        """
        get_dim2(self) ->  int

        get dimension 2

        dimension 2 
        """
        return _Library.RealArray3_get_dim2(self)

    def get_dim3(self):
        """
        get_dim3(self) ->  int

        get dimension 3

        dimension 3 
        """
        return _Library.RealArray3_get_dim3(self)

    def zero(self):
        """
        zero(self)

        zero array 
        """
        return _Library.RealArray3_zero(self)

    def set_const(self, *args):
        """
        set_const(self, const_elem)

        set array with a constant 
        """
        return _Library.RealArray3_set_const(self, *args)

    def get_array(self):
        """
        get_array(self) -> float

        get the array call get_array just before messing with it DO NOT call
        any [],resize/delete functions after get_array(), the pointer may
        become invalid !

        the array 
        """
        return _Library.RealArray3_get_array(self)

    def set_array(self, *args):
        """
        set_array(self, p_array, dim1, dim2, dim3, p_free_array, copy_array = False)
        set_array(self, p_array, dim1, dim2, dim3, p_free_array)

        set the array pointer and free previously allocated memory

        Parameters:
        -----------

        p_array:  another array

        dim1:  dimension 1

        dim2:  dimensino 2

        dim3:  dimensino 3

        p_free_array:  if array must be freed

        copy_array:  if array must be copied 
        """
        return _Library.RealArray3_set_array(self, *args)

    def resize_array(self, *args):
        """
        resize_array(self, dim1, dim2, dim3) -> bool

        resize array

        Parameters:
        -----------

        dim1:  new dimension 1

        dim2:  new dimension 2

        dim3:  new dimension 3

        if resizing was successful 
        """
        return _Library.RealArray3_resize_array(self, *args)

    def get_element(self, *args):
        """
        get_element(self, idx1, idx2, idx3) -> float

        get array element at index

        Parameters:
        -----------

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        array element at index 
        """
        return _Library.RealArray3_get_element(self, *args)

    def set_element(self, *args):
        """
        set_element(self, p_element, idx1, idx2, idx3) -> bool

        set array element at index 'index'

        Parameters:
        -----------

        p_element:  array element

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        if setting was successful 
        """
        return _Library.RealArray3_set_element(self, *args)

    def element(self, *args):
        """
        element(self, idx1, idx2, idx3) -> float
        element(self, idx1, idx2, idx3) -> float
        element(self, p_array, idx1, idx2, idx3) -> float
        element(self, p_array, idx1, idx2, idx3, p_dim1_size, p_dim2_size) -> float

        get element of given array at given index

        Parameters:
        -----------

        p_array:  another array

        idx1:  index 1

        idx2:  index 2

        idx3:  index 3

        p_dim1_size:  size of dimension 1

        p_dim2_size:  size of dimension 2

        element of given array at given index 
        """
        return _Library.RealArray3_element(self, *args)

    def display_size(self):
        """
        display_size(self)

        display array size 
        """
        return _Library.RealArray3_display_size(self)

    def display_array(self):
        """
        display_array(self)

        display array 
        """
        return _Library.RealArray3_display_array(self)

    def get_name(self):
        """
        get_name(self) -> str

        object name 
        """
        return _Library.RealArray3_get_name(self)

RealArray3_swigregister = _Library.RealArray3_swigregister
RealArray3_swigregister(RealArray3)

class File(SGObject):
    """
    A File access base class.

    A file is assumed to be a seekable raw data stream.

    See:   CAsciiFile

    CBinaryFile

    CHDF5File

    C++ includes: File.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, File, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, File, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Library.delete_File
    __del__ = lambda self : None;
    def close(self):
        """close(self)"""
        return _Library.File_close(self)

    def set_variable_name(self, *args):
        """
        set_variable_name(self, name)

        set the path to the variable to be accessed

        only supported by some file interfaces like CHDF5File

        Parameters:
        -----------

        name:  variable path & name 
        """
        return _Library.File_set_variable_name(self, *args)

    def get_variable_name(self):
        """
        get_variable_name(self) -> str

        get the path to the variable to be accessed

        only supported by some file interfaces like CHDF5File

        name variable path & name 
        """
        return _Library.File_get_variable_name(self)

    def get_bool_vector(self, *args):
        """get_bool_vector(self, vector, len)"""
        return _Library.File_get_bool_vector(self, *args)

    def get_byte_vector(self, *args):
        """get_byte_vector(self, vector, len)"""
        return _Library.File_get_byte_vector(self, *args)

    def get_char_vector(self, *args):
        """get_char_vector(self, vector, len)"""
        return _Library.File_get_char_vector(self, *args)

    def get_int_vector(self, *args):
        """get_int_vector(self, vector, len)"""
        return _Library.File_get_int_vector(self, *args)

    def get_real_vector(self, *args):
        """get_real_vector(self, vector, len)"""
        return _Library.File_get_real_vector(self, *args)

    def get_shortreal_vector(self, *args):
        """get_shortreal_vector(self, vector, len)"""
        return _Library.File_get_shortreal_vector(self, *args)

    def get_short_vector(self, *args):
        """get_short_vector(self, vector, len)"""
        return _Library.File_get_short_vector(self, *args)

    def get_word_vector(self, *args):
        """get_word_vector(self, vector, len)"""
        return _Library.File_get_word_vector(self, *args)

    def get_bool_matrix(self, *args):
        """get_bool_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_bool_matrix(self, *args)

    def get_byte_matrix(self, *args):
        """get_byte_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_byte_matrix(self, *args)

    def get_char_matrix(self, *args):
        """get_char_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_char_matrix(self, *args)

    def get_int_matrix(self, *args):
        """get_int_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_int_matrix(self, *args)

    def get_uint_matrix(self, *args):
        """get_uint_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_uint_matrix(self, *args)

    def get_long_matrix(self, *args):
        """get_long_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_long_matrix(self, *args)

    def get_ulong_matrix(self, *args):
        """get_ulong_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_ulong_matrix(self, *args)

    def get_shortreal_matrix(self, *args):
        """get_shortreal_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_shortreal_matrix(self, *args)

    def get_real_matrix(self, *args):
        """get_real_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_real_matrix(self, *args)

    def get_longreal_matrix(self, *args):
        """get_longreal_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_longreal_matrix(self, *args)

    def get_short_matrix(self, *args):
        """get_short_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_short_matrix(self, *args)

    def get_word_matrix(self, *args):
        """get_word_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_word_matrix(self, *args)

    def get_byte_ndarray(self, *args):
        """get_byte_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_byte_ndarray(self, *args)

    def get_char_ndarray(self, *args):
        """get_char_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_char_ndarray(self, *args)

    def get_int_ndarray(self, *args):
        """get_int_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_int_ndarray(self, *args)

    def get_shortreal_ndarray(self, *args):
        """get_shortreal_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_shortreal_ndarray(self, *args)

    def get_real_ndarray(self, *args):
        """get_real_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_real_ndarray(self, *args)

    def get_short_ndarray(self, *args):
        """get_short_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_short_ndarray(self, *args)

    def get_word_ndarray(self, *args):
        """get_word_ndarray(self, array, dims, num_dims)"""
        return _Library.File_get_word_ndarray(self, *args)

    def get_bool_sparsematrix(self, *args):
        """get_bool_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_bool_sparsematrix(self, *args)

    def get_byte_sparsematrix(self, *args):
        """get_byte_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_byte_sparsematrix(self, *args)

    def get_char_sparsematrix(self, *args):
        """get_char_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_char_sparsematrix(self, *args)

    def get_int_sparsematrix(self, *args):
        """get_int_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_int_sparsematrix(self, *args)

    def get_uint_sparsematrix(self, *args):
        """get_uint_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_uint_sparsematrix(self, *args)

    def get_long_sparsematrix(self, *args):
        """get_long_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_long_sparsematrix(self, *args)

    def get_ulong_sparsematrix(self, *args):
        """get_ulong_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_ulong_sparsematrix(self, *args)

    def get_short_sparsematrix(self, *args):
        """get_short_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_short_sparsematrix(self, *args)

    def get_word_sparsematrix(self, *args):
        """get_word_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_word_sparsematrix(self, *args)

    def get_shortreal_sparsematrix(self, *args):
        """get_shortreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_shortreal_sparsematrix(self, *args)

    def get_real_sparsematrix(self, *args):
        """get_real_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_real_sparsematrix(self, *args)

    def get_longreal_sparsematrix(self, *args):
        """get_longreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_get_longreal_sparsematrix(self, *args)

    def get_bool_string_list(self, *args):
        """get_bool_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_bool_string_list(self, *args)

    def get_byte_string_list(self, *args):
        """get_byte_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_byte_string_list(self, *args)

    def get_char_string_list(self, *args):
        """get_char_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_char_string_list(self, *args)

    def get_int_string_list(self, *args):
        """get_int_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_int_string_list(self, *args)

    def get_uint_string_list(self, *args):
        """get_uint_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_uint_string_list(self, *args)

    def get_short_string_list(self, *args):
        """get_short_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_short_string_list(self, *args)

    def get_word_string_list(self, *args):
        """get_word_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_word_string_list(self, *args)

    def get_long_string_list(self, *args):
        """get_long_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_long_string_list(self, *args)

    def get_ulong_string_list(self, *args):
        """get_ulong_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_ulong_string_list(self, *args)

    def get_shortreal_string_list(self, *args):
        """get_shortreal_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_shortreal_string_list(self, *args)

    def get_real_string_list(self, *args):
        """get_real_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_real_string_list(self, *args)

    def get_longreal_string_list(self, *args):
        """get_longreal_string_list(self, strings, num_str, max_string_len)"""
        return _Library.File_get_longreal_string_list(self, *args)

    def set_bool_vector(self, *args):
        """set_bool_vector(self, vector, len)"""
        return _Library.File_set_bool_vector(self, *args)

    def set_byte_vector(self, *args):
        """set_byte_vector(self, vector, len)"""
        return _Library.File_set_byte_vector(self, *args)

    def set_char_vector(self, *args):
        """set_char_vector(self, vector, len)"""
        return _Library.File_set_char_vector(self, *args)

    def set_int_vector(self, *args):
        """set_int_vector(self, vector, len)"""
        return _Library.File_set_int_vector(self, *args)

    def set_shortreal_vector(self, *args):
        """set_shortreal_vector(self, vector, len)"""
        return _Library.File_set_shortreal_vector(self, *args)

    def set_real_vector(self, *args):
        """set_real_vector(self, vector, len)"""
        return _Library.File_set_real_vector(self, *args)

    def set_short_vector(self, *args):
        """set_short_vector(self, vector, len)"""
        return _Library.File_set_short_vector(self, *args)

    def set_word_vector(self, *args):
        """set_word_vector(self, vector, len)"""
        return _Library.File_set_word_vector(self, *args)

    def set_bool_matrix(self, *args):
        """set_bool_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_bool_matrix(self, *args)

    def set_byte_matrix(self, *args):
        """set_byte_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_byte_matrix(self, *args)

    def set_char_matrix(self, *args):
        """set_char_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_char_matrix(self, *args)

    def set_int_matrix(self, *args):
        """set_int_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_int_matrix(self, *args)

    def set_uint_matrix(self, *args):
        """set_uint_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_uint_matrix(self, *args)

    def set_long_matrix(self, *args):
        """set_long_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_long_matrix(self, *args)

    def set_ulong_matrix(self, *args):
        """set_ulong_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_ulong_matrix(self, *args)

    def set_shortreal_matrix(self, *args):
        """set_shortreal_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_shortreal_matrix(self, *args)

    def set_real_matrix(self, *args):
        """set_real_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_real_matrix(self, *args)

    def set_longreal_matrix(self, *args):
        """set_longreal_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_longreal_matrix(self, *args)

    def set_short_matrix(self, *args):
        """set_short_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_short_matrix(self, *args)

    def set_word_matrix(self, *args):
        """set_word_matrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_word_matrix(self, *args)

    def set_bool_sparsematrix(self, *args):
        """set_bool_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_bool_sparsematrix(self, *args)

    def set_byte_sparsematrix(self, *args):
        """set_byte_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_byte_sparsematrix(self, *args)

    def set_char_sparsematrix(self, *args):
        """set_char_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_char_sparsematrix(self, *args)

    def set_int_sparsematrix(self, *args):
        """set_int_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_int_sparsematrix(self, *args)

    def set_uint_sparsematrix(self, *args):
        """set_uint_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_uint_sparsematrix(self, *args)

    def set_long_sparsematrix(self, *args):
        """set_long_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_long_sparsematrix(self, *args)

    def set_ulong_sparsematrix(self, *args):
        """set_ulong_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_ulong_sparsematrix(self, *args)

    def set_short_sparsematrix(self, *args):
        """set_short_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_short_sparsematrix(self, *args)

    def set_word_sparsematrix(self, *args):
        """set_word_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_word_sparsematrix(self, *args)

    def set_shortreal_sparsematrix(self, *args):
        """set_shortreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_shortreal_sparsematrix(self, *args)

    def set_real_sparsematrix(self, *args):
        """set_real_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_real_sparsematrix(self, *args)

    def set_longreal_sparsematrix(self, *args):
        """set_longreal_sparsematrix(self, matrix, num_feat, num_vec)"""
        return _Library.File_set_longreal_sparsematrix(self, *args)

    def set_bool_string_list(self, *args):
        """set_bool_string_list(self, strings, num_str)"""
        return _Library.File_set_bool_string_list(self, *args)

    def set_byte_string_list(self, *args):
        """set_byte_string_list(self, strings, num_str)"""
        return _Library.File_set_byte_string_list(self, *args)

    def set_char_string_list(self, *args):
        """set_char_string_list(self, strings, num_str)"""
        return _Library.File_set_char_string_list(self, *args)

    def set_int_string_list(self, *args):
        """set_int_string_list(self, strings, num_str)"""
        return _Library.File_set_int_string_list(self, *args)

    def set_uint_string_list(self, *args):
        """set_uint_string_list(self, strings, num_str)"""
        return _Library.File_set_uint_string_list(self, *args)

    def set_short_string_list(self, *args):
        """set_short_string_list(self, strings, num_str)"""
        return _Library.File_set_short_string_list(self, *args)

    def set_word_string_list(self, *args):
        """set_word_string_list(self, strings, num_str)"""
        return _Library.File_set_word_string_list(self, *args)

    def set_long_string_list(self, *args):
        """set_long_string_list(self, strings, num_str)"""
        return _Library.File_set_long_string_list(self, *args)

    def set_ulong_string_list(self, *args):
        """set_ulong_string_list(self, strings, num_str)"""
        return _Library.File_set_ulong_string_list(self, *args)

    def set_shortreal_string_list(self, *args):
        """set_shortreal_string_list(self, strings, num_str)"""
        return _Library.File_set_shortreal_string_list(self, *args)

    def set_real_string_list(self, *args):
        """set_real_string_list(self, strings, num_str)"""
        return _Library.File_set_real_string_list(self, *args)

    def set_longreal_string_list(self, *args):
        """set_longreal_string_list(self, strings, num_str)"""
        return _Library.File_set_longreal_string_list(self, *args)

File_swigregister = _Library.File_swigregister
File_swigregister(File)

class AsciiFile(File):
    """
    A Ascii File access class.

    Vectors are written out as one number per line

    Matrices are written out as one column per line

    Sparse Matrices are written out as one column per line
    (libsvm/svmlight style format)

    Strings are written out as one string per line

    C++ includes: AsciiFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AsciiFile, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AsciiFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, f, name = None) -> AsciiFile
        __init__(self, f) -> AsciiFile
        __init__(self, fname, rw = 'r', name = None) -> AsciiFile
        __init__(self, fname, rw = 'r') -> AsciiFile
        __init__(self, fname) -> AsciiFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w'

        name:  variable name (e.g. "x" or "/path/to/x") 
        """
        this = _Library.new_AsciiFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_AsciiFile
    __del__ = lambda self : None;
AsciiFile_swigregister = _Library.AsciiFile_swigregister
AsciiFile_swigregister(AsciiFile)

class BinaryFile(File):
    """
    A Binary file access class.

    A file consists of a SG00 fourcc header then an alternation of a type
    header and data. The current implementation is capable of storing only
    a single header/data type. Multiple headers are currently not
    implemented.

    C++ includes: BinaryFile.h 
    """
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BinaryFile, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BinaryFile, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, f, name = None) -> BinaryFile
        __init__(self, f) -> BinaryFile
        __init__(self, fname, rw = 'r', name = None) -> BinaryFile
        __init__(self, fname, rw = 'r') -> BinaryFile
        __init__(self, fname) -> BinaryFile

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w'

        name:  variable name (e.g. "x" or "/path/to/x") 
        """
        this = _Library.new_BinaryFile(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_BinaryFile
    __del__ = lambda self : None;
BinaryFile_swigregister = _Library.BinaryFile_swigregister
BinaryFile_swigregister(BinaryFile)

class HDF5File(File):
    """
    A HDF5 File access class.

    This class allows reading and writing of vectors and matrices in the
    hierarchical file format version 5.

    C++ includes: HDF5File.h 
    """
    __swig_setmethods__ = {}
    for _s in [File]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HDF5File, name, value)
    __swig_getmethods__ = {}
    for _s in [File]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HDF5File, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, fname, rw = 'r', name = None) -> HDF5File
        __init__(self, fname, rw = 'r') -> HDF5File
        __init__(self, fname) -> HDF5File

        constructor

        Parameters:
        -----------

        fname:  filename to open

        rw:  mode, 'r' or 'w'

        name:  variable name (e.g. "x" or "/path/to/x") 
        """
        this = _Library.new_HDF5File(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_HDF5File
    __del__ = lambda self : None;
HDF5File_swigregister = _Library.HDF5File_swigregister
HDF5File_swigregister(HDF5File)

RNG_SEED_SIZE = _Library.RNG_SEED_SIZE
class Math(SGObject):
    """
    Class which collects generic mathematical functions.

    C++ includes: Mathematics.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Math, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Math, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Math

        Constructor - initializes log-table. 
        """
        this = _Library.new_Math()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Math
    __del__ = lambda self : None;
    def round(*args):
        """round(d) -> float"""
        return _Library.Math_round(*args)

    if _newclass:round = staticmethod(round)
    __swig_getmethods__["round"] = lambda x: round
    def floor(*args):
        """floor(d) -> float"""
        return _Library.Math_floor(*args)

    if _newclass:floor = staticmethod(floor)
    __swig_getmethods__["floor"] = lambda x: floor
    def ceil(*args):
        """ceil(d) -> float"""
        return _Library.Math_ceil(*args)

    if _newclass:ceil = staticmethod(ceil)
    __swig_getmethods__["ceil"] = lambda x: ceil
    def sqrt(*args):
        """
        sqrt(x) -> float
        sqrt(x) -> float
        sqrt(x) -> floatmax_t

        x^0.5 
        """
        return _Library.Math_sqrt(*args)

    if _newclass:sqrt = staticmethod(sqrt)
    __swig_getmethods__["sqrt"] = lambda x: sqrt
    def powl(*args):
        """
        powl(x, n) -> floatmax_t

        x^n 
        """
        return _Library.Math_powl(*args)

    if _newclass:powl = staticmethod(powl)
    __swig_getmethods__["powl"] = lambda x: powl
    def pow(*args):
        """
        pow(x, n) ->  int
        pow(x, n) -> float
        pow(x, n) -> float
        """
        return _Library.Math_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def exp(*args):
        """exp(x) -> float"""
        return _Library.Math_exp(*args)

    if _newclass:exp = staticmethod(exp)
    __swig_getmethods__["exp"] = lambda x: exp
    def log10(*args):
        """log10(v) -> float"""
        return _Library.Math_log10(*args)

    if _newclass:log10 = staticmethod(log10)
    __swig_getmethods__["log10"] = lambda x: log10
    def log2(*args):
        """log2(v) -> float"""
        return _Library.Math_log2(*args)

    if _newclass:log2 = staticmethod(log2)
    __swig_getmethods__["log2"] = lambda x: log2
    def log(*args):
        """log(v) -> float"""
        return _Library.Math_log(*args)

    if _newclass:log = staticmethod(log)
    __swig_getmethods__["log"] = lambda x: log
    def pinv(*args):
        """
        pinv(matrix, rows, cols, target = None) -> float
        pinv(matrix, rows, cols) -> float

        return the pseudo inverse for matrix when matrix has shape (rows,
        cols) the pseudo inverse has (cols, rows) 
        """
        return _Library.Math_pinv(*args)

    if _newclass:pinv = staticmethod(pinv)
    __swig_getmethods__["pinv"] = lambda x: pinv
    def dgemm(*args):
        """
        dgemm(alpha, A, rows, cols, transposeA, B, cols_B, transposeB, 
            beta, C)
        """
        return _Library.Math_dgemm(*args)

    if _newclass:dgemm = staticmethod(dgemm)
    __swig_getmethods__["dgemm"] = lambda x: dgemm
    def dgemv(*args):
        """dgemv(alpha, A, rows, cols, transposeA, X, beta, Y)"""
        return _Library.Math_dgemv(*args)

    if _newclass:dgemv = staticmethod(dgemv)
    __swig_getmethods__["dgemv"] = lambda x: dgemv
    def factorial(*args):
        """factorial(n) -> int"""
        return _Library.Math_factorial(*args)

    if _newclass:factorial = staticmethod(factorial)
    __swig_getmethods__["factorial"] = lambda x: factorial
    def init_random(initseed = 0):
        """
        init_random(initseed = 0)
        init_random()
        """
        return _Library.Math_init_random(initseed)

    if _newclass:init_random = staticmethod(init_random)
    __swig_getmethods__["init_random"] = lambda x: init_random
    def random(*args):
        """
        random() -> int
        random(min_value, max_value) ->  int
        random(min_value, max_value) -> float
        random(min_value, max_value) -> float
        """
        return _Library.Math_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def randperm(*args):
        """randperm(n) ->  int"""
        return _Library.Math_randperm(*args)

    if _newclass:randperm = staticmethod(randperm)
    __swig_getmethods__["randperm"] = lambda x: randperm
    def nchoosek(*args):
        """nchoosek(n, k) -> int"""
        return _Library.Math_nchoosek(*args)

    if _newclass:nchoosek = staticmethod(nchoosek)
    __swig_getmethods__["nchoosek"] = lambda x: nchoosek
    def dot(*args):
        """
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> floatmax_t
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float
        dot(v1, v2, n) -> float

        compute dot product between v1 and v2 
        """
        return _Library.Math_dot(*args)

    if _newclass:dot = staticmethod(dot)
    __swig_getmethods__["dot"] = lambda x: dot
    def mean(*args):
        """mean(vec, len) -> float"""
        return _Library.Math_mean(*args)

    if _newclass:mean = staticmethod(mean)
    __swig_getmethods__["mean"] = lambda x: mean
    def trace(*args):
        """trace(mat, cols, rows) -> float"""
        return _Library.Math_trace(*args)

    if _newclass:trace = staticmethod(trace)
    __swig_getmethods__["trace"] = lambda x: trace
    def sort(*args):
        """
        sort(a, cols, sort_col = 0)
        sort(a, cols)
        sort(a, idx, N)
        """
        return _Library.Math_sort(*args)

    if _newclass:sort = staticmethod(sort)
    __swig_getmethods__["sort"] = lambda x: sort
    def Align(*args):
        """
        Align(seq1, seq2, l1, l2, gapCost) -> float

        align two sequences seq1 & seq2 of length l1 and l2 using gapCost
        return alignment cost 
        """
        return _Library.Math_Align(*args)

    if _newclass:Align = staticmethod(Align)
    __swig_getmethods__["Align"] = lambda x: Align
    def calcroc(*args):
        """
        calcroc(fp, tp, output, label, size, possize, negsize, tresh, 
            rocfile) ->  int

        calculates ROC into (fp,tp) from output and label of length size
        returns index with smallest error=fp+fn 
        """
        return _Library.Math_calcroc(*args)

    if _newclass:calcroc = staticmethod(calcroc)
    __swig_getmethods__["calcroc"] = lambda x: calcroc
    def mutual_info(*args):
        """mutual_info(p1, p2, len) -> float"""
        return _Library.Math_mutual_info(*args)

    if _newclass:mutual_info = staticmethod(mutual_info)
    __swig_getmethods__["mutual_info"] = lambda x: mutual_info
    def relative_entropy(*args):
        """relative_entropy(p, q, len) -> float"""
        return _Library.Math_relative_entropy(*args)

    if _newclass:relative_entropy = staticmethod(relative_entropy)
    __swig_getmethods__["relative_entropy"] = lambda x: relative_entropy
    def entropy(*args):
        """entropy(p, len) -> float"""
        return _Library.Math_entropy(*args)

    if _newclass:entropy = staticmethod(entropy)
    __swig_getmethods__["entropy"] = lambda x: entropy
    def get_seed():
        """get_seed() -> int"""
        return _Library.Math_get_seed()

    if _newclass:get_seed = staticmethod(get_seed)
    __swig_getmethods__["get_seed"] = lambda x: get_seed
    def is_finite(*args):
        """is_finite(f) -> int"""
        return _Library.Math_is_finite(*args)

    if _newclass:is_finite = staticmethod(is_finite)
    __swig_getmethods__["is_finite"] = lambda x: is_finite
    def is_infinity(*args):
        """is_infinity(f) -> int"""
        return _Library.Math_is_infinity(*args)

    if _newclass:is_infinity = staticmethod(is_infinity)
    __swig_getmethods__["is_infinity"] = lambda x: is_infinity
    def is_nan(*args):
        """is_nan(f) -> int"""
        return _Library.Math_is_nan(*args)

    if _newclass:is_nan = staticmethod(is_nan)
    __swig_getmethods__["is_nan"] = lambda x: is_nan
    def logarithmic_sum(*args):
        """
        logarithmic_sum(p, q) -> float

        sum logarithmic probabilities. Probability measures are summed up but
        are now given in logspace where direct summation of exp(operand) is
        not possible due to numerical problems, i.e. eg. exp(-1000)=0.
        Therefore we do log( exp(a) + exp(b)) = a + log (1 + exp (b-a)) where
        a = max(p,q) and b min(p,q). 
        """
        return _Library.Math_logarithmic_sum(*args)

    if _newclass:logarithmic_sum = staticmethod(logarithmic_sum)
    __swig_getmethods__["logarithmic_sum"] = lambda x: logarithmic_sum
    __swig_setmethods__["LOGRANGE"] = _Library.Math_LOGRANGE_set
    __swig_getmethods__["LOGRANGE"] = _Library.Math_LOGRANGE_get
    if _newclass:LOGRANGE = _swig_property(_Library.Math_LOGRANGE_get, _Library.Math_LOGRANGE_set)
    __swig_setmethods__["seed"] = _Library.Math_seed_set
    __swig_getmethods__["seed"] = _Library.Math_seed_get
    if _newclass:seed = _swig_property(_Library.Math_seed_get, _Library.Math_seed_set)
    __swig_setmethods__["rand_state"] = _Library.Math_rand_state_set
    __swig_getmethods__["rand_state"] = _Library.Math_rand_state_get
    if _newclass:rand_state = _swig_property(_Library.Math_rand_state_get, _Library.Math_rand_state_set)
Math_swigregister = _Library.Math_swigregister
Math_swigregister(Math)

def Math_round(*args):
  """Math_round(d) -> float"""
  return _Library.Math_round(*args)

def Math_floor(*args):
  """Math_floor(d) -> float"""
  return _Library.Math_floor(*args)

def Math_ceil(*args):
  """Math_ceil(d) -> float"""
  return _Library.Math_ceil(*args)

def Math_sqrt(*args):
  """
    sqrt(x) -> float
    sqrt(x) -> float
    Math_sqrt(x) -> floatmax_t

    x^0.5 
    """
  return _Library.Math_sqrt(*args)

def Math_powl(*args):
  """
    Math_powl(x, n) -> floatmax_t

    x^n 
    """
  return _Library.Math_powl(*args)

def Math_pow(*args):
  """
    pow(x, n) ->  int
    pow(x, n) -> float
    Math_pow(x, n) -> float
    """
  return _Library.Math_pow(*args)

def Math_exp(*args):
  """Math_exp(x) -> float"""
  return _Library.Math_exp(*args)

def Math_log10(*args):
  """Math_log10(v) -> float"""
  return _Library.Math_log10(*args)

def Math_log2(*args):
  """Math_log2(v) -> float"""
  return _Library.Math_log2(*args)

def Math_log(*args):
  """Math_log(v) -> float"""
  return _Library.Math_log(*args)

def Math_pinv(*args):
  """
    pinv(matrix, rows, cols, target = None) -> float
    Math_pinv(matrix, rows, cols) -> float

    return the pseudo inverse for matrix when matrix has shape (rows,
    cols) the pseudo inverse has (cols, rows) 
    """
  return _Library.Math_pinv(*args)

def Math_dgemm(*args):
  """
    Math_dgemm(alpha, A, rows, cols, transposeA, B, cols_B, transposeB, 
        beta, C)
    """
  return _Library.Math_dgemm(*args)

def Math_dgemv(*args):
  """Math_dgemv(alpha, A, rows, cols, transposeA, X, beta, Y)"""
  return _Library.Math_dgemv(*args)

def Math_factorial(*args):
  """Math_factorial(n) -> int"""
  return _Library.Math_factorial(*args)

def Math_init_random(initseed = 0):
  """
    init_random(initseed = 0)
    Math_init_random()
    """
  return _Library.Math_init_random(initseed)

def Math_random(*args):
  """
    random() -> int
    random(min_value, max_value) ->  int
    random(min_value, max_value) -> float
    Math_random(min_value, max_value) -> float
    """
  return _Library.Math_random(*args)

def Math_randperm(*args):
  """Math_randperm(n) ->  int"""
  return _Library.Math_randperm(*args)

def Math_nchoosek(*args):
  """Math_nchoosek(n, k) -> int"""
  return _Library.Math_nchoosek(*args)

def Math_dot(*args):
  """
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> floatmax_t
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    dot(v1, v2, n) -> float
    Math_dot(v1, v2, n) -> float

    compute dot product between v1 and v2 
    """
  return _Library.Math_dot(*args)

def Math_mean(*args):
  """Math_mean(vec, len) -> float"""
  return _Library.Math_mean(*args)

def Math_trace(*args):
  """Math_trace(mat, cols, rows) -> float"""
  return _Library.Math_trace(*args)

def Math_sort(*args):
  """
    sort(a, cols, sort_col = 0)
    sort(a, cols)
    Math_sort(a, idx, N)
    """
  return _Library.Math_sort(*args)

def Math_Align(*args):
  """
    Math_Align(seq1, seq2, l1, l2, gapCost) -> float

    align two sequences seq1 & seq2 of length l1 and l2 using gapCost
    return alignment cost 
    """
  return _Library.Math_Align(*args)

def Math_calcroc(*args):
  """
    Math_calcroc(fp, tp, output, label, size, possize, negsize, tresh, 
        rocfile) ->  int

    calculates ROC into (fp,tp) from output and label of length size
    returns index with smallest error=fp+fn 
    """
  return _Library.Math_calcroc(*args)

def Math_mutual_info(*args):
  """Math_mutual_info(p1, p2, len) -> float"""
  return _Library.Math_mutual_info(*args)

def Math_relative_entropy(*args):
  """Math_relative_entropy(p, q, len) -> float"""
  return _Library.Math_relative_entropy(*args)

def Math_entropy(*args):
  """Math_entropy(p, len) -> float"""
  return _Library.Math_entropy(*args)

def Math_get_seed():
  """Math_get_seed() -> int"""
  return _Library.Math_get_seed()

def Math_is_finite(*args):
  """Math_is_finite(f) -> int"""
  return _Library.Math_is_finite(*args)

def Math_is_infinity(*args):
  """Math_is_infinity(f) -> int"""
  return _Library.Math_is_infinity(*args)

def Math_is_nan(*args):
  """Math_is_nan(f) -> int"""
  return _Library.Math_is_nan(*args)

def Math_logarithmic_sum(*args):
  """
    Math_logarithmic_sum(p, q) -> float

    sum logarithmic probabilities. Probability measures are summed up but
    are now given in logspace where direct summation of exp(operand) is
    not possible due to numerical problems, i.e. eg. exp(-1000)=0.
    Therefore we do log( exp(a) + exp(b)) = a + log (1 + exp (b-a)) where
    a = max(p,q) and b min(p,q). 
    """
  return _Library.Math_logarithmic_sum(*args)
Math.INFTY = _Library.cvar.Math_INFTY
Math.ALMOST_INFTY = _Library.cvar.Math_ALMOST_INFTY
Math.ALMOST_NEG_INFTY = _Library.cvar.Math_ALMOST_NEG_INFTY

class Signal(SGObject):
    """
    Class Signal implements signal handling to e.g. allow ctrl+c to cancel
    a long running process.

    This is done in two ways:

    A signal handler is attached to trap the SIGINT and SIGURG signal.
    Pressing ctrl+c or sending the SIGINT (kill ...) signal to the shogun
    process will make shogun print a message asking to immediately exit
    the running method and to fall back to the command line.

    When an URG signal is received or ctrl+c P is pressed shogun will
    prematurely stop a method and continue execution. For example when an
    SVM solver takes a long time without progressing much, one might still
    be interested in the result and should thus send SIGURG or
    interactively prematurely stop the method

    C++ includes: Signal.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Signal, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Signal, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """
        __init__(self) -> Signal

        default constructor 
        """
        this = _Library.new_Signal()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Signal
    __del__ = lambda self : None;
    def handler(*args):
        """handler(signal)"""
        return _Library.Signal_handler(*args)

    if _newclass:handler = staticmethod(handler)
    __swig_getmethods__["handler"] = lambda x: handler
    def set_handler():
        """set_handler() -> bool"""
        return _Library.Signal_set_handler()

    if _newclass:set_handler = staticmethod(set_handler)
    __swig_getmethods__["set_handler"] = lambda x: set_handler
    def unset_handler():
        """unset_handler() -> bool"""
        return _Library.Signal_unset_handler()

    if _newclass:unset_handler = staticmethod(unset_handler)
    __swig_getmethods__["unset_handler"] = lambda x: unset_handler
    def clear():
        """clear()"""
        return _Library.Signal_clear()

    if _newclass:clear = staticmethod(clear)
    __swig_getmethods__["clear"] = lambda x: clear
    def clear_cancel():
        """clear_cancel()"""
        return _Library.Signal_clear_cancel()

    if _newclass:clear_cancel = staticmethod(clear_cancel)
    __swig_getmethods__["clear_cancel"] = lambda x: clear_cancel
    def set_cancel(immediately = False):
        """
        set_cancel(immediately = False)
        set_cancel()
        """
        return _Library.Signal_set_cancel(immediately)

    if _newclass:set_cancel = staticmethod(set_cancel)
    __swig_getmethods__["set_cancel"] = lambda x: set_cancel
    def cancel_computations():
        """cancel_computations() -> bool"""
        return _Library.Signal_cancel_computations()

    if _newclass:cancel_computations = staticmethod(cancel_computations)
    __swig_getmethods__["cancel_computations"] = lambda x: cancel_computations
Signal_swigregister = _Library.Signal_swigregister
Signal_swigregister(Signal)

def Signal_handler(*args):
  """Signal_handler(signal)"""
  return _Library.Signal_handler(*args)

def Signal_set_handler():
  """Signal_set_handler() -> bool"""
  return _Library.Signal_set_handler()

def Signal_unset_handler():
  """Signal_unset_handler() -> bool"""
  return _Library.Signal_unset_handler()

def Signal_clear():
  """Signal_clear()"""
  return _Library.Signal_clear()

def Signal_clear_cancel():
  """Signal_clear_cancel()"""
  return _Library.Signal_clear_cancel()

def Signal_set_cancel(immediately = False):
  """
    set_cancel(immediately = False)
    Signal_set_cancel()
    """
  return _Library.Signal_set_cancel(immediately)

def Signal_cancel_computations():
  """Signal_cancel_computations() -> bool"""
  return _Library.Signal_cancel_computations()

class Time(SGObject):
    """
    Class Time that implements a stopwatch based on either cpu time or
    wall clock time.

    C++ includes: Time.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Time, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Time, name)
    __repr__ = _swig_repr
    def __init__(self, start = True): 
        """
        __init__(self, start = True) -> Time
        __init__(self) -> Time

        constructor

        Parameters:
        -----------

        start:  if time measurement shall be started 
        """
        this = _Library.new_Time(start)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_Time
    __del__ = lambda self : None;
    def cur_runtime(self, verbose = False):
        """
        cur_runtime(self, verbose = False) -> clock_t
        cur_runtime(self) -> clock_t

        get current cpu runtime

        Parameters:
        -----------

        verbose:  if time shall be printed

        current cpu runtime 
        """
        return _Library.Time_cur_runtime(self, verbose)

    def cur_runtime_diff(self, verbose = False):
        """
        cur_runtime_diff(self, verbose = False) -> clock_t
        cur_runtime_diff(self) -> clock_t

        get time difference between start and NOW

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW 
        """
        return _Library.Time_cur_runtime_diff(self, verbose)

    def cur_runtime_diff_sec(self, verbose = False):
        """
        cur_runtime_diff_sec(self, verbose = False) -> float
        cur_runtime_diff_sec(self) -> float

        get time difference between start and NOW in seconds (wall clock time)

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW in seconds 
        """
        return _Library.Time_cur_runtime_diff_sec(self, verbose)

    def start(self, verbose = False):
        """
        start(self, verbose = False) -> float
        start(self) -> float

        start the counter

        Parameters:
        -----------

        verbose:  if start time shall be printed

        start time in seconds 
        """
        return _Library.Time_start(self, verbose)

    def cur_time_diff(self, verbose = False):
        """
        cur_time_diff(self, verbose = False) -> float
        cur_time_diff(self) -> float

        get time difference between start and NOW in seconds (wall clock time)

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and NOW in seconds 
        """
        return _Library.Time_cur_time_diff(self, verbose)

    def time_diff_sec(self, verbose = False):
        """
        time_diff_sec(self, verbose = False) -> float
        time_diff_sec(self) -> float

        get time difference between start and stop in seconds

        Parameters:
        -----------

        verbose:  if time difference shall be printed

        time difference between start and stop in seconds 
        """
        return _Library.Time_time_diff_sec(self, verbose)

    def stop(self, verbose = False):
        """
        stop(self, verbose = False) -> float
        stop(self) -> float

        stop the counter

        Parameters:
        -----------

        verbose:  if stop time shall be printed

        stop time in seconds 
        """
        return _Library.Time_stop(self, verbose)

    def get_runtime():
        """get_runtime() -> float"""
        return _Library.Time_get_runtime()

    if _newclass:get_runtime = staticmethod(get_runtime)
    __swig_getmethods__["get_runtime"] = lambda x: get_runtime
    def get_curtime():
        """get_curtime() -> float"""
        return _Library.Time_get_curtime()

    if _newclass:get_curtime = staticmethod(get_curtime)
    __swig_getmethods__["get_curtime"] = lambda x: get_curtime
Time_swigregister = _Library.Time_swigregister
Time_swigregister(Time)

def Time_get_runtime():
  """Time_get_runtime() -> float"""
  return _Library.Time_get_runtime()

def Time_get_curtime():
  """Time_get_curtime() -> float"""
  return _Library.Time_get_curtime()

class ConsensusEntry(_object):
    """
    consensus entry

    C++ includes: Trie.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConsensusEntry, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ConsensusEntry, name)
    __repr__ = _swig_repr
    __swig_setmethods__["string"] = _Library.ConsensusEntry_string_set
    __swig_getmethods__["string"] = _Library.ConsensusEntry_string_get
    if _newclass:string = _swig_property(_Library.ConsensusEntry_string_get, _Library.ConsensusEntry_string_set)
    __swig_setmethods__["score"] = _Library.ConsensusEntry_score_set
    __swig_getmethods__["score"] = _Library.ConsensusEntry_score_get
    if _newclass:score = _swig_property(_Library.ConsensusEntry_score_get, _Library.ConsensusEntry_score_set)
    __swig_setmethods__["bt"] = _Library.ConsensusEntry_bt_set
    __swig_getmethods__["bt"] = _Library.ConsensusEntry_bt_get
    if _newclass:bt = _swig_property(_Library.ConsensusEntry_bt_get, _Library.ConsensusEntry_bt_set)
    def __init__(self): 
        """__init__(self) -> ConsensusEntry"""
        this = _Library.new_ConsensusEntry()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_ConsensusEntry
    __del__ = lambda self : None;
ConsensusEntry_swigregister = _Library.ConsensusEntry_swigregister
ConsensusEntry_swigregister(ConsensusEntry)

class POIMTrie(_object):
    """
    POIM trie

    C++ includes: Trie.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, POIMTrie, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, POIMTrie, name)
    __repr__ = _swig_repr
    __swig_setmethods__["weight"] = _Library.POIMTrie_weight_set
    __swig_getmethods__["weight"] = _Library.POIMTrie_weight_get
    if _newclass:weight = _swig_property(_Library.POIMTrie_weight_get, _Library.POIMTrie_weight_set)
    __swig_setmethods__["S"] = _Library.POIMTrie_S_set
    __swig_getmethods__["S"] = _Library.POIMTrie_S_get
    if _newclass:S = _swig_property(_Library.POIMTrie_S_get, _Library.POIMTrie_S_set)
    __swig_setmethods__["L"] = _Library.POIMTrie_L_set
    __swig_getmethods__["L"] = _Library.POIMTrie_L_get
    if _newclass:L = _swig_property(_Library.POIMTrie_L_get, _Library.POIMTrie_L_set)
    __swig_setmethods__["R"] = _Library.POIMTrie_R_set
    __swig_getmethods__["R"] = _Library.POIMTrie_R_get
    if _newclass:R = _swig_property(_Library.POIMTrie_R_get, _Library.POIMTrie_R_set)
    def __init__(self): 
        """__init__(self) -> POIMTrie"""
        this = _Library.new_POIMTrie()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_POIMTrie
    __del__ = lambda self : None;
POIMTrie_swigregister = _Library.POIMTrie_swigregister
POIMTrie_swigregister(POIMTrie)

class DNATrie(_object):
    """
    DNA trie

    C++ includes: Trie.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DNATrie, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DNATrie, name)
    __repr__ = _swig_repr
    __swig_setmethods__["weight"] = _Library.DNATrie_weight_set
    __swig_getmethods__["weight"] = _Library.DNATrie_weight_get
    if _newclass:weight = _swig_property(_Library.DNATrie_weight_get, _Library.DNATrie_weight_set)
    def __init__(self): 
        """__init__(self) -> DNATrie"""
        this = _Library.new_DNATrie()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_DNATrie
    __del__ = lambda self : None;
DNATrie_swigregister = _Library.DNATrie_swigregister
DNATrie_swigregister(DNATrie)

class TreeParseInfo(_object):
    """
    tree parse info

    C++ includes: Trie.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, TreeParseInfo, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, TreeParseInfo, name)
    __repr__ = _swig_repr
    __swig_setmethods__["num_sym"] = _Library.TreeParseInfo_num_sym_set
    __swig_getmethods__["num_sym"] = _Library.TreeParseInfo_num_sym_get
    if _newclass:num_sym = _swig_property(_Library.TreeParseInfo_num_sym_get, _Library.TreeParseInfo_num_sym_set)
    __swig_setmethods__["num_feat"] = _Library.TreeParseInfo_num_feat_set
    __swig_getmethods__["num_feat"] = _Library.TreeParseInfo_num_feat_get
    if _newclass:num_feat = _swig_property(_Library.TreeParseInfo_num_feat_get, _Library.TreeParseInfo_num_feat_set)
    __swig_setmethods__["p"] = _Library.TreeParseInfo_p_set
    __swig_getmethods__["p"] = _Library.TreeParseInfo_p_get
    if _newclass:p = _swig_property(_Library.TreeParseInfo_p_get, _Library.TreeParseInfo_p_set)
    __swig_setmethods__["k"] = _Library.TreeParseInfo_k_set
    __swig_getmethods__["k"] = _Library.TreeParseInfo_k_get
    if _newclass:k = _swig_property(_Library.TreeParseInfo_k_get, _Library.TreeParseInfo_k_set)
    __swig_setmethods__["nofsKmers"] = _Library.TreeParseInfo_nofsKmers_set
    __swig_getmethods__["nofsKmers"] = _Library.TreeParseInfo_nofsKmers_get
    if _newclass:nofsKmers = _swig_property(_Library.TreeParseInfo_nofsKmers_get, _Library.TreeParseInfo_nofsKmers_set)
    __swig_setmethods__["margFactors"] = _Library.TreeParseInfo_margFactors_set
    __swig_getmethods__["margFactors"] = _Library.TreeParseInfo_margFactors_get
    if _newclass:margFactors = _swig_property(_Library.TreeParseInfo_margFactors_get, _Library.TreeParseInfo_margFactors_set)
    __swig_setmethods__["x"] = _Library.TreeParseInfo_x_set
    __swig_getmethods__["x"] = _Library.TreeParseInfo_x_get
    if _newclass:x = _swig_property(_Library.TreeParseInfo_x_get, _Library.TreeParseInfo_x_set)
    __swig_setmethods__["substrs"] = _Library.TreeParseInfo_substrs_set
    __swig_getmethods__["substrs"] = _Library.TreeParseInfo_substrs_get
    if _newclass:substrs = _swig_property(_Library.TreeParseInfo_substrs_get, _Library.TreeParseInfo_substrs_set)
    __swig_setmethods__["y0"] = _Library.TreeParseInfo_y0_set
    __swig_getmethods__["y0"] = _Library.TreeParseInfo_y0_get
    if _newclass:y0 = _swig_property(_Library.TreeParseInfo_y0_get, _Library.TreeParseInfo_y0_set)
    __swig_setmethods__["C_k"] = _Library.TreeParseInfo_C_k_set
    __swig_getmethods__["C_k"] = _Library.TreeParseInfo_C_k_get
    if _newclass:C_k = _swig_property(_Library.TreeParseInfo_C_k_get, _Library.TreeParseInfo_C_k_set)
    __swig_setmethods__["L_k"] = _Library.TreeParseInfo_L_k_set
    __swig_getmethods__["L_k"] = _Library.TreeParseInfo_L_k_get
    if _newclass:L_k = _swig_property(_Library.TreeParseInfo_L_k_get, _Library.TreeParseInfo_L_k_set)
    __swig_setmethods__["R_k"] = _Library.TreeParseInfo_R_k_set
    __swig_getmethods__["R_k"] = _Library.TreeParseInfo_R_k_get
    if _newclass:R_k = _swig_property(_Library.TreeParseInfo_R_k_get, _Library.TreeParseInfo_R_k_set)
    def __init__(self): 
        """__init__(self) -> TreeParseInfo"""
        this = _Library.new_TreeParseInfo()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_TreeParseInfo
    __del__ = lambda self : None;
TreeParseInfo_swigregister = _Library.TreeParseInfo_swigregister
TreeParseInfo_swigregister(TreeParseInfo)

UNCOMPRESSED = _Library.UNCOMPRESSED
LZO = _Library.LZO
GZIP = _Library.GZIP
BZIP2 = _Library.BZIP2
LZMA = _Library.LZMA
class CCompressor(SGObject):
    """
    Compression library for compressing and decompressing buffers using
    one of the standard compression algorithms, LZO, GZIP, BZIP2 or LZMA.

    The general recommendation is to use LZO whenever lightweight
    compression is sufficient but high i/o throughputs are needed (at 1/2
    the speed of memcpy).

    If size is all that matters use LZMA (which especially when
    compressing can be very slow though).

    Note that besides lzo compression, this library is thread safe.

    C++ includes: Compressor.h 
    """
    __swig_setmethods__ = {}
    for _s in [SGObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CCompressor, name, value)
    __swig_getmethods__ = {}
    for _s in [SGObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CCompressor, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, ct) -> CCompressor

        default constructor

        Parameters:
        -----------

        ct:  compression to use: one of UNCOMPRESSED, LZO, GZIP, BZIP2 or LZMA

        """
        this = _Library.new_CCompressor(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Library.delete_CCompressor
    __del__ = lambda self : None;
    def compress(self, *args):
        """
        compress(self, uncompressed, uncompressed_size, compressed, compressed_size, 
            level = 1)
        compress(self, uncompressed, uncompressed_size, compressed, compressed_size)

        compress data

        compresses the buffer uncompressed using the selected compression
        algorithm and returns compressed data and its size

        Parameters:
        -----------

        uncompressed:  - uncompressed data to be compressed

        uncompressed_size:  - size of the uncompressed data

        compressed:  - pointer to hold compressed data (returned)

        compressed_size:  - size of compressed data (returned)

        level:  - compression level between 1 and 9 
        """
        return _Library.CCompressor_compress(self, *args)

    def decompress(self, *args):
        """
        decompress(self, compressed, compressed_size, uncompressed, uncompressed_size)

        decompress data

        Decompresses the buffer using the selected compression algorithm to
        the memory block specified in uncompressed. Note: Compressed and
        uncompressed size must be known prior to calling this function.

        Parameters:
        -----------

        compressed:  - pointer to compressed data

        compressed_size:  - size of compressed data

        uncompressed:  - pointer to buffer to hold uncompressed data

        uncompressed_size:  - size of the uncompressed data 
        """
        return _Library.CCompressor_decompress(self, *args)

CCompressor_swigregister = _Library.CCompressor_swigregister
CCompressor_swigregister(CCompressor)



